; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Sticky - Module
; Nom du fichier : Sticky - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 28-04-2008
; Mise  jour : 14-02-2015
; Code PureBasic : V5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Sticky
  
  Declare ReadPrefs(GroupName.s)
  Declare WritePrefs(GroupName.s)
  Declare Initialize(P_Button.l, P_Path.s, P_Image_0.s, P_Image_1.s, P_Status.l = 0)
  Declare ToggleStatus(P_WinID.l, OneShot.b = #False)
  Declare Reset()
  
EndDeclareModule

Module Sticky

  Structure Instance
    
    Status.l
    Button.l
    Image.q[2]
    
  EndStructure
  
  Global Instance.Instance
  
  Procedure ReadPrefs(GroupName.s)
    
    PreferenceGroup(GroupName)
    Instance\Status = ReadPreferenceLong("Status", Instance\Status)
    
    If Instance\Status <= 0
      Instance\Status = 0
    ElseIf Instance\Status >= 1
      Instance\Status = 1
    EndIf
    
  EndProcedure
  
  Procedure WritePrefs(GroupName.s)
    
    PreferenceGroup(GroupName)
    WritePreferenceLong("Status", Instance\Status)
    
  EndProcedure
  
  Procedure Initialize(P_Button.l, P_Path.s, P_Image_0.s, P_Image_1.s, P_Status.l = 0)
    
    If P_Status <= 0
      Instance\Status = 0
    ElseIf P_Status >= 1
      Instance\Status = 1
    EndIf
    
    Instance\Button = P_Button
    
    If FileSize(P_Path + P_Image_0) > 0
      Instance\Image[0] = LoadImage(#PB_Any, P_Path + P_Image_0)
    EndIf
    
    If FileSize(P_Path + P_Image_1) > 0
      Instance\Image[1] = LoadImage(#PB_Any, P_Path + P_Image_1)
    EndIf
    
  EndProcedure

  Procedure ToggleStatus(P_WinID.l, OneShot.b = #False)
    
    If OneShot = #False
      Instance\Status = Instance\Status ! 1
    EndIf

    SetGadgetAttribute(Instance\Button, #PB_Button_Image, ImageID(Instance\Image[Instance\Status]))
    StickyWindow(P_WinID, Instance\Status)

  EndProcedure
  
  Procedure Reset()
    
    Instance\Status = 0
    Instance\Button = 0
    
    For Index = 0 To 1
      If IsImage(Instance\Image[Index])
        FreeImage(Instance\Image[Index])
        Instance\Image[Index] = 0
      EndIf
    Next
    
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = --
; EnableXP
; CompileSourceDirectory