; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Field.pb
; Version du fichier : 0.9.1
; Programmation : En cours
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 03-10-2014
; Mise  jour : 02-06-2018
; Code PureBasic : V5.62
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Field
  
  Declare New(P_Target.b, P_FieldID.l, P_Description.s)
  Declare UpdateGeneral(P_ModuleName.s, P_InstanceID.s, P_InstanceStyle.b, P_SecondaryInstance.b)
  Declare GenerateParamList()
  Declare.l SearchInternalStruct(P_Name.s) 
  Declare AddInternalStruct(P_Name.s)
  Declare AddInternalStructField(P_Name.s, P_FieldDefinition.s)
  Declare.s GenerateEnumeration()
  Declare.s GenerateStructures(CallFrom.b)
  Declare.s GenerateStaticArraySizeConstants()
  Declare.s MethodsSpecial(P_Mode.b)
  
  Declare.s MethodGetSet(P_FieldID.l, P_MethodID.l, P_Mode.b)
  Declare.s MethodReset(P_Mode.b) 
  Declare.s MethodInitialize(P_Mode.b) 
  Declare.s MethodUpdate(P_Mode.b) 
  Declare.s MethodStaticArray(P_MethodID.l, P_Mode.b)
  Declare.s MethodLinkedList(P_MethodID.l, P_Mode.b)
  Declare.s MethodDynamicArray(P_MethodID.l, P_Mode.b)
  Declare.s MethodMaths(P_MethodID.l, P_Mode.b)
  Declare.s MethodPrefFile(P_MethodID.l, P_Mode.b)
  Declare.s MethodBinaryFile(P_MethodID.l, P_Mode.b)
  Declare.s MethodEncodedFile(P_MethodID.l, P_Mode.b)
  Declare.s MethodCryptedFile(P_MethodID.l, P_Mode.b)
  Declare.s MethodXMLFile(P_MethodID.l, P_Mode.b)
  Declare.s MethodJSONFile(P_MethodID.l, P_Mode.b)
  Declare.s MethodDataBase(P_MethodID.l, P_Mode.b)
  Declare.s MethodDebugging(P_MethodID.l, P_Mode.b)
  
  Declare.l CountStructure()
  Declare.l CountInstances(Flag.b = 0)
  
  Declare GadgetLinking(GadgetID, Flag)
  
  Declare FileModule_To_GUI()
  Declare To_GUI(Mode.b = 0)
  Declare From_GUI(Mode.b = 0)
  Declare AddFileModule(Flag.b)
  Declare RemoveFileModule(Flag.b)
  
  Declare.s CurrentFileModuleName(Flag.b, Input.s = "")
  
  Declare SaveProjectFileInternalStructure()
  Declare LoadProjectFileInternalStructure()
  
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  
  Declare GetSpecialMethods()
  
  Declare.b IsSquareMatrix()
  Declare.b IsMatrix()
  Declare.b IsStaticArray()
  Declare.b IsDatabaseHelperNeeded(Flag.b = -1)
  Declare.s GenerateMultipleInstanceHelper(P_Mode.b)
  
  Declare Reset(Style.b)
  
  Enumeration
    
    #METHOD_MODE_DECLARE
    #METHOD_MODE_PROCEDURE
    
    #INSTANCE_STYLE_UNIQUE
    #INSTANCE_STYLE_MULTIPLE_ID
    #INSTANCE_STYLE_MULTIPLE_INDEX
    #INSTANCE_STYLE_MULTIPLE_NAME
    #INSTANCE_STYLE_OFF_MODULE
    
    #RESET_STYLE_TERMINAL
    #RESET_STYLE_NEW_MODULE
    #RESET_STYLE_AFTER_RUN
    #RESET_STYLE_FLUSH_INTERNAL_STRUCTURE
    
  EndEnumeration
  
EndDeclareModule

Module Field
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows 
      #LineFeed = #CRLF$    
      #TwinLineFeed = #CRLF$ + #CRLF$
      
    CompilerCase #PB_OS_Linux
      #LineFeed = #LF$
      #TwinLineFeed = #LF$ + #LF$
      
    CompilerCase #PB_OS_MacOS
      #LineFeed = #CR$
      #TwinLineFeed = #CR$ + #CR$
      
  CompilerEndSelect
  
  #EmptyString = Chr(34) + Chr(34)
  
  #CAME_FROM_PRIMARY = 0
  #CAME_FROM_SECONDARY = 1
  
  Enumeration 
    
    ;#FIELD_STYLE_DATA
    ;#FIELD_STYLE_POINTER
    
    #FIELD_STYLE_ARRAY
    #FIELD_STYLE_LIST
    #FIELD_STYLE_MAP
    #FIELD_STYLE_BASIC
    #FIELD_STYLE_BASIC_ARRAY
    
  EndEnumeration 
  
  Enumeration 
    
    ;#FIELD_TYPE_DATA
    ;#FIELD_TYPE_POINTER
    
    #FIELD_TYPE_BYTE
    #FIELD_TYPE_ASCII
    #FIELD_TYPE_UNICODE
    #FIELD_TYPE_CHARACTER
    #FIELD_TYPE_INTEGER
    #FIELD_TYPE_WORD
    #FIELD_TYPE_LONG
    #FIELD_TYPE_QUAD
    #FIELD_TYPE_FLOAT
    #FIELD_TYPE_DOUBLE
    #FIELD_TYPE_STRING01
    #FIELD_TYPE_STRING02
    #FIELD_TYPE_STRUCTURE
    #FIELD_TYPE_MODULE
    
  EndEnumeration 
  
  Enumeration
    
    #INSTRUCTION_MODE_RESET
    #INSTRUCTION_MODE_UPDATE
    
    #INSTRUCTION_MODE_READ_PREF
    #INSTRUCTION_MODE_WRITE_PREF
    
    #INSTRUCTION_MODE_READ_BINARY
    #INSTRUCTION_MODE_WRITE_BINARY
    
    #INSTRUCTION_MODE_READ_ENCODED
    #INSTRUCTION_MODE_WRITE_ENCODED
    
    #INSTRUCTION_MODE_READ_CRYPTED
    #INSTRUCTION_MODE_WRITE_CRYPTED
    
    #INSTRUCTION_MODE_XML_SET_NODE
    #INSTRUCTION_MODE_XML_GET_NODE
    
    #INSTRUCTION_MODE_XML_SET_ATTRIB
    #INSTRUCTION_MODE_XML_GET_ATTRIB
    
    #INSTRUCTION_MODE_ZERO
    #INSTRUCTION_MODE_ONE
    
    #INSTRUCTION_MODE_QUICK_SORT_ASCENDING
    #INSTRUCTION_MODE_QUICK_SORT_DESCENDING
    #INSTRUCTION_MODE_LINEAR_SEARCH
    #INSTRUCTION_MODE_BINARY_SEARCH
    #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE
    
  EndEnumeration
  
  Structure FileModule
    
    Name.s
    DisplayName.s
    FileName.s
    Prefix.s
    
  EndStructure 
  
  Structure Struct
    
    Name.s
    List Fields.s()
    
  EndStructure
  
  Structure General
    
    UpdateInitParam.s
    ModuleName.s
    InstanceID.s
    SpecialMethods.b
    GenerateEnumConstants.b
    SizeConstants.b
    StaticArraySort.b
    StaticArray.b
    StaticArrayFieldName.b
    InstanceStyle.b
    IsMatrix.b
    IsSquareMatrix.b  
    MatrixSizeI.b
    MatrixSizeJ.b
    IsDatabaseHelperNeeded.b
    
    EncodedModuleGadget.l
    CryptedModuleGadget.l
    InternalStructListViewGadget.l
    InternalStructEditorGadget.l
    
    SecondaryInstance.b
    
    List EncodedModule.FileModule()
    List CryptedModule.FileModule()
    List Struct.Struct()
    
  EndStructure
  
  Structure Field
    
    Description.s
    Name.s
    Access.s
    Type.b
    Style.b
    ExtensionShort.s
    ExtensionLong.s
    ExtraInfo.s
    FixedString.s
    ArraySize.l
    ArraySizeCte.s
    ArraySizeLoop.s
    ArraySizeDeclare.s
    ArrayIndexName.s
    DynamicArrayDimensionCount.b
    DynamicArrayDimensionDeclare.s
    DynamicArrayDimensionIndexName.s[10]
    ExternModuleName.s
    ExternModuleStructure.s
    IsSubField.b
    
  EndStructure
  
  Structure Instance
    
    ID.l
    Field.Field
    List SubField.Field()
    
  EndStructure 
  
  Global General.General
  Global NewList Primary.Instance()
  Global NewList Secondary.Instance()
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Procdures prives <<<<<
  
  Procedure.l SearchInstances(P_InstanceID.l, Target.b = 0)
    
    Protected IsFoundAtIndex.l = -1
    
    If Target = 0 
      
      ForEach Primary()
        
        If Primary()\ID = P_InstanceID
          IsFoundAtIndex = ListIndex(Primary())
          Break
        EndIf
        
      Next
      
    ElseIf Target = 1
      
      ForEach Secondary()
        
        If Secondary()\ID = P_InstanceID
          IsFoundAtIndex = ListIndex(Secondary())
          Break
        EndIf
        
      Next
      
    EndIf
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure.l SearchInternalStruct(P_Name.s)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach General\Struct()
      
      If General\Struct()\Name = P_Name
        IsFoundAtIndex = ListIndex(General\Struct())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure.l SearchStructField(P_Name.s, P_FieldDefinition.s)
    
    Protected IsFoundAtIndex.l = -1
    
    If SearchInternalStruct(P_Name)
      
      ForEach General\Struct()\Fields()
        
        If General\Struct()\Fields() = P_FieldDefinition
          IsFoundAtIndex = ListIndex(General\Struct()\Fields())
          Break
        EndIf
        
      Next
    EndIf
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Oprateur ExtractBracket <<<<<
  
  Procedure.s ExtractBracket(P_Description.s, OpenBracket.s, CloseBracket.s, Flag.b = 0)
    
    If FindString(P_Description, OpenBracket, 1)
      
      BracketPart.s = StringBetween::FindIt(P_Description, OpenBracket, CloseBracket)
      
      If Flag = 0
        BracketPart = OpenBracket + BracketPart + CloseBracket
      EndIf
      
    EndIf
    
    ProcedureReturn BracketPart
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Commandes pour les tableaux Dynamiques <<<<<
  
  Procedure DynamicArrayDimensionsExtraction(*FieldA.Field, ArrayDefinition.s)
    
    DimensionPart.s = ExtractBracket(ArrayDefinition, "(", ")", 1)
    
    *FieldA\DynamicArrayDimensionDeclare = "(" + DimensionPart + ")"
    *FieldA\DynamicArrayDimensionCount = CountString(DimensionPart, ",") + 1
    
    For Index = *FieldA\DynamicArrayDimensionCount To 1 Step -1  
      *FieldA\DynamicArrayDimensionIndexName[Index-1] = *FieldA\Name + "_ID_" + Str(Index)
    Next
    
  EndProcedure
  
  Procedure.s BuiltDynamicArrayIndexList(*FieldA.Field, Mode.b)
    
    If *FieldA\DynamicArrayDimensionCount <> 0
      
      Select Mode
          
        Case 0, 1, 2
          
          For Index = 0 To *FieldA\DynamicArrayDimensionCount - 1
            ParamList.s = ParamList + ", " + *FieldA\DynamicArrayDimensionIndexName[Index]          
          Next 
          
          If Mode = 1 Or Mode = 2
            ParamList = Right(ParamList, Len(ParamList) - 2)       
          EndIf 
          
          If Mode = 2
            ParamList = "(" + ParamList + ")"
          EndIf
          
          ;     Case 2
          ;       
          ;       For Index = 0 To GetFieldDynamicArrayDimensionCount(*FieldA) - 1
          ;         ParamList = ParamList + ", 0"         
          ;       Next 
          
        Case 3
          
          For Index = 1 To *FieldA\DynamicArrayDimensionCount
            
            ParamList = ParamList + *FieldA\Name + "_Max_" + Str(Index) + "D"
            
            If Index < *FieldA\DynamicArrayDimensionCount
              ParamList + ", "
            EndIf
            
          Next
          
          ;     Case 4
          ;       
          ;       For Index = 1 To *FieldA\DynamicArrayDimensionCount
          ;         ParamList = ParamList + ", " + DynamicArraySize(*FieldA, #VARIABLE_NAME_A, Str(Index))
          ;       Next
          ;       
          ;     Case 5
          ;       
          ;       For Index = 1 To *FieldA\DynamicArrayDimensionCount
          ;         ParamList = ParamList + ", " + DynamicArraySize(*FieldA, #POINTER_NAME_A, Str(Index))
          ;       Next
          
        Case 6
          
          For Index = 1 To *FieldA\DynamicArrayDimensionCount
            
            ParamList = ParamList + " + Str(" + *FieldA\DynamicArrayDimensionIndexName[Index-1]  + ")"
            
            If Index < *FieldA\DynamicArrayDimensionCount
              ParamList = ParamList + " + " + Chr(34) + "_" + Chr(34)
            EndIf 
            
          Next 
          
      EndSelect
      
    EndIf
    
    ProcedureReturn ParamList
  EndProcedure 
  
  Procedure.s DynamicArraySize(*FieldA.Field, Dimension.s = "DimensionID", P_InstanceCameFrom.b = #CAME_FROM_PRIMARY, *ParentField.Field = #Null)
    
    If *FieldA\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    If *ParentField <> #Null
      
      Select *ParentField\Style
          
        Case #FIELD_STYLE_ARRAY
          Parent.s = *ParentField\Name + "(" + BuiltDynamicArrayIndexList(*ParentField, 1) + ")\"
          
        Case #FIELD_STYLE_LIST
          Parent.s = *ParentField\Name + "()\"
          
        Case #FIELD_STYLE_MAP
          Parent.s = *ParentField\Name + "()\"
          
        Case #FIELD_STYLE_BASIC
          Parent.s = *ParentField\Name + "\"
          
        Case #FIELD_STYLE_BASIC_ARRAY
          Parent.s = *ParentField\Name + "[" + *ParentField\ArrayIndexName + "]\"
          
      EndSelect
      
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        Output.s = "ArraySize(Instance\" + Parent + *FieldA\Name + DollarSign + "(), " + Dimension + ")"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        Output.s = "ArraySize(Instances()\" + Parent + *FieldA\Name + DollarSign + "(), " + Dimension + ")"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        Output.s = "ArraySize(*" +  General\ModuleName + "A\" + Parent + *FieldA\Name + DollarSign + "(), " + Dimension + ")"
        
    EndSelect
    
    If General\SecondaryInstance = #True And P_InstanceCameFrom = #CAME_FROM_SECONDARY
      Output.s = "ArraySize(Secondary\" + *FieldA\Name + DollarSign + "(), " + Dimension + ")"
    EndIf
    
    ProcedureReturn Output
  EndProcedure

  Procedure.s AddDynamicArrayOpeningLoop(*FieldA.Field, *Ptr_TabSize, P_InstanceCameFrom.b = #CAME_FROM_PRIMARY, *ParentField.Field = #Null)
    
    TabSize.b = PeekB(*Ptr_TabSize)
    
    Buffer.s = ""
    
    For Index = *FieldA\DynamicArrayDimensionCount To 1 Step -1 
      
      Buffer + Comments::Tabulation(TabSize) + "For " + *FieldA\DynamicArrayDimensionIndexName[Index - 1] + " = 0 To " + DynamicArraySize(*FieldA, Str(Index), P_InstanceCameFrom, *ParentField) + #LineFeed
      
      If Index > 1
        TabSize + 1
      EndIf 
      
    Next 
    
    PokeB(*Ptr_TabSize, TabSize)
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s AddDynamicArrayClosingLoop(*FieldA.Field, *Ptr_TabSize)
    
    TabSize.b = PeekB(*Ptr_TabSize)
    Buffer.s = ""
    
    For Index = *FieldA\DynamicArrayDimensionCount To 1 Step -1 
      
      Buffer + Comments::Tabulation(TabSize) + "Next"
      
      If Index > 1
        TabSize - 1
        Buffer + #LineFeed
      EndIf 
      
    Next 
    
    PokeB(*Ptr_TabSize, TabSize)
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Commandes pour les Structures Internes <<<<<
  
  Procedure AddInternalStruct(P_Name.s)
    
    If SearchInternalStruct(P_Name) = -1
      AddElement(General\Struct())
      General\Struct()\Name = P_Name
    EndIf
    
  EndProcedure
  
  Procedure AddInternalStructField(P_Name.s, P_FieldDefinition.s)
    
    If SearchStructField(P_Name, P_FieldDefinition) = -1
      AddElement(General\Struct()\Fields())
      General\Struct()\Fields() = P_FieldDefinition
    EndIf
    
  EndProcedure
  
  Procedure.s GenerateInternalStruct(TabSize.b)
    
    ForEach General\Struct()
      
      Buffer.s + Comments::Tabulation(TabSize) + "Structure " + General\Struct()\Name + #TwinLineFeed
      
      ForEach General\Struct()\Fields()
        Buffer + Comments::Tabulation(TabSize+1) + General\Struct()\Fields() + #LineFeed
      Next
      
      Buffer + #LineFeed + Comments::Tabulation(TabSize) + "EndStructure" + #TwinLineFeed
      
    Next
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s FormatFileModule(*FileModuleA.FileModule, Flag.b = 0)
    
    If Flag = 0 
      Output.s = *FileModuleA\Name + "::" + *FileModuleA\Prefix
    Else
      Output.s = *FileModuleA\Name
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Extraire l'information d'un champs (Module ou structure interne) <<<<<
  
  Procedure.s FieldFromDescription(*FieldA.Field, P_Description.s)
    
    *FieldA\Description = P_Description
    
    If FindString(*FieldA\Description, ";", 1)
      
      ExtraPart01.s = Trim(StringField(*FieldA\Description, 1, ";"))
      ExtraPart02.s = Trim(StringField(*FieldA\Description, 2, ";"))
      *FieldA\ExtraInfo = " ; " + ExtraPart02
      *FieldA\Description = ExtraPart01 + *FieldA\ExtraInfo
      
      If General\SpecialMethods = #False
        If FindString(ExtraPart02, "Special", 1)
          General\SpecialMethods = #True
        EndIf
      EndIf
      
      If General\GenerateEnumConstants = #False
        If FindString(ExtraPart02, "Enum", 1)
          General\GenerateEnumConstants = #True
        EndIf
      EndIf
      
    EndIf
    
    FirstPart.s = StringField(*FieldA\Description, 1, " ")
    SecondPart.s = StringField(*FieldA\Description, 2, " ")
    
    Select UCase(FirstPart)
        
      Case "ARRAY"
        
        *FieldA\Style = #FIELD_STYLE_ARRAY
        
        If FindString(SecondPart, "$", 1)
          *FieldA\Name = StringField(StringField(SecondPart, 1, "$"), 1, "(")
          *FieldA\ExtensionShort = "$"
          *FieldA\Access = *FieldA\Name + "$(" + BuiltDynamicArrayIndexList(*FieldA, 1) + ")"
        Else
          *FieldA\Name = StringField(StringField(SecondPart, 1, "."), 1, "(")
          *FieldA\ExtensionShort = StringField(StringField(SecondPart, 2, "."), 1, "(")
          *FieldA\Access = *FieldA\Name + "(" + BuiltDynamicArrayIndexList(*FieldA, 1) + ")"
        EndIf
        
        DynamicArrayDimensionsExtraction(*FieldA, *FieldA\Description)
        
      Case "LIST"
        
        *FieldA\Style = #FIELD_STYLE_LIST
        
        If FindString(FirstPart, "$", 1)
          *FieldA\Name = StringField(FirstPart, 1, "$")
          *FieldA\ExtensionShort = "$"
          *FieldA\Access = *FieldA\Name + "$()"
        Else
          *FieldA\Name = StringField(SecondPart, 1, ".")
          *FieldA\ExtensionShort = StringField(StringField(SecondPart, 2, "."), 1, "(")
          *FieldA\Access = *FieldA\Name + "()"
        EndIf
        
      Case "MAP"
        
        *FieldA\Style = #FIELD_STYLE_MAP
        
        If FindString(FirstPart, "$", 1)
          *FieldA\Name = StringField(FirstPart, 1, "$")
          *FieldA\ExtensionShort = "$"
          *FieldA\Access = *FieldA\Name + "$()"
        Else
          *FieldA\Name = StringField(SecondPart, 1, ".")
          *FieldA\ExtensionShort = StringField(StringField(SecondPart, 2, "."), 1, "(")
          *FieldA\Access = *FieldA\Name + "()"
        EndIf
        
      Default
        
        *FieldA\Style = #FIELD_STYLE_BASIC
        
        If FindString(FirstPart, "$", 1)
          *FieldA\Name = StringField(FirstPart, 1, "$")
          *FieldA\ExtensionShort = "$"
          *FieldA\Access = *FieldA\Name + "$"
        Else
          *FieldA\Name = StringField(FirstPart, 1, ".")
          *FieldA\ExtensionShort = StringField(FirstPart, 2, ".")
          *FieldA\Access = *FieldA\Name
        EndIf 
        
    EndSelect 
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    *FieldA\FixedString = ExtractBracket(*FieldA\Description, "{", "}")
    
    If *FieldA\FixedString <> ""
      *FieldA\ExtensionShort = StringField(*FieldA\ExtensionShort, 1, "{")
    EndIf
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    ArrayBracket.s = ExtractBracket(*FieldA\Description, "[", "]")
    
    If ArrayBracket <> ""
      
      *FieldA\Style = #FIELD_STYLE_BASIC_ARRAY
      *FieldA\ArrayIndexName = *FieldA\Name + "ID"
      *FieldA\ExtensionShort = StringField(*FieldA\ExtensionShort, 1, "[") 
      
      If FindString(ArrayBracket, "#",1)
        
        *FieldA\ArraySizeCte = UCase("#" + *FieldA\Name + "_max")
        *FieldA\ArraySizeLoop = *FieldA\ArraySizeCte + " - 1"
        
        If FindString(ArrayBracket, "=", 1)
          Size.s = Trim(StringField(StringField(ArrayBracket, 2, "="), 1, "]"))
          *FieldA\ArraySizeDeclare = *FieldA\ArraySizeCte + " = " + Size
          *FieldA\ArraySize = Val(Size)
        Else
          *FieldA\ArraySizeDeclare = *FieldA\ArraySizeCte + " = 5"
          *FieldA\ArraySize = 5
        EndIf
        
        If *FieldA\ArraySizeDeclare <> ""
          General\SizeConstants = #True
        EndIf 
        
      Else 
        
        Size.s = ExtractBracket(ArrayBracket, "[", "]", 1)
        *FieldA\ArraySizeCte = Size
        *FieldA\ArraySize = Val(Size)
        *FieldA\ArraySizeLoop = Str(*FieldA\ArraySize - 1)
        
      EndIf
      
      FieldArrayName.s = *FieldA\ExtraInfo
      
      If FieldArrayName <> ""
        FieldArrayName = " ; " + Trim(FieldArrayName)
        General\StaticArrayFieldName = #True
      EndIf
      
      IndexStruct00.s = ", " + *FieldA\ArrayIndexName
      IndexStruct01.s = "[" + *FieldA\ArrayIndexName + "]"
      
    Else
      
      IndexStruct00 = ""
      IndexStruct01 = ""
      
    EndIf
    
    If *FieldA\Style = #FIELD_STYLE_BASIC_ARRAY
      
      If General\StaticArraySort = #False
        If *FieldA\Type >= #FIELD_TYPE_BYTE And *FieldA\Type <= #FIELD_TYPE_STRING02
          General\StaticArraySort = #True
        EndIf
      EndIf
      
    EndIf 
    
    Select *FieldA\ExtensionShort
        
      Case "$"
        *FieldA\Type = #FIELD_TYPE_STRING01
        *FieldA\ExtensionLong = "$"
        
      Case "s", "S"
        *FieldA\Type = #FIELD_TYPE_STRING02
        *FieldA\ExtensionLong = ".s"
        
      Case "b", "B"
        *FieldA\Type = #FIELD_TYPE_BYTE
        *FieldA\ExtensionLong = ".b"
        
      Case "a", "A"
        *FieldA\Type = #FIELD_TYPE_ASCII
        *FieldA\ExtensionLong = ".a"
        
      Case "u", "U"
        *FieldA\Type = #FIELD_TYPE_UNICODE
        *FieldA\ExtensionLong = ".u"
        
      Case "c", "C"
        *FieldA\Type = #FIELD_TYPE_CHARACTER
        *FieldA\ExtensionLong = ".c"
        
      Case "i", "I"
        *FieldA\Type = #FIELD_TYPE_INTEGER
        *FieldA\ExtensionLong = ".i"
        
      Case "w", "W"
        *FieldA\Type = #FIELD_TYPE_WORD
        *FieldA\ExtensionLong = ".w"
        
      Case "l", "L"
        *FieldA\Type = #FIELD_TYPE_LONG
        *FieldA\ExtensionLong = ".l"
        
      Case "q", "Q"
        *FieldA\Type = #FIELD_TYPE_QUAD
        *FieldA\ExtensionLong = ".q"
        
      Case "f", "F"
        *FieldA\Type = #FIELD_TYPE_FLOAT
        *FieldA\ExtensionLong = ".f"
        
      Case "d", "D"
        *FieldA\Type = #FIELD_TYPE_DOUBLE
        *FieldA\ExtensionLong = ".d"
        
      Default 
        *FieldA\Type = #FIELD_TYPE_STRUCTURE
        *FieldA\ExtensionLong = "." + *FieldA\ExtensionShort
        
    EndSelect 
    
    If *FieldA\Type = #FIELD_TYPE_STRUCTURE
      
      If FindString(*FieldA\ExtensionShort, "::")
        *FieldA\Type = #FIELD_TYPE_MODULE
        *FieldA\ExternModuleName = StringField(*FieldA\ExtensionShort, 1, "::")
        *FieldA\ExternModuleStructure = StringField(*FieldA\ExtensionShort, 2, "::") 
      Else
        ProcedureReturn *FieldA\ExtensionShort
      EndIf
      
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Gnration de la liste de constante pour le dimensionnement des tableaux statiques <<<<<
  
  Procedure.s GenerateStaticArraySizeConstants()
    
    ForEach Primary()
      
      If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY
        If Primary()\Field\ArraySizeDeclare <> ""
          Buffer.s + Comments::Tabulation(1) + Primary()\Field\ArraySizeDeclare + #Linefeed
        EndIf
      EndIf
      
    Next
    
    ForEach Secondary()
      
      If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY
        If Secondary()\Field\ArraySizeDeclare <> ""
          Buffer + Comments::Tabulation(1) + Secondary()\Field\ArraySizeDeclare + #Linefeed
        EndIf
      EndIf
      
    Next
    
    ProcedureReturn Buffer
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Gnration des numrations <<<<<
  
  Procedure.s GenerateEnumeration() 
    
    If General\GenerateEnumConstants = #True
      
      ForEach Primary()
        
        If Primary()\Field\Style = #FIELD_STYLE_BASIC
          
          If FindString(Primary()\Field\Description, "; Enum :")
            
            Enum.s = Trim(StringField(StringField(Primary()\Field\Description, 2, ";"), 2, ":"))
            CteCount = CountString(Enum, ",") + 1
            Output.s + Comments::Tabulation(1) + "Enumeration" + #TwinLineFeed
            
            For Index = 1 To CteCount
              Output + Comments::Tabulation(2) + UCase("#" + Primary()\Field\Name + "_" + Trim(StringField(Enum, Index, ","))) + #LineFeed
            Next
            
            Output + #LineFeed
            Output + Comments::Tabulation(1) + "EndEnumeration" + #LineFeed
            
          EndIf
          
        EndIf
        
      Next
      
      ForEach Secondary()
        
        If Secondary()\Field\Style = #FIELD_STYLE_BASIC
          
          If FindString(Secondary()\Field\Description, "; Enum :")
            
            Enum.s = Trim(StringField(StringField(Secondary()\Field\Description, 2, ";"), 2, ":"))
            CteCount = CountString(Enum, ",") + 1
            
            If Output <> ""
              Output + #LineFeed
            EndIf
            
            Output.s + Comments::Tabulation(1) + "Enumeration" + #TwinLineFeed
            
            For Index = 1 To CteCount
              Output + Comments::Tabulation(2) + UCase("#" + Secondary()\Field\Name + "_" + Trim(StringField(Enum, Index, ","))) + #LineFeed
            Next
            
            Output + #LineFeed
            Output + Comments::Tabulation(1) + "EndEnumeration" + #LineFeed
            
          EndIf
          
        EndIf
        
      Next
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Gnration des mthodes spciales <<<<<
  
  Procedure.s MethodsSpecial(P_Mode.b)
    
    If General\SpecialMethods = #True
      
      ForEach Primary()
        
        Select Primary()\Field\Type
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            ExtraParam.s = ".0"
            
          Default 
            ExtraParam = ""
            
        EndSelect
        
        If Primary()\Field\Style = #FIELD_STYLE_BASIC
          
          If FindString(Primary()\Field\ExtraInfo, "; Special :")
            
            If FindString(Primary()\Field\ExtraInfo, "Increment")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output.s + Comments::Tabulation(1) + "Declare Increment" + Primary()\Field\Name + "(P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Declare Increment" + Primary()\Field\Name + "(" + General\InstanceID + ", P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
                Case #METHOD_MODE_PROCEDURE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Procedure Increment" + Primary()\Field\Name + "(P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = Instance\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID 
                      Output + Comments::Tabulation(1) + "Procedure Increment" + Primary()\Field\Name + "(P_InstanceID.l, P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> - 1" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(1) + "Procedure Increment" + Primary()\Field\Name + "(P_Index.l, P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Procedure Increment" + Primary()\Field\Name + "(P_Name.s, P_Increment" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
              EndSelect
              
            EndIf
            
            If FindString(Primary()\Field\ExtraInfo, "Decrement")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Declare Decrement" + Primary()\Field\Name + "(P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                                           
                    Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Declare Decrement" + Primary()\Field\Name + "(" + General\InstanceID + ", P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
                Case #METHOD_MODE_PROCEDURE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Procedure Decrement" + Primary()\Field\Name + "(P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = Instance\" + Primary()\Field\Name + " - P_Decrement" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID 
                      Output + Comments::Tabulation(1) + "Procedure Decrement" + Primary()\Field\Name + "(P_InstanceID.l, P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> - 1" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " - P_Decrement" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(1) + "Procedure Decrement" + Primary()\Field\Name + "(P_Index.l, P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " - P_Decrement" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Procedure Decrement" + Primary()\Field\Name + "(P_Name.s, P_Decrement" + Primary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " - P_Decrement" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
              EndSelect
              
            EndIf
            
            If FindString(Primary()\Field\ExtraInfo, "Toggle")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Declare Toggle" + Primary()\Field\Name + "()" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Declare Toggle" + Primary()\Field\Name + "(" + General\InstanceID + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect 
                  
                Case #METHOD_MODE_PROCEDURE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Procedure Toggle" + Primary()\Field\Name + "()" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = Instance\" + Primary()\Field\Name + " ! 1" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID 
                      Output + Comments::Tabulation(1) + "Procedure Toggle" + Primary()\Field\Name + "(P_InstanceID.l)" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> - 1" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " ! 1" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(1) + "Procedure Toggle" + Primary()\Field\Name + "(P_Index.l)" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " ! 1" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Procedure Toggle" + Primary()\Field\Name + "(P_Name.s)" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " ! 1" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
              EndSelect

            EndIf      
            
            If FindString(Primary()\Field\ExtraInfo, "Looping")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Declare Looping" + Primary()\Field\Name + "(P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Declare Looping" + Primary()\Field\Name + "(" + General\InstanceID + ", P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #LineFeed

                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
                Case #METHOD_MODE_PROCEDURE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Procedure Looping" + Primary()\Field\Name + "(P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = Instance\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If Instance\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instance\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(2) + "ElseIf Instance\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instance\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID
                      Output + Comments::Tabulation(1) + "Procedure Looping" + Primary()\Field\Name + "(P_InstanceID.l, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> - 1" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(1) + "Procedure Looping" + Primary()\Field\Name + "(P_Index.l, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Procedure Looping" + Primary()\Field\Name + "(P_Name.s, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed                     
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect 
                  
              EndSelect
              
            EndIf
            
            If FindString(Primary()\Field\ExtraInfo, "Scrolling")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Declare Scrolling" + Primary()\Field\Name + "(P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Declare Scrolling" + Primary()\Field\Name + "(" + General\InstanceID + ", P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #LineFeed
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect
                  
                Case #METHOD_MODE_PROCEDURE
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_UNIQUE
                      Output + Comments::Tabulation(1) + "Procedure Scrolling" + Primary()\Field\Name + "(P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = Instance\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If Instance\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instance\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(2) + "ElseIf Instance\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "Instance\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID
                      Output + Comments::Tabulation(1) + "Procedure Scrolling" + Primary()\Field\Name + "(P_InstanceID.l, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> - 1" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(1) + "Procedure Scrolling" + Primary()\Field\Name + "(P_Index.l, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(1) + "Procedure Scrolling" + Primary()\Field\Name + "(P_Name.s, P_Minimum" + Primary()\Field\ExtensionLong + ", P_Maximum" + Primary()\Field\ExtensionLong + ", P_Increment" + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "Instances()\" + Primary()\Field\Name + " = Instances()\" + Primary()\Field\Name + " + P_Increment" + #TwinLineFeed
                      Output + Comments::Tabulation(3) + "If Instances()\" + Primary()\Field\Name + " > P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Maximum" + #LineFeed
                      Output + Comments::Tabulation(3) + "ElseIf Instances()\" + Primary()\Field\Name + " < P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(4) + "Instances()\" + Primary()\Field\Name + " = P_Minimum" + #LineFeed
                      Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed     
                      
                    Case #INSTANCE_STYLE_OFF_MODULE
                      
                  EndSelect 
                  
              EndSelect
              
            EndIf
            
          EndIf
          
        EndIf
        
      Next
      
      ForEach Secondary()
        
        If Secondary()\Field\Style = #FIELD_STYLE_BASIC
          
          If FindString(Secondary()\Field\ExtraInfo, "; Special :")
            
            If FindString(Secondary()\Field\ExtraInfo, "Increment")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  Output.s + Comments::Tabulation(1) + "Declare Increment" + Secondary()\Field\Name + "(P_Increment" + Secondary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                  
                Case #METHOD_MODE_PROCEDURE
                  Output + Comments::Tabulation(1) + "Procedure Increment" + Secondary()\Field\Name + "(P_Increment" + Secondary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "Instance\" + Secondary()\Field\Name + " = Instance\" + Secondary()\Field\Name + " + P_Increment" + #TwinLineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
              EndSelect
              
            EndIf
            
            If FindString(Secondary()\Field\ExtraInfo, "Decrement")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  Output.s + Comments::Tabulation(1) + "Declare Decrement" + Secondary()\Field\Name + "(P_Decrement" + Secondary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #LineFeed
                  
                Case #METHOD_MODE_PROCEDURE
                  Output + Comments::Tabulation(1) + "Procedure Decrement" + Secondary()\Field\Name + "(P_Decrement" + Secondary()\Field\ExtensionLong + " = 1" + ExtraParam + ")" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "Instance\" + Secondary()\Field\Name + " = Instance\" + Secondary()\Field\Name + " - P_Decrement" + #TwinLineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
              EndSelect
              
            EndIf
            
            If FindString(Secondary()\Field\ExtraInfo, "Toggle")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  Output + Comments::Tabulation(1) + "Declare Toggle" + Secondary()\Field\Name + "()" + #LineFeed
                  
                Case #METHOD_MODE_PROCEDURE
                  Output + Comments::Tabulation(1) + "Procedure Toggle" + Secondary()\Field\Name + "()" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "Instance\" + Secondary()\Field\Name + " = Instance\" + Secondary()\Field\Name + " ! 1" + #TwinLineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
              EndSelect
              
            EndIf    
                  
            If FindString(Secondary()\Field\ExtraInfo, "Looping")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  Output + Comments::Tabulation(1) + "Declare Looping" + Secondary()\Field\Name + "(P_Minimum" + Secondary()\Field\ExtensionLong + ", P_Maximum" + Secondary()\Field\ExtensionLong + ", P_Increment" + Secondary()\Field\ExtensionLong + ")" + #LineFeed
                  
                Case #METHOD_MODE_PROCEDURE
                  Output + Comments::Tabulation(1) + "Procedure Looping" + Secondary()\Field\Name + "(P_Minimum" + Secondary()\Field\ExtensionLong + ", P_Maximum" + Secondary()\Field\ExtensionLong + ", P_Increment" + Secondary()\Field\ExtensionLong + ")" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "Instance\" + Secondary()\Field\Name + " = Instance\" + Secondary()\Field\Name + " + P_Increment" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "If Instance\" + Secondary()\Field\Name + " > P_Maximum" + #LineFeed
                  Output + Comments::Tabulation(3) + "Instance\" + Secondary()\Field\Name + " = P_Minimum" + #LineFeed
                  Output + Comments::Tabulation(2) + "ElseIf Instance\" + Secondary()\Field\Name + " < P_Minimum" + #LineFeed
                  Output + Comments::Tabulation(3) + "Instance\" + Secondary()\Field\Name + " = P_Maximum" + #LineFeed
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
              EndSelect
              
            EndIf
            
            If FindString(Secondary()\Field\ExtraInfo, "Scrolling")
              
              Select P_Mode
                  
                Case #METHOD_MODE_DECLARE
                  Output + Comments::Tabulation(1) + "Declare Scrolling" + Secondary()\Field\Name + "(P_Minimum" + Secondary()\Field\ExtensionLong + ", P_Maximum" + Secondary()\Field\ExtensionLong + ", P_Increment" + Secondary()\Field\ExtensionLong + ")" + #LineFeed
                  
                Case #METHOD_MODE_PROCEDURE
                  Output + Comments::Tabulation(1) + "Procedure Scrolling" + Secondary()\Field\Name + "(P_Minimum" + Secondary()\Field\ExtensionLong + ", P_Maximum" + Secondary()\Field\ExtensionLong + ", P_Increment" + Secondary()\Field\ExtensionLong + ")" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "Instance\" + Secondary()\Field\Name + " = Instance\" + Secondary()\Field\Name + " + P_Increment" + #TwinLineFeed
                  Output + Comments::Tabulation(2) + "If Instance\" + Secondary()\Field\Name + " > P_Maximum" + #LineFeed
                  Output + Comments::Tabulation(3) + "Instance\" + Secondary()\Field\Name + " = P_Maximum" + #LineFeed
                  Output + Comments::Tabulation(2) + "ElseIf Instance\" + Secondary()\Field\Name + " < P_Minimum" + #LineFeed
                  Output + Comments::Tabulation(3) + "Instance\" + Secondary()\Field\Name + " = P_Minimum" + #LineFeed
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
              EndSelect
              
            EndIf
            
          EndIf
          
        EndIf
        
      Next
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Method Get()/Set() <<<<<
  
  Procedure.s MethodGetSet(P_FieldID.l, P_MethodID.l, P_Mode.b)
    
    If SearchInstances(P_FieldID) <> -1
      
      If Primary()\Field\Type <> #FIELD_TYPE_STRUCTURE
        
        If Primary()\Field\Name = "ID" And General\InstanceStyle = #INSTANCE_STYLE_MULTIPLE_ID
          Output.s = ""
        Else
          
          Select P_Mode
              
            Case #METHOD_MODE_DECLARE
              
              Select P_MethodID
                  
                Case 0
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                          Output.s = Comments::Tabulation(1) + "Declare Get" + Primary()\Field\Name + "(Array Output." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #LineFeed
                          
                        Case #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Declare Get" + Primary()\Field\Name + "(" + General\InstanceID + ", Array Output." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #LineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Declare Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", Array Output." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_LIST
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                          Output.s = Comments::Tabulation(1) + "Declare Get" + Primary()\Field\Name + "(List Output." + Primary()\Field\ExtensionShort + "())" + #LineFeed
                          
                        Case #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Declare Get" + Primary()\Field\Name + "(" + General\InstanceID + ", List Output." + Primary()\Field\ExtensionShort + "())" + #LineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Declare Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", List Output." + Primary()\Field\ExtensionShort + "())" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_MAP
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Declare Get" + Primary()\Field\Name + "(Map Output." + Primary()\Field\ExtensionShort + "())" + #LineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Declare Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", Map Output." + Primary()\Field\ExtensionShort + "())" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Declare Get" + Primary()\Field\Name + "(*P_" + Primary()\Field\Name + "." + Primary()\Field\ExternModuleName + "::" + Primary()\Field\ExternModuleStructure  + " = #Null)" + #LineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Declare." + Primary()\Field\ExtensionShort + " Get" + Primary()\Field\Name + "()" + #LineFeed
                          EndIf
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Declare.i Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", *P_" + Primary()\Field\Name + "." + Primary()\Field\ExternModuleName + "::" + Primary()\Field\ExternModuleStructure + " = #Null)" + #LineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Declare." + Primary()\Field\ExtensionShort + " Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ")" + #LineFeed
                          EndIf
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Declare Get" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l, *P_" + Primary()\Field\Name + "." + Primary()\Field\ExternModuleName + "::" + Primary()\Field\ExternModuleStructure  + " = #Null)" + #LineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Declare." + Primary()\Field\ExtensionShort + " Get" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l)" + #LineFeed
                          EndIf
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Declare." + Primary()\Field\ExtensionShort + " Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", " + Primary()\Field\ArrayIndexName + ".l)" + #LineFeed
                          
                      EndSelect
                      
                  EndSelect
                 
                Case 1
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(Array Input." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #LineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", Array Input." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_LIST
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(List Input." + Primary()\Field\ExtensionShort + "())" + #LineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", List Input." + Primary()\Field\ExtensionShort + "())" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_MAP
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(Map Input." + Primary()\Field\ExtensionShort + "())" + #LineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", Map Input." + Primary()\Field\ExtensionShort + "())" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(*P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #LineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #LineFeed
                          EndIf
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", *P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #LineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #LineFeed
                          EndIf
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l, *P_" + Primary()\Field\Name + "." + Primary()\Field\ExternModuleName + "::" + Primary()\Field\ExternModuleStructure + ")" + #LineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l, P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #LineFeed
                          EndIf
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Declare Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", " + Primary()\Field\ArrayIndexName + ".l, P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #LineFeed
                          
                      EndSelect
                      
                  EndSelect
                  
              EndSelect
              
            Case #METHOD_MODE_PROCEDURE
              
              Select P_MethodID
                  
                Case 0
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE
                          Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(Array Output." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyArray(Instance\" + Primary()\Field\Name + "(), OutPut())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(Array Output." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyArray(Instances()\" + Primary()\Field\Name + "(), OutPut())" + #TwinLineFeed  
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", Array Output." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyArray(*" + General\ModuleName + "A\" + Primary()\Field\Name + "(), OutPut())" + #TwinLineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_LIST
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE
                          Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(List Output." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyList(Instance\" + Primary()\Field\Name + "(), OutPut())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(List Output." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyList(Instances()\" + Primary()\Field\Name + "(), OutPut())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", List Output." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyList(*" + General\ModuleName + "A\" + Primary()\Field\Name + "(), OutPut())" + #TwinLineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_MAP
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE 
                          Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(Map Output." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyMap(Instance\" + Primary()\Field\Name + "(), OutPut())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(Map Output." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyMap(Instances()\" + Primary()\Field\Name + "(), OutPut())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", Map Output." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyMap(*" + General\ModuleName + "A\" + Primary()\Field\Name + "(), OutPut())" + #TwinLineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(*P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + " = #Null)" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "If *P_" + Primary()\Field\Name + " <> #Null" + #LineFeed
                            Output + Comments::Tabulation(3) + Primary()\Field\ExternModuleName + "::Copy(Instance\" + Primary()\Field\Name + ", *P_" + Primary()\Field\Name + ")" + #LineFeed
                            Output + Comments::Tabulation(2) + "Else"  + #LineFeed          
                            Output + Comments::Tabulation(3) + "ProcedureReturn Instance\" + Primary()\Field\Name + #LineFeed
                            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Procedure." + Primary()\Field\ExtensionShort + " Get" + Primary()\Field\Name + "(" + General\InstanceID + ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "ProcedureReturn Instance\" + Primary()\Field\Name + #LineFeed
                          EndIf
                          
                        Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(*P_" + Primary()\Field\Name + "." + Primary()\Field\ExternModuleName + "::" + Primary()\Field\ExternModuleStructure  + " = #Null)" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "If *P_" + Primary()\Field\Name + " <> #Null" + #LineFeed
                            Output + Comments::Tabulation(3) + Primary()\Field\ExternModuleName + "::Copy(Instances()\" + Primary()\Field\Name + ", *P_" + Primary()\Field\Name + ")" + #LineFeed
                            Output + Comments::Tabulation(2) + "Else"  + #LineFeed          
                            Output + Comments::Tabulation(3) + "ProcedureReturn Instances()\" + Primary()\Field\Name + #LineFeed
                            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Procedure." + Primary()\Field\ExtensionShort + " Get" + Primary()\Field\Name + "()" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "ProcedureReturn Instances()\" + Primary()\Field\Name + #LineFeed
                          EndIf
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s =  Comments::Tabulation(1) + "Procedure.i Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", *P_" + Primary()\Field\Name + "." + Primary()\Field\ExternModuleName + "::" + Primary()\Field\ExternModuleStructure + " = #Null)" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "If *P_" + Primary()\Field\Name + " <> #Null" + #LineFeed
                            Output + Comments::Tabulation(3) + Primary()\Field\ExternModuleName + "::Copy(*" + General\ModuleName + "A\" + Primary()\Field\Name + ", *P_" + Primary()\Field\Name + ")" + #LineFeed
                            Output + Comments::Tabulation(2) + "Else"  + #LineFeed          
                            Output + Comments::Tabulation(3) + "ProcedureReturn *" + General\ModuleName + "A\" + Primary()\Field\Name + #LineFeed
                            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s =  Comments::Tabulation(1) + "Procedure." + Primary()\Field\ExtensionShort + " Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "ProcedureReturn *" + General\ModuleName + "A\" + Primary()\Field\Name + #LineFeed
                          EndIf
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l, *P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + " = #Null)" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "If *P_" + Primary()\Field\Name + " <> #Null" + #LineFeed
                            Output + Comments::Tabulation(3) + Primary()\Field\ExternModuleName + "::Copy(Instance\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "], *P_" + Primary()\Field\Name + ")" + #LineFeed
                            Output + Comments::Tabulation(2) + "Else"  + #LineFeed          
                            Output + Comments::Tabulation(3) + "ProcedureReturn Instance\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "]" + #LineFeed
                            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Procedure." + Primary()\Field\ExtensionShort + " Get" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l)" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "ProcedureReturn Instance\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "]" + #LineFeed
                          EndIf
                          
                        Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Procedure Get" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l, *P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + " = #Null)" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "If *P_" + Primary()\Field\Name + " <> #Null" + #LineFeed
                            Output + Comments::Tabulation(3) + Primary()\Field\ExternModuleName + "::Copy(Instances()\" + Primary()\Field\Name + "[" +Primary()\Field\ArrayIndexName + "], *P_" + Primary()\Field\Name + ")" + #LineFeed
                            Output + Comments::Tabulation(2) + "Else"  + #LineFeed   
                            Output + Comments::Tabulation(3) + "ProcedureReturn Instances()\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "]" + #LineFeed
                            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Procedure." + Primary()\Field\ExtensionShort + " Get" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l)" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "ProcedureReturn Instances()\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "]" + #LineFeed
                          EndIf                        
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Procedure." + Primary()\Field\ExtensionShort + " Get" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", " + Primary()\Field\ArrayIndexName + ".l)" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "ProcedureReturn *" + General\ModuleName + "A\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "]" + #LineFeed
                          
                      EndSelect
                      
                  EndSelect
                  
                Case 1
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE
                          Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(Array Input." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyArray(Input(), Instance\" + Primary()\Field\Name + "())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(Array Input." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyArray(Input(), Instances()\" + Primary()\Field\Name + "())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", Array Input." + Primary()\Field\ExtensionShort + "(" + Str(Primary()\Field\DynamicArrayDimensionCount) + "))" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyArray(Input(), *" + General\ModuleName + "A\" + Primary()\Field\Name + "())" + #TwinLineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_LIST
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_INDEX
                          Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(List Input." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyList(Input(), Instance\" + Primary()\Field\Name + "())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(List Input." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyList(Input(), Instances()\" + Primary()\Field\Name + "())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", List Input." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyList(Input(), *" + General\ModuleName + "A\" + Primary()\Field\Name + "())" + #TwinLineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_MAP
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE
                          Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(Map Input." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyMap(Input(), Instance\" + Primary()\Field\Name + "())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(Map Input." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyMap(Input(), Instances()\" + Primary()\Field\Name + "())" + #TwinLineFeed
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", Map Input." + Primary()\Field\ExtensionShort + "())" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "CopyMap(Input(), *" + General\ModuleName + "A\" + Primary()\Field\Name + "())" + #TwinLineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(*P_" + Primary()\Field\Name + "." + Primary()\Field\ExternModuleName + "::" + Primary()\Field\ExternModuleStructure + ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + Primary()\Field\ExternModuleName + "::Copy(*P_" + Primary()\Field\Name + ", Instance\" + Primary()\Field\Name + ")" + #TwinLineFeed
                          Else
                            Output = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort+ ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + " = P_" + Primary()\Field\Name + #TwinLineFeed
                          EndIf
                          
                        Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(*P_" + Primary()\Field\Name + "." + Primary()\Field\ExternModuleName + "::" + Primary()\Field\ExternModuleStructure + ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + Primary()\Field\ExternModuleName + "::Copy(*P_" + Primary()\Field\Name + ", Instances()\" + Primary()\Field\Name + ")" + #TwinLineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort+ ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "Instances()\" + Primary()\Field\Name + " = P_" + Primary()\Field\Name + #TwinLineFeed
                          EndIf
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", *P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort+ ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + Primary()\Field\ExternModuleName + "::Copy(*P_" + Primary()\Field\Name + ", *" + General\ModuleName + "A\" + Primary()\Field\Name + ")" + #TwinLineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort+ ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "*" + General\ModuleName + "A\" + Primary()\Field\Name + " = P_" + Primary()\Field\Name + #TwinLineFeed
                          EndIf
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Select General\InstanceStyle
                          
                        Case #INSTANCE_STYLE_UNIQUE
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l, *P_" + Primary()\Field\Name + "." + Primary()\Field\ExternModuleName + "::" + Primary()\Field\ExternModuleStructure + ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + Primary()\Field\ExternModuleName + "::Copy(*P_" + Primary()\Field\Name + ", Instance\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "])" + #TwinLineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l, P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "Instance\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "] = P_" + Primary()\Field\Name + #TwinLineFeed
                          EndIf
                          
                        Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX, #INSTANCE_STYLE_MULTIPLE_NAME
                          If Primary()\Field\Type = #FIELD_TYPE_MODULE
                            Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l, *P_" + Primary()\Field\Name + "." + Primary()\Field\ExternModuleName + "::" + Primary()\Field\ExternModuleStructure + ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + Primary()\Field\ExternModuleName + "::Copy(*P_" + Primary()\Field\Name + ", Instances()\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "])" + #TwinLineFeed
                          ElseIf Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
                            Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(" + Primary()\Field\ArrayIndexName + ".l, P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #TwinLineFeed
                            Output + Comments::Tabulation(2) + "Instances()\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "] = P_" + Primary()\Field\Name + #TwinLineFeed
                          EndIf    
                          
                        Case #INSTANCE_STYLE_OFF_MODULE
                          Output.s = Comments::Tabulation(1) + "Procedure Set" + Primary()\Field\Name + "(*" + General\ModuleName + "A." + General\ModuleName + ", " + Primary()\Field\ArrayIndexName + ".l, P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #TwinLineFeed
                          Output + Comments::Tabulation(2) + "*" + General\ModuleName + "A\" + Primary()\Field\Name + "[" + Primary()\Field\ArrayIndexName + "] = P_" + Primary()\Field\Name + #TwinLineFeed
                          
                      EndSelect
                      
                  EndSelect
                  
              EndSelect
              
              Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
              
          EndSelect
          
        EndIf
        
      EndIf 
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< MethodReset() <<<<<
  
  Procedure.s InstructionReset(*InstanceA.Instance, TabSize.b, P_InstanceCameFrom.b)
    
    If *InstanceA\Field\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    If General\SecondaryInstance = #True And P_InstanceCameFrom = #CAME_FROM_SECONDARY
      InstanceStyle.s = "Secondary\"
    EndIf
    
    Select *InstanceA\Field\Style
        
      Case #FIELD_STYLE_ARRAY
        
        Instruction.s = AddDynamicArrayOpeningLoop(*InstanceA\Field, @TabSize, P_InstanceCameFrom)
        DynamicArrayIndexList.s = BuiltDynamicArrayIndexList(*InstanceA\Field, 1)
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = 0" + #LineFeed
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = 0.0" + #LineFeed
            
          Case #FIELD_TYPE_STRING01
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$(" + DynamicArrayIndexList + ") = " + #EmptyString + #LineFeed
            
          Case #FIELD_TYPE_STRING02
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + #EmptyString + #LineFeed
            
          Case #FIELD_TYPE_MODULE
            Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
            
          Case #FIELD_TYPE_STRUCTURE
            
            ForEach *InstanceA\SubField()
              
              If *InstanceA\SubField()\Type = #FIELD_TYPE_STRING01
                DollarSign2.s = "$"
              Else
                DollarSign2 = ""
              EndIf
              
              Select *InstanceA\SubField()\Style
                  
                Case #FIELD_STYLE_ARRAY
                  
                  TabSize + 1
                  Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                  DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = 0" + #LineFeed

                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
            
                  EndSelect
                  
                  Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize) + "FreeArray(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                  TabSize - 1
                  
                Case #FIELD_STYLE_LIST
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize + 1) + "FreeList(" + InstanceStyle + *InstanceA\Field\Name +"(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                          
                Case #FIELD_STYLE_MAP
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = 0.0" + #LineFeed
                        
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize + 1) + "FreeMap(" + InstanceStyle + *InstanceA\Field\Name +"(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                     
                Case #FIELD_STYLE_BASIC
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$ = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                      
                  EndSelect
                  
                Case #FIELD_STYLE_BASIC_ARRAY
                  
                  Instruction + Comments::Tabulation(TabSize+1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #EmptyString + #LineFeed
                                            
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "Next" + #Linefeed
                  
              EndSelect
              
            Next
 
        EndSelect
        
        Instruction + AddDynamicArrayClosingLoop(*InstanceA\Field, @TabSize) + #TwinLineFeed
        Instruction + Comments::Tabulation(TabSize) + "FreeArray(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "())" ;+ #LineFeed
        
      Case #FIELD_STYLE_LIST
        
        Instruction = Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()" + #LineFeed
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = 0" + #LineFeed
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = 0.0" + #LineFeed
            
          Case #FIELD_TYPE_STRING01
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$() = " + #EmptyString + #LineFeed
            
          Case #FIELD_TYPE_STRING02
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + #EmptyString + #LineFeed
            
          Case #FIELD_TYPE_MODULE
            Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
             
          Case #FIELD_TYPE_STRUCTURE
            
            ForEach *InstanceA\SubField()
              
              Select *InstanceA\SubField()\Style
                  
                Case #FIELD_STYLE_ARRAY
                  
                  TabSize + 1
                  Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                  DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize) + "FreeArray(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                  TabSize - 1
                  
                Case #FIELD_STYLE_LIST
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize + 1) + "FreeList(" + InstanceStyle + *InstanceA\Field\Name +"()\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                          
                Case #FIELD_STYLE_MAP
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize + 1) + "FreeMap(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed

                Case #FIELD_STYLE_BASIC
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$ = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                      
                  EndSelect
                  
                Case #FIELD_STYLE_BASIC_ARRAY
                  
                  Instruction + Comments::Tabulation(TabSize+1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                  
              EndSelect
              
            Next

        EndSelect
        
        Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed
        Instruction + Comments::Tabulation(TabSize) + "FreeList(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "())"
        
      Case #FIELD_STYLE_MAP
        
        Instruction = Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()" + #LineFeed
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = 0" + #LineFeed
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = 0.0" + #LineFeed
            
          Case #FIELD_TYPE_STRING01
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$() = " + #EmptyString + #LineFeed
            
          Case #FIELD_TYPE_STRING02
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + #EmptyString + #LineFeed
            
          Case #FIELD_TYPE_MODULE
            Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
            
          Case #FIELD_TYPE_STRUCTURE
            
            ForEach *InstanceA\SubField()
              
              Select *InstanceA\SubField()\Style
                  
                Case #FIELD_STYLE_ARRAY
                  
                  TabSize + 1
                  Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                  DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + #EmptyString + #LineFeed
                      
                  EndSelect
                  
                  Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize) + "FreeArray(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                  TabSize - 1
                  
                Case #FIELD_STYLE_LIST
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + #EmptyString + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize + 1) + "FreeList(" + InstanceStyle + *InstanceA\Field\Name +"()\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                          
                Case #FIELD_STYLE_MAP
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + #EmptyString + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize + 1) + "FreeMap(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed

                Case #FIELD_STYLE_BASIC
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$ = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + #EmptyString + #LineFeed
                      
                  EndSelect
                  
                Case #FIELD_STYLE_BASIC_ARRAY
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #EmptyString + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                  
              EndSelect
              
            Next
            
        EndSelect
        
        Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed
        Instruction + Comments::Tabulation(TabSize) + "FreeMap(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "())" ;+ #LineFeed
        
      Case #FIELD_STYLE_BASIC
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Instruction = Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = 0"
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            Instruction = Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = 0.0"
            
          Case #FIELD_TYPE_STRING01
            Instruction = Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "$ = " + #EmptyString
            
          Case #FIELD_TYPE_STRING02
            Instruction = Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + #EmptyString
            
          Case #FIELD_TYPE_MODULE
            Instruction = Comments::Tabulation(TabSize) + *InstanceA\Field\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + ")" 
                
          Case #FIELD_TYPE_STRUCTURE
            
            Instruction = ""
            
            ForEach *InstanceA\SubField()
              
              Select *InstanceA\SubField()\Style
                  
                Case #FIELD_STYLE_ARRAY
                  
                  Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                  DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + #EmptyString + #LineFeed
                      
                  EndSelect
                  
                  Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize) + "FreeArray(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed

                Case #FIELD_STYLE_LIST
                  
                  Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + #EmptyString + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize) + "FreeList(" + InstanceStyle + *InstanceA\Field\Name +"\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                          
                Case #FIELD_STYLE_MAP
                  
                  Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + #EmptyString + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize) + "FreeMap(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed

                  
                Case #FIELD_STYLE_BASIC
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$ = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")"  + #LineFeed
                      
                  EndSelect
                  
                Case #FIELD_STYLE_BASIC_ARRAY
                  
                  Instruction + Comments::Tabulation(TabSize) + #LineFeed + Comments::Tabulation(TabSize) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"  + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize) + "Next" + #Linefeed
                  
              EndSelect
              
            Next

        EndSelect
        
      Case #FIELD_STYLE_BASIC_ARRAY
        
        Instruction = Comments::Tabulation(TabSize) + "For " + *InstanceA\Field\ArrayIndexName + " = 0 To " + *InstanceA\Field\ArraySizeLoop + #LineFeed
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = 0" + #LineFeed
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = 0.0" + #LineFeed
            
          Case #FIELD_TYPE_STRING01
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$[" + *InstanceA\Field\ArrayIndexName + "] = " + #EmptyString + #LineFeed
            
          Case #FIELD_TYPE_STRING02
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + #EmptyString + #LineFeed
            
          Case #FIELD_TYPE_MODULE
            Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
            
          Case #FIELD_TYPE_STRUCTURE
            
            ForEach *InstanceA\SubField()
              
              Select *InstanceA\SubField()\Style
                  
                Case #FIELD_STYLE_ARRAY
                  
                  TabSize + 1
                  Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                  DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))"  + #LineFeed
                      
                  EndSelect
                  
                  Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize) + "FreeArray(" + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                  TabSize - 1
                  
                Case #FIELD_STYLE_LIST
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())"  + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "Next" + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize+1) + "FreeList(" + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                          
                Case #FIELD_STYLE_MAP
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name  + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())"  + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                  Instruction + Comments::Tabulation(TabSize + 1) + "FreeMap(" + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + DollarSign2 + "())" + #LineFeed
                  
                Case #FIELD_STYLE_BASIC
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$ = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")"  + #LineFeed
                      
                  EndSelect
                  
                Case #FIELD_STYLE_BASIC_ARRAY
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = 0" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = 0.0" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_MODULE
                      Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"  + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                  
              EndSelect
              
            Next 

        EndSelect
        
        Instruction + Comments::Tabulation(TabSize) + "Next"
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s MethodReset(P_Mode.b) 
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        Output.s = Comments::Tabulation(1) + "Declare Reset(" + General\InstanceID + ")" + #LineFeed
        
      Case #METHOD_MODE_PROCEDURE
        Output.s = Comments::Tabulation(1) + "Procedure Reset(" + General\InstanceID + ")" + #LineFeed
        
        Select General\InstanceStyle
            
          Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
            
            ForEach Primary()
              
              Select Primary()\Field\Style
                  
                Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                  SeparatorNeeded = #True
                  
                Case #FIELD_STYLE_BASIC
                  SeparatorNeeded = #False
                  
              EndSelect
              
              If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                Output + Comments::Tabulation(2) + #LineFeed
              EndIf 
              
              Output + InstructionReset(Primary(), 2, #CAME_FROM_PRIMARY) + #LineFeed
              
              If General\SecondaryInstance = #False
                If ListIndex(Primary()) = ListSize(Primary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
              EndIf 
              
              PreviousSeparator = SeparatorNeeded
              
            Next
            
          Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
            
            Output + #LineFeed 
            Output2.s = ""
            
            ForEach Primary()
              
              Select Primary()\Field\Style
                  
                Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                  SeparatorNeeded = #True
                  
                Case #FIELD_STYLE_BASIC
                  SeparatorNeeded = #False
                  
              EndSelect
              
              If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                Output2 + Comments::Tabulation(4) + #LineFeed
              EndIf 
              
              Output2 + InstructionReset(Primary(), 4, #CAME_FROM_PRIMARY) + #LineFeed
              
              If General\SecondaryInstance = #False
                If ListIndex(Primary()) = ListSize(Primary()) - 1
                  Output2 + Comments::Tabulation(4) + #LineFeed
                EndIf
              EndIf 
              
              PreviousSeparator = SeparatorNeeded
              
            Next
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = -1" + #TwinLineFeed
                
              Case #INSTANCE_STYLE_MULTIPLE_NAME 
                Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = " + #EmptyString + #TwinLineFeed
                
            EndSelect

            Output + Comments::Tabulation(3) + "Foreach Instances()" + #LineFeed
            Output + OutPut2
            Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                Output + Comments::Tabulation(3) + "ClearList(Instances())" + #TwinLineFeed
                
              Case #INSTANCE_STYLE_MULTIPLE_NAME 
                Output + Comments::Tabulation(3) + "ClearMap(Instances())" + #TwinLineFeed
                
            EndSelect
            
            
            Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_MULTIPLE_ID
                Output + Comments::Tabulation(3) + "If SearchInstances(" + StringField(General\InstanceID, 1, ".") + ") <> -1" + #LineFeed
                
              Case #INSTANCE_STYLE_MULTIPLE_INDEX
                Output + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(General\InstanceID, 1, ".") + ")" + #LineFeed
                
              Case #INSTANCE_STYLE_MULTIPLE_NAME
                Output + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(General\InstanceID, 1, ".") + ")" + #LineFeed  
                
            EndSelect

            Output + OutPut2
            
            Select General\InstanceStyle
                
                Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                  Output + Comments::Tabulation(4) + "DeleteElement(Instances(), 1)" + #TwinLineFeed
                  
                Case #INSTANCE_STYLE_MULTIPLE_NAME
                  Output + Comments::Tabulation(4) + "DeleteMapElement(Instances(), " + StringField(General\InstanceID, 1, ".") + ")" + #TwinLineFeed
                  
              EndSelect 
              
            Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
            
            If General\SecondaryInstance = #False
              Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Else
              Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
            EndIf
            
        EndSelect
        
        If General\SecondaryInstance = #True
          
          ForEach Secondary()
            
            Select Secondary()\Field\Style
                
              Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                SeparatorNeeded = #True
                
              Case #FIELD_STYLE_BASIC
                SeparatorNeeded = #False
                
            EndSelect
            
            If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
              Output + Comments::Tabulation(2) + #LineFeed
            EndIf 
            
            Output + InstructionReset(Secondary(), 2, #CAME_FROM_SECONDARY) + #LineFeed
            
            If ListIndex(Secondary()) = ListSize(Secondary()) - 1
              Output + Comments::Tabulation(2) + #LineFeed
            EndIf
            
            PreviousSeparator = SeparatorNeeded
            
          Next
          
        EndIf
        
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s MethodInitialize(P_Mode.b) 
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        Output.s = Comments::Tabulation(1) + "Declare Initialize(" + General\InstanceID + ")" + #LineFeed
        
      Case #METHOD_MODE_PROCEDURE
        Output.s = Comments::Tabulation(1) + "Procedure Initialize(" + General\InstanceID + ")" + #LineFeed
        
        Select General\InstanceStyle
            
          Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
            
            ForEach Primary()
              
              Select Primary()\Field\Style
                  
                Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                  SeparatorNeeded = #True
                  
                Case #FIELD_STYLE_BASIC
                  SeparatorNeeded = #False
                  
              EndSelect
              
              If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                Output + Comments::Tabulation(2) + #LineFeed
              EndIf 
              
              Output + InstructionReset(Primary(), 2, #CAME_FROM_PRIMARY) + #LineFeed
              
              If General\SecondaryInstance = #False
                If ListIndex(Primary()) = ListSize(Primary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
              EndIf 
              
              PreviousSeparator = SeparatorNeeded
              
            Next
            
          Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
            
            Output + #LineFeed 
            Output2.s = ""
            
            ForEach Primary()
              
              Select Primary()\Field\Style
                  
                Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                  SeparatorNeeded = #True
                  
                Case #FIELD_STYLE_BASIC
                  SeparatorNeeded = #False
                  
              EndSelect
              
              If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                Output2 + Comments::Tabulation(4) + #LineFeed
              EndIf 
              
              Output2 + InstructionReset(Primary(), 4, #CAME_FROM_PRIMARY) + #LineFeed
              
              If General\SecondaryInstance = #False
                If ListIndex(Primary()) = ListSize(Primary()) - 1
                  Output2 + Comments::Tabulation(4) + #LineFeed
                EndIf
              EndIf 
              
              PreviousSeparator = SeparatorNeeded
              
            Next
            
            Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = -1" + #TwinLineFeed
            Output + Comments::Tabulation(3) + "Foreach Instances()" + #LineFeed
            Output + OutPut2
            Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                Output + Comments::Tabulation(3) + "ClearList(Instances())" + #TwinLineFeed
                
              Case #INSTANCE_STYLE_MULTIPLE_NAME 
                Output + Comments::Tabulation(3) + "ClearMap(Instances())" + #TwinLineFeed
                
            EndSelect
            
            
            Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_MULTIPLE_ID
                Output + Comments::Tabulation(3) + "If SearchInstances(" + StringField(General\InstanceID, 1, ".") + ") <> -1" + #LineFeed
                
              Case #INSTANCE_STYLE_MULTIPLE_INDEX
                Output + Comments::Tabulation(3) + "If SelectElement(Instances(), " + StringField(General\InstanceID, 1, ".") + ")" + #LineFeed
                
              Case #INSTANCE_STYLE_MULTIPLE_NAME
                Output + Comments::Tabulation(3) + "If FindMapElement(Instances(), " + StringField(General\InstanceID, 1, ".") + ")" + #LineFeed  
                
            EndSelect

            Output + OutPut2
            
            Select General\InstanceStyle
                
                Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                  Output + Comments::Tabulation(4) + "DeleteElement(Instances(), 1)" + #TwinLineFeed
                  
                Case #INSTANCE_STYLE_MULTIPLE_NAME
                  Output + Comments::Tabulation(4) + "DeleteMapElement(Instances(), " + StringField(General\InstanceID, 1, ".") + ")" + #TwinLineFeed
                  
              EndSelect 
              
            Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
            
            If General\SecondaryInstance = #False
              Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Else
              Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
            EndIf
            
        EndSelect
        
        If General\SecondaryInstance = #True
          
          ForEach Secondary()
            
            Select Secondary()\Field\Style
                
              Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                SeparatorNeeded = #True
                
              Case #FIELD_STYLE_BASIC
                SeparatorNeeded = #False
                
            EndSelect
            
            If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
              Output + Comments::Tabulation(2) + #LineFeed
            EndIf 
            
            Output + InstructionReset(Secondary(), 2, #CAME_FROM_SECONDARY) + #LineFeed
            
            If ListIndex(Secondary()) = ListSize(Secondary()) - 1
              Output + Comments::Tabulation(2) + #LineFeed
            EndIf
            
            PreviousSeparator = SeparatorNeeded
            
          Next
          
        EndIf
        
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Mthode Update <<<<<
  
  Procedure.s InstructionUpdate(*FieldA.Field, TabSize.b, P_InstanceCameFrom.b, P_AccessPath.s = "")
    
    If *FieldA\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf    
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        ExtraParam1.s = ""
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + General\InstanceID + " = -1"
        ExtraParam1.s = StringField(General\InstanceID, 1, ".") + ", "
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
        ExtraParam1.s = "*" + General\ModuleName + "A, "
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    Select *FieldA\Type
        
      Case #FIELD_TYPE_MODULE
        Output.s = *FieldA\ExternModuleName + "::Copy(*P_" + *FieldA\Name + DollarSign + ", "
        
      Default
        Output = "P_" + *FieldA\Name + DollarSign
        
    EndSelect
    
    Select *FieldA\Style
        
      Case #FIELD_STYLE_ARRAY
        Instruction.s = AddDynamicArrayOpeningLoop(*FieldA, @TabSize)
        
        Select *FieldA\Type
            
          Case #FIELD_TYPE_MODULE
            Instruction + Comments::Tabulation(TabSize + 1) + Output + InstanceStyle + *FieldA\Name + "(" + BuiltDynamicArrayIndexList(*FieldA, 1) + "))" + #LineFeed  
            
          Case #FIELD_TYPE_STRUCTURE
            
          Default
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *FieldA\Name + DollarSign + "(" + BuiltDynamicArrayIndexList(*FieldA, 1) + ") = " + Output + #LineFeed
            
        EndSelect
        
        Instruction + AddDynamicArrayClosingLoop(*FieldA, @TabSize)
        
      Case #FIELD_STYLE_LIST, #FIELD_STYLE_MAP
        Instruction = Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *FieldA\Name + DollarSign + "()" + #LineFeed
        
        If *FieldA\Type = #FIELD_TYPE_MODULE
          Instruction + Comments::Tabulation(TabSize + 1) + Output + InstanceStyle + *FieldA\Name + "())" + #LineFeed
        Else
          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *FieldA\Name + DollarSign + "() = " + Output + #LineFeed
        EndIf
        
        Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed
        
        If *FieldA\Style = #FIELD_STYLE_LIST
          Instruction + Comments::Tabulation(TabSize) + "ClearList(" + InstanceStyle + *FieldA\Name + DollarSign + "())"  
        ElseIf *FieldA\Style = #FIELD_STYLE_MAP
          Instruction + Comments::Tabulation(TabSize) + "ClearMap(" + InstanceStyle + *FieldA\Name + DollarSign + "())"
        EndIf
        
      Case #FIELD_STYLE_BASIC
        If *FieldA\Type = #FIELD_TYPE_MODULE
          Instruction = Comments::Tabulation(TabSize) + Output + InstanceStyle + *FieldA\Name + ")" 
        Else
          Instruction = Comments::Tabulation(TabSize) + InstanceStyle + *FieldA\Name + DollarSign + " = " + Output
        EndIf
        
      Case #FIELD_STYLE_BASIC_ARRAY
        Instruction = Comments::Tabulation(TabSize) + "For " + *FieldA\ArrayIndexName + " = 0 To " + *FieldA\ArraySizeLoop + #LineFeed
        
        If *FieldA\Type = #FIELD_TYPE_MODULE
          Instruction + Comments::Tabulation(TabSize + 1) + Output + InstanceStyle + *FieldA\Name + "[" + *FieldA\ArrayIndexName + "])" + #LineFeed
        Else              
          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *FieldA\Name + DollarSign + "[" + *FieldA\ArrayIndexName + "] = " + Output + #LineFeed
        EndIf
        
        Instruction + Comments::Tabulation(TabSize) + "Next"
        
    EndSelect  
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s MethodUpdate(P_Mode.b) 
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = General\UpdateInitParam
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = General\InstanceID + ", " + General\UpdateInitParam
        
      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = "*" + General\ModuleName + "A." + General\ModuleName + ", " + General\UpdateInitParam
        
    EndSelect
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        Output.s = Comments::Tabulation(1) + "Declare Update(" + ExtraParam + ")" + #LineFeed
        
      Case #METHOD_MODE_PROCEDURE
        Output.s = Comments::Tabulation(1) + "Procedure Update(" + ExtraParam + ")" + #TwinLineFeed 
        
        Select General\InstanceStyle
            
          Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
            
            ForEach Primary()
              If Primary()\Field\Style = #FIELD_STYLE_BASIC
                If Primary()\Field\Name <> "ID"
                  Output + InstructionUpdate(Primary()\Field, 2, #CAME_FROM_PRIMARY, "") + #LineFeed
                EndIf 
              EndIf 
            Next
            
          Case #INSTANCE_STYLE_MULTIPLE_ID
            
            Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> -1" + #LineFeed
            
            ForEach Primary()
              If Primary()\Field\Style = #FIELD_STYLE_BASIC
                If Primary()\Field\Name <> "ID"
                  Output + InstructionUpdate(Primary()\Field, 3, #CAME_FROM_PRIMARY, "") + #LineFeed
                EndIf 
              EndIf 
            Next
            
            Output + Comments::Tabulation(2) + "EndIf" + #LineFeed 
            
          Case #INSTANCE_STYLE_MULTIPLE_INDEX
            Output + Comments::Tabulation(2) + "If SelectElement(Instances(), P_Index)" + #LineFeed
            
            ForEach Primary()
              If Primary()\Field\Style = #FIELD_STYLE_BASIC
                If Primary()\Field\Name <> "ID"
                  Output + InstructionUpdate(Primary()\Field, 3, #CAME_FROM_PRIMARY, "") + #LineFeed
                EndIf 
              EndIf 
            Next
            
            Output + Comments::Tabulation(2) + "EndIf" + #LineFeed 
 
          Case #INSTANCE_STYLE_MULTIPLE_NAME
            Output + Comments::Tabulation(2) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
            
            ForEach Primary()
              If Primary()\Field\Style = #FIELD_STYLE_BASIC
                If Primary()\Field\Name <> "ID"
                  Output + InstructionUpdate(Primary()\Field, 3, #CAME_FROM_PRIMARY, "") + #LineFeed
                EndIf 
              EndIf 
            Next
            
            Output + Comments::Tabulation(2) + "EndIf" + #LineFeed 
  
        EndSelect
        
        If CountString(Right(Output, 2 * Len(#Linefeed)), #Linefeed) < 2
          Output + #LineFeed
        EndIf
        
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure  
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Basic Array Support Instruction <<<<<
  
  Procedure.s InsertQuickSort(TabSize.b, Test01.s, Test02.s, InstructionMin.s, InstructionMax.s)
    
    Buffer.s = Comments::Tabulation(TabSize) + "Repeat" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "While " + Test01 + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "MinIndex + 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "Wend" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "While " + Test02 + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "MaxIndex - 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "Wend" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "If MinIndex <= MaxIndex" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "Swap " + InstructionMin + ", " + InstructionMax + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "MinIndex + 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "MaxIndex - 1" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "EndIf" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize) + "Until MinIndex > MaxIndex" + #LineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s InsertLinearSearch(TabSize.b, ArraySizeLoop.s, Test01.s, IndexName.s = "Index")
    
    Buffer.s = Comments::Tabulation(TabSize) + ArraySizeLoop + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "If " + Test01 + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "IsFoundAtIndex = " + IndexName + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "Break" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "EndIf" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize) + "Next" + #LineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s InsertBinarySearch(TabSize.b, Instruction.s, Test01.s, Test02.s)
    
    Buffer.s = Comments::Tabulation(TabSize) + "While StartPosition <= EndPosition" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "MiddlePosition = (StartPosition + EndPosition + 1) >> 1" + #LineFeed
    
    If Instruction <> ""
      Buffer + Comments::Tabulation(TabSize + 1) + Instruction + #LineFeed
    EndIf
    
    Buffer + #LineFeed + Comments::Tabulation(TabSize + 1) + "If " + Test01 + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "EndPosition = MiddlePosition - 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "ElseIf " + Test02 + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "StartPosition = MiddlePosition + 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "Else" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "StartPosition = EndPosition + 1" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 2) + "IsFoundAtIndex = MiddlePosition" + #LineFeed
    Buffer + Comments::Tabulation(TabSize + 1) + "EndIf" + #TwinLineFeed
    Buffer + Comments::Tabulation(TabSize) + "Wend" + #LineFeed
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s InstructionStaticArray(*FieldA.Field, MethodID.l, TabSize.b, P_InstanceCameFrom.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        ExtraParam1.s = ""
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + General\InstanceID + " = -1"
        ExtraParam1.s = StringField(General\InstanceID, 1, ".") + ", "
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
        ExtraParam1.s = "*" + General\ModuleName + "A, "
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    If General\SecondaryInstance = #True And P_InstanceCameFrom = #CAME_FROM_SECONDARY
      ExtraParam.s = ""
      ExtraParam1.s = ""
      InstanceStyle.s = "Secondary\"
      
    EndIf
    
    If *FieldA\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    
    Select MethodID
        
      Case #INSTRUCTION_MODE_QUICK_SORT_ASCENDING
        
        InstructionMin.s = InstanceStyle + *FieldA\Name + DollarSign + "[MinIndex]"
        InstructionMax.s = InstanceStyle + *FieldA\Name + DollarSign + "[MaxIndex]"
        InstructionMid.s = InstanceStyle + *FieldA\Name + DollarSign + "[(FirstIndex + LastIndex) >> 1]"
        Test01.s = "UCase(" + InstructionMin + ") < UCase(SplitValue" + DollarSign + ")"
        Test02.s = "UCase(" + InstructionMax + ") > UCase(SplitValue" + DollarSign + ")"
        Test03.s = InstructionMin + " < SplitValue" + DollarSign
        Test04.s = InstructionMax + " > SplitValue" + DollarSign
        
        Instruction.s + Comments::Tabulation(TabSize) + "MinIndex = FirstIndex" + #LineFeed 
        Instruction + Comments::Tabulation(TabSize) + "MaxIndex = LastIndex" + #LineFeed
        
        Select *FieldA\Style
            
          Case #FIELD_STYLE_BASIC_ARRAY
            
            Select *FieldA\Type
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                CommandName02.s = "QuickSortAscendant" + *FieldA\Name + "(" + ExtraParam1 + "CaseSensitive, FirstIndex, MaxIndex)"
                CommandName03.s = "QuickSortAscendant" + *FieldA\Name + "(" + ExtraParam1 + "CaseSensitive, MinIndex, LastIndex)"
                
                If *FieldA\Type = #FIELD_TYPE_STRING01
                  Instruction + Comments::Tabulation(TabSize) + "SplitValue$ = " + InstructionMid + #TwinLineFeed
                ElseIf *FieldA\Type = #FIELD_TYPE_STRING02
                  Instruction + Comments::Tabulation(TabSize) + "SplitValue." + *FieldA\ExtensionShort + " = " + InstructionMid + #TwinLineFeed
                EndIf
                
                Instruction + Comments::Tabulation(TabSize) + "If CaseSensitive = #True" + #TwinLineFeed
                Instruction + InsertQuickSort(TabSize + 1, Test01, Test02, InstructionMin, InstructionMax) + #LineFeed
                Instruction + Comments::Tabulation(TabSize) + "Else" + #TwinLineFeed
                Instruction + InsertQuickSort(TabSize + 1, Test03, Test04, InstructionMin, InstructionMax) + #LineFeed
                Instruction + Comments::Tabulation(TabSize) + "EndIf" + #TwinLineFeed
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_DOUBLE
                CommandName02.s = "QuickSortAscendant" + *FieldA\Name + "(" + ExtraParam1 + "FirstIndex, MaxIndex)"
                CommandName03.s = "QuickSortAscendant" + *FieldA\Name + "(" + ExtraParam1 + "MinIndex, LastIndex)"
                Instruction + Comments::Tabulation(TabSize) + "SplitValue." + *FieldA\ExtensionShort + " = " + InstructionMid + #TwinLineFeed
                Instruction + InsertQuickSort(TabSize, Test03, Test04, InstructionMin, InstructionMax) + #LineFeed
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "If FirstIndex < MaxIndex" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + CommandName02 + #LineFeed 
            Instruction + Comments::Tabulation(TabSize) + "EndIf" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + "If MinIndex < LastIndex" + #LineFeed 
            Instruction + Comments::Tabulation(TabSize + 1) + CommandName03 + #LineFeed
            Instruction + Comments::Tabulation(TabSize) + "EndIf" + #TwinLineFeed
            
        EndSelect
        
      Case #INSTRUCTION_MODE_QUICK_SORT_DESCENDING
        
        InstructionMin.s = InstanceStyle + *FieldA\Name + DollarSign + "[MinIndex]"
        InstructionMax.s = InstanceStyle + *FieldA\Name + DollarSign + "[MaxIndex]"
        InstructionMid.s = InstanceStyle + *FieldA\Name + DollarSign + "[(FirstIndex + LastIndex) >> 1]"
        Test01.s = "UCase(" + InstructionMin + ") > UCase(SplitValue" + DollarSign + ")"
        Test02.s = "UCase(" + InstructionMax + ") < UCase(SplitValue" + DollarSign + ")"
        Test03.s = InstructionMin + " > SplitValue" + DollarSign
        Test04.s = InstructionMax + " < SplitValue" + DollarSign
        
        Instruction + Comments::Tabulation(TabSize) + "MinIndex = FirstIndex" + #LineFeed 
        Instruction + Comments::Tabulation(TabSize) + "MaxIndex = LastIndex" + #LineFeed
        
        Select *FieldA\Style
            
          Case #FIELD_STYLE_BASIC_ARRAY
            
            Select *FieldA\Type
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                CommandName02.s = "QuickSortDescendant" + *FieldA\Name + "(" + ExtraParam1 + "CaseSensitive, FirstIndex, MaxIndex)"
                CommandName03.s = "QuickSortDescendant" + *FieldA\Name + "(" + ExtraParam1 + "CaseSensitive, MinIndex, LastIndex)"
                
                
                If *FieldA\Type = #FIELD_TYPE_STRING01
                  Instruction + Comments::Tabulation(TabSize) + "SplitValue$ = " + InstructionMid + #TwinLineFeed
                ElseIf *FieldA\Type = #FIELD_TYPE_STRING02
                  Instruction + Comments::Tabulation(TabSize) + "SplitValue." + *FieldA\ExtensionShort + " = " + InstructionMid + #TwinLineFeed
                EndIf
                
                Instruction + Comments::Tabulation(TabSize) + "If CaseSensitive = #True" + #TwinLineFeed
                Instruction + InsertQuickSort(TabSize + 1, Test01, Test02, InstructionMin, InstructionMax) + #LineFeed
                Instruction + Comments::Tabulation(TabSize) + "Else" + #TwinLineFeed
                Instruction + InsertQuickSort(TabSize + 1, Test03, Test04, InstructionMin, InstructionMax) + #LineFeed
                Instruction + Comments::Tabulation(TabSize) + "EndIf" + #TwinLineFeed
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_DOUBLE
                CommandName02.s = "QuickSortDescendant" + *FieldA\Name + "(" + ExtraParam1 + "FirstIndex, MaxIndex)"
                CommandName03.s = "QuickSortDescendant" + *FieldA\Name + "(" + ExtraParam1 + "MinIndex, LastIndex)"
                Test03.s = InstructionMin + " > SplitValue"
                Test04.s = InstructionMax + " < SplitValue"
                Instruction + Comments::Tabulation(TabSize) + "SplitValue." + *FieldA\ExtensionShort + " = " + InstructionMid + #TwinLineFeed
                Instruction + InsertQuickSort(TabSize, Test03, Test04, InstructionMin, InstructionMax) + #LineFeed
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "If FirstIndex < MaxIndex" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + CommandName02 + #LineFeed 
            Instruction + Comments::Tabulation(TabSize) + "EndIf" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + "If MinIndex < LastIndex" + #LineFeed 
            Instruction + Comments::Tabulation(TabSize + 1) + CommandName03 + #LineFeed
            Instruction + Comments::Tabulation(TabSize) + "EndIf" + #TwinLineFeed
            
        EndSelect
        
      Case #INSTRUCTION_MODE_LINEAR_SEARCH
        
        InstructionA.s = InstanceStyle + *FieldA\Name + DollarSign + "[" + *FieldA\ArrayIndexName + "]"
        Test01.s = "UCase(" + InstructionA + ") = UCase(SearchValue" + DollarSign + ")"
        Test02.s = InstructionA + " = SearchValue" + DollarSign
        ArraySizeLoop.s = "For " + *FieldA\ArrayIndexName + " = 0 To " + *FieldA\ArraySizeLoop
        
        Select *FieldA\Style
            
          Case #FIELD_STYLE_BASIC_ARRAY
            
            Instruction + Comments::Tabulation(TabSize) + "IsFoundAtIndex.l = -1" + #TwinLineFeed
            
            Select *FieldA\Type
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize) + "If CaseSensitive = #True" + #TwinLineFeed
                Instruction + InsertLinearSearch(TabSize + 1, ArraySizeLoop, Test01, *FieldA\ArrayIndexName) + #LineFeed
                Instruction + Comments::Tabulation(TabSize) + "Else" + #TwinLineFeed
                Instruction + InsertLinearSearch(TabSize + 1, ArraySizeLoop, Test02, *FieldA\ArrayIndexName) + #LineFeed
                Instruction + Comments::Tabulation(TabSize) + "EndIf" + #TwinLineFeed
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_DOUBLE
                Instruction + InsertLinearSearch(TabSize, ArraySizeLoop, Test02, *FieldA\ArrayIndexName) + #LineFeed
                
            EndSelect
            
        EndSelect
        
        Instruction + Comments::Tabulation(TabSize) + "ProcedureReturn IsFoundAtIndex" + #LineFeed
        
      Case #INSTRUCTION_MODE_BINARY_SEARCH
        
        InstructionA.s = InstanceStyle + *FieldA\Name + DollarSign + "[MiddlePosition]" 
        Test01.s = "UCase(SearchValue) < UCase(" + InstructionA + ")"
        Test02.s = "Ucase(SearchValue) > UCase(" + InstructionA + ")"
        Test03.s = "SearchValue < " + InstructionA
        Test04.s = "SearchValue > " + InstructionA
        
        Select *FieldA\Style
            
          Case #FIELD_STYLE_BASIC_ARRAY
            
            Instruction + Comments::Tabulation(TabSize) + "IsFoundAtIndex.l = -1" + #LineFeed
            Instruction + Comments::Tabulation(TabSize) + "StartPosition.l = 0" + #LineFeed
            Instruction + Comments::Tabulation(TabSize) + "EndPosition.l = " + *FieldA\ArraySizeLoop + #TwinLineFeed
            
            Select *FieldA\Type
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize) + "If CaseSensitive = #False" + #TwinLineFeed
                Instruction + Comments::Tabulation(TabSize + 1) + "If EndPosition > 1" + #TwinLineFeed
                Instruction + InsertBinarySearch(TabSize + 2, "", Test01, Test02) + #LineFeed
                Instruction + Comments::Tabulation(TabSize + 1) + "EndIf" + #TwinLineFeed
                Instruction + Comments::Tabulation(TabSize) + "Else" + #TwinLineFeed
                Instruction + Comments::Tabulation(TabSize + 1) + "If EndPosition > 1" + #TwinLineFeed
                Instruction + InsertBinarySearch(TabSize + 2, "", Test03, Test04) + #LineFeed
                Instruction + Comments::Tabulation(TabSize + 1) + "EndIf" + #TwinLineFeed
                Instruction + Comments::Tabulation(TabSize) + "EndIf" + #TwinLineFeed
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize) + "If EndPosition > 1" + #TwinLineFeed
                Instruction + InsertBinarySearch(TabSize + 1, "", Test03, Test04)+ #LineFeed
                Instruction + Comments::Tabulation(TabSize) + "EndIf" + #TwinLineFeed
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "ProcedureReturn IsFoundAtIndex" + #LineFeed
            
        EndSelect 
        
      Case #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE
        
        Select *FieldA\Style
            
          Case #FIELD_STYLE_BASIC_ARRAY
            Instruction + Comments::Tabulation(TabSize) + "For " + *FieldA\ArrayIndexName +  " = " + *FieldA\ArraySizeLoop + " To 1 Step -1" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *FieldA\Name + DollarSign + "[" + *FieldA\ArrayIndexName + "] = " + InstanceStyle + *FieldA\Name + DollarSign + "[" + *FieldA\ArrayIndexName + " - 1]" + #LineFeed
            Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *FieldA\Name + DollarSign + "[0] = P_" + *FieldA\Name + #TwinLineFeed
            
        EndSelect 
    EndSelect 
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s MethodStaticArray(P_MethodID.l, P_Mode.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        ExtraParam1.s = ""
        ExtraParam2.s = ""
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + General\InstanceID + " = -1"
        ExtraParam1.s = General\InstanceID + " = -1, "
        ExtraParam2.s = General\InstanceID + ", "
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + General\InstanceID + " = " + #EmptyString
        ExtraParam1.s = General\InstanceID + " = " + #EmptyString + ", "
        ExtraParam2.s = General\InstanceID + ", "
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
        ExtraParam1.s = "*" + General\ModuleName + "A." + General\ModuleName + ", "
        ExtraParam2.s = ExtraParam1
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0
            
            ForEach Primary()
              If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Primary()\Field\Type <= #FIELD_TYPE_STRING02
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output.s + Comments::Tabulation(1) + "Declare QuickSortAscendant" + Primary()\Field\Name + "(" + ExtraParam1 +  "CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Primary()\Field\ArraySizeLoop + ")" + #LineFeed
                Else
                  Output.s + Comments::Tabulation(1) + "Declare QuickSortAscendant" + Primary()\Field\Name + "(" + ExtraParam1 +  "FirstIndex = 0, LastIndex = " + Primary()\Field\ArraySizeLoop + ")" + #LineFeed
                EndIf
              EndIf
            Next
            
            If General\SecondaryInstance = #True
              ForEach Secondary()
                If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Secondary()\Field\Type <= #FIELD_TYPE_STRING02
                  If Secondary()\Field\Type = #FIELD_TYPE_STRING01 Or Secondary()\Field\Type = #FIELD_TYPE_STRING02
                    Output.s + Comments::Tabulation(1) + "Declare QuickSortAscendant" + Secondary()\Field\Name + "(CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Secondary()\Field\ArraySizeLoop + ")" + #LineFeed
                  Else
                    Output.s + Comments::Tabulation(1) + "Declare QuickSortAscendant" + Secondary()\Field\Name + "(FirstIndex = 0, LastIndex = " + Secondary()\Field\ArraySizeLoop + ")" + #LineFeed
                  EndIf
                EndIf
              Next
            EndIf
            
          Case 1
            
            ForEach Primary()
              If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Primary()\Field\Type <= #FIELD_TYPE_STRING02
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output.s + Comments::Tabulation(1) + "Declare QuickSortDescendant" + Primary()\Field\Name + "(" + ExtraParam1 +  "CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Primary()\Field\ArraySizeLoop + ")" + #LineFeed
                Else
                  Output.s + Comments::Tabulation(1) + "Declare QuickSortDescendant" + Primary()\Field\Name + "(" + ExtraParam1 +  "FirstIndex = 0, LastIndex = " + Primary()\Field\ArraySizeLoop + ")" + #LineFeed
                EndIf
              EndIf
            Next
            
            If General\SecondaryInstance = #True
              ForEach Secondary()
                If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Secondary()\Field\Type <= #FIELD_TYPE_STRING02
                  If Secondary()\Field\Type = #FIELD_TYPE_STRING01 Or Secondary()\Field\Type = #FIELD_TYPE_STRING02
                    Output.s + Comments::Tabulation(1) + "Declare QuickSortDescendant" + Secondary()\Field\Name + "(CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Secondary()\Field\ArraySizeLoop + ")" + #LineFeed
                  Else
                    Output.s + Comments::Tabulation(1) + "Declare QuickSortDescendant" + Secondary()\Field\Name + "(FirstIndex = 0, LastIndex = " + Secondary()\Field\ArraySizeLoop + ")" + #LineFeed
                  EndIf
                EndIf
              Next
            EndIf
            
          Case 2
            
            ForEach Primary()
              If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Primary()\Field\Type <= #FIELD_TYPE_STRING02
                If Primary()\Field\Type = #FIELD_TYPE_STRING01
                  Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue$, CaseSensitive.b = #False)" + #LineFeed
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue." + Primary()\Field\ExtensionShort + ", CaseSensitive.b = #False)" + #LineFeed
                Else
                  Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue." + Primary()\Field\ExtensionShort + ")" + #LineFeed
                EndIf
              EndIf 
            Next
            
            If General\SecondaryInstance = #True
              ForEach Secondary()
                If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Secondary()\Field\Type <= #FIELD_TYPE_STRING02
                  If Secondary()\Field\Type = #FIELD_TYPE_STRING01
                    Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Secondary()\Field\Name + "(SearchValue$, CaseSensitive.b = #False)" + #LineFeed
                  ElseIf Secondary()\Field\Type = #FIELD_TYPE_STRING02
                    Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Secondary()\Field\Name + "(SearchValue." + Secondary()\Field\ExtensionShort + ", CaseSensitive.b = #False)" + #LineFeed
                  Else
                    Output.s + Comments::Tabulation(1) + "Declare.l LinearSearch" + Secondary()\Field\Name + "(SearchValue." + Secondary()\Field\ExtensionShort + ")" + #LineFeed
                  EndIf
                EndIf 
              Next
            EndIf
            
          Case 3
            
            ForEach Primary()
              If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Primary()\Field\Type <= #FIELD_TYPE_STRING02
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 
                  Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue$, CaseSensitive.b = #False)" + #LineFeed
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue." + Primary()\Field\ExtensionShort + ", CaseSensitive.b = #False)" + #LineFeed
                Else
                  Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue." + Primary()\Field\ExtensionShort + ")" + #LineFeed
                EndIf
              EndIf 
            Next
            
            If General\SecondaryInstance = #True
              ForEach Secondary()
                If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Secondary()\Field\Type <= #FIELD_TYPE_STRING02
                  If Secondary()\Field\Type = #FIELD_TYPE_STRING01 
                    Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Secondary()\Field\Name + "(SearchValue$, CaseSensitive.b = #False)" + #LineFeed
                  ElseIf Secondary()\Field\Type = #FIELD_TYPE_STRING02
                    Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Secondary()\Field\Name + "(SearchValue." + Secondary()\Field\ExtensionShort + ", CaseSensitive.b = #False)" + #LineFeed
                  Else
                    Output.s + Comments::Tabulation(1) + "Declare.l BinarySearch" + Secondary()\Field\Name + "(SearchValue." + Secondary()\Field\ExtensionShort + ")" + #LineFeed
                  EndIf
                EndIf 
              Next
            EndIf
            
          Case 4
            
            ForEach Primary()
              If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Primary()\Field\Type <= #FIELD_TYPE_STRING02
                If Primary()\Field\Type = #FIELD_TYPE_STRING01
                  Output.s + Comments::Tabulation(1) + "Declare InsertTopBottomOut" + Primary()\Field\Name + "(" + ExtraParam2 + "P_" + Primary()\Field\Name + "$)" + #LineFeed
                Else
                  Output.s + Comments::Tabulation(1) + "Declare InsertTopBottomOut" + Primary()\Field\Name + "(" + ExtraParam2 + "P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #LineFeed
                EndIf
              EndIf
            Next
            
            If General\SecondaryInstance = #True
              ForEach Secondary()
                If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Secondary()\Field\Type <= #FIELD_TYPE_STRING02
                  If Secondary()\Field\Type = #FIELD_TYPE_STRING01
                    Output.s + Comments::Tabulation(1) + "Declare InsertTopBottomOut" + Secondary()\Field\Name + "(P_" + Secondary()\Field\Name + "$)" + #LineFeed
                  Else
                    Output.s + Comments::Tabulation(1) + "Declare InsertTopBottomOut" + Secondary()\Field\Name + "(P_" + Secondary()\Field\Name + "." + Secondary()\Field\ExtensionShort + ")" + #LineFeed
                  EndIf
                EndIf
              Next
            EndIf
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Primary()\Field\Type <= #FIELD_TYPE_STRING02
                
                CommandName.s = "QuickSortAscendant" + Primary()\Field\Name
                
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output.s + Comments::Tabulation(1) + "Procedure " + CommandName + "(" + ExtraParam1 +  "CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Primary()\Field\ArraySizeLoop + ")" + #TwinLineFeed
                Else
                  Output.s + Comments::Tabulation(1) + "Procedure " + CommandName + "(" + ExtraParam1 +  "FirstIndex = 0, LastIndex = " + Primary()\Field\ArraySizeLoop + ")" + #TwinLineFeed
                EndIf
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 2, #CAME_FROM_PRIMARY)
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(2) + "If P_InstanceID = -1" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "Foreach Instances()" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If P_Index = -1" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "Foreach Instances()" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "If SelectElement(Instances(), P_Index)" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed

                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If P_Name = " + #EmptyString + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "Foreach Instances()" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "If FindMapElement(P_Name)" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed

                EndSelect
                
                Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                
              EndIf
              
            Next
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Secondary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  CommandName.s = "QuickSortAscendant" + Secondary()\Field\Name
                  
                  If Secondary()\Field\Type = #FIELD_TYPE_STRING01 Or Secondary()\Field\Type = #FIELD_TYPE_STRING02
                    Output.s + Comments::Tabulation(1) + "Procedure " + CommandName + "(CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Secondary()\Field\ArraySizeLoop + ")" + #TwinLineFeed
                  Else
                    Output.s + Comments::Tabulation(1) + "Procedure " + CommandName + "(FirstIndex = 0, LastIndex = " + Secondary()\Field\ArraySizeLoop + ")" + #TwinLineFeed
                  EndIf
                  
                  Output + InstructionStaticArray(Secondary()\Field, #INSTRUCTION_MODE_QUICK_SORT_ASCENDING, 2, #CAME_FROM_SECONDARY)
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
                EndIf
                
              Next
              
            EndIf
            
          Case 1
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Primary()\Field\Type <= #FIELD_TYPE_STRING02
                
                CommandName.s = "QuickSortDescendant" + Primary()\Field\Name
                
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output.s + Comments::Tabulation(1) + "Procedure " + CommandName + "(" + ExtraParam1 +  "CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Primary()\Field\ArraySizeLoop + ")" + #TwinLineFeed
                Else
                  Output.s + Comments::Tabulation(1) + "Procedure " + CommandName + "(" + ExtraParam1 +  "FirstIndex = 0, LastIndex = " + Primary()\Field\ArraySizeLoop + ")" + #TwinLineFeed
                EndIf
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 2, #CAME_FROM_PRIMARY)
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(2) + "If P_InstanceID = -1" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "Foreach Instances()" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If P_Index = -1" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "Foreach Instances()" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If P_Name = " + #EmptyString + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "Foreach Instances()" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 4, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                
              EndIf
              
            Next
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Secondary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  CommandName.s = "QuickSortDescendant" + Secondary()\Field\Name
                  
                  If Secondary()\Field\Type = #FIELD_TYPE_STRING01 Or Secondary()\Field\Type = #FIELD_TYPE_STRING02
                    Output.s + Comments::Tabulation(1) + "Procedure " + CommandName + "(CaseSensitive.b = #False, FirstIndex = 0, LastIndex = " + Secondary()\Field\ArraySizeLoop + ")" + #TwinLineFeed
                  Else
                    Output.s + Comments::Tabulation(1) + "Procedure " + CommandName + "(FirstIndex = 0, LastIndex = " + Secondary()\Field\ArraySizeLoop + ")" + #TwinLineFeed
                  EndIf
                  
                  Output + InstructionStaticArray(Secondary()\Field, #INSTRUCTION_MODE_QUICK_SORT_DESCENDING, 2, #CAME_FROM_SECONDARY)
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
                EndIf
                
              Next
              
            EndIf
            
            
          Case 2
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Primary()\Field\Type <= #FIELD_TYPE_STRING02
                
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 
                  Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue$, CaseSensitive.b = #False)" + #TwinLineFeed
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue." + Primary()\Field\ExtensionShort + ", CaseSensitive.b = #False)" + #TwinLineFeed
                Else
                  Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue." + Primary()\Field\ExtensionShort + ")" + #TwinLineFeed
                EndIf
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_LINEAR_SEARCH, 2, #CAME_FROM_PRIMARY)
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_LINEAR_SEARCH, 3, #CAME_FROM_PRIMARY) + #LineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "ProcedureReturn -2" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If SelectElement(P_Index)" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_LINEAR_SEARCH, 3, #CAME_FROM_PRIMARY) + #LineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "ProcedureReturn -2" + #LineFeed
                             
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If FindMapElement(P_Name)" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_LINEAR_SEARCH, 3, #CAME_FROM_PRIMARY) + #LineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "ProcedureReturn -2" + #LineFeed
  
                EndSelect
                
                Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                
              EndIf 
              
            Next
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Secondary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Secondary()\Field\Type = #FIELD_TYPE_STRING01 
                    Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Secondary()\Field\Name + "(SearchValue$, CaseSensitive.b = #False)" + #TwinLineFeed
                  ElseIf Secondary()\Field\Type = #FIELD_TYPE_STRING02
                    Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Secondary()\Field\Name + "(SearchValue." + Secondary()\Field\ExtensionShort + ", CaseSensitive.b = #False)" + #TwinLineFeed
                  Else
                    Output.s + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Secondary()\Field\Name + "(SearchValue." + Secondary()\Field\ExtensionShort + ")" + #TwinLineFeed
                  EndIf
                  
                  Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_LINEAR_SEARCH, 2, #CAME_FROM_SECONDARY)
                  
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
                EndIf
                
              Next
              
            EndIf
            
          Case 3
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Primary()\Field\Type <= #FIELD_TYPE_STRING02
                
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 
                  Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue$, CaseSensitive.b = #False)" + #TwinLineFeed
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue." + Primary()\Field\ExtensionShort + ", CaseSensitive.b = #False)" + #TwinLineFeed
                Else
                  Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "(" + ExtraParam2 + "SearchValue." + Primary()\Field\ExtensionShort + ")" + #TwinLineFeed
                EndIf
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_BINARY_SEARCH, 2, #CAME_FROM_PRIMARY)
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_BINARY_SEARCH, 3, #CAME_FROM_PRIMARY) + #LineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "ProcedureReturn -2" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If SelectElement(P_Index)" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_BINARY_SEARCH, 3, #CAME_FROM_PRIMARY) + #LineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "ProcedureReturn -2" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If FindMapElement(P_Name)" + #TwinLineFeed
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_BINARY_SEARCH, 3, #CAME_FROM_PRIMARY) + #LineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "ProcedureReturn -2" + #LineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                
              EndIf 
              
            Next
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Secondary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Secondary()\Field\Type = #FIELD_TYPE_STRING01 
                    Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Secondary()\Field\Name + "(SearchValue$, CaseSensitive.b = #False)" + #TwinLineFeed
                  ElseIf Secondary()\Field\Type = #FIELD_TYPE_STRING02
                    Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Secondary()\Field\Name + "(SearchValue." + Secondary()\Field\ExtensionShort + ", CaseSensitive.b = #False)" + #TwinLineFeed
                  Else
                    Output.s + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Secondary()\Field\Name + "(SearchValue." + Secondary()\Field\ExtensionShort + ")" + #TwinLineFeed
                  EndIf
                  
                  Output + InstructionStaticArray(Secondary()\Field, #INSTRUCTION_MODE_BINARY_SEARCH, 2, #CAME_FROM_SECONDARY)
                  
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
                EndIf
                
              Next
              
            EndIf
            
          Case 4
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Primary()\Field\Type <= #FIELD_TYPE_STRING02
                
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 
                  Output.s + Comments::Tabulation(1) + "Procedure InsertTopBottomOut" + Primary()\Field\Name + "(" + ExtraParam2 + "P_" + Primary()\Field\Name + "$)" + #TwinLineFeed
                Else
                  Output.s + Comments::Tabulation(1) + "Procedure InsertTopBottomOut" + Primary()\Field\Name + "(" + ExtraParam2 + "P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort + ")" + #TwinLineFeed
                EndIf
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                    Output + InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE, 2, #CAME_FROM_PRIMARY)
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(2) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    Output +  InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE, 3, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
 
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If SelectElement(P_InstanceID)" + #TwinLineFeed
                    Output +  InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE, 3, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If FindMapElement(P_InstanceID)" + #TwinLineFeed
                    Output +  InstructionStaticArray(Primary()\Field, #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE, 3, #CAME_FROM_PRIMARY)
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                
              EndIf
              
            Next
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY And Secondary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Secondary()\Field\Type = #FIELD_TYPE_STRING01 
                    Output.s + Comments::Tabulation(1) + "Procedure InsertTopBottomOut" + Secondary()\Field\Name + "(P_" + Secondary()\Field\Name + "$)" + #TwinLineFeed
                  Else
                    Output.s + Comments::Tabulation(1) + "Procedure InsertTopBottomOut" + Secondary()\Field\Name + "(P_" + Secondary()\Field\Name + "." + Secondary()\Field\ExtensionShort + ")" + #TwinLineFeed
                  EndIf
                  
                  Output + InstructionStaticArray(Secondary()\Field, #INSTRUCTION_MODE_FIXED_LENGTH_QUEUE, 2, #CAME_FROM_SECONDARY)
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
                EndIf
                
              Next
              
            EndIf
            
            
        EndSelect
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Linked list Support Instruction <<<<<<
  
  Procedure.s MethodLinkedList(P_MethodID.l, P_Mode.b)
    
    Output.s = ""
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0 ; Sort
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_LIST
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  Output + Comments::Tabulation(1) + "Declare Sort" + Primary()\Field\Name + "(P_Options.l)" + #LineFeed
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      Output + Comments::Tabulation(1) + "Declare Sort" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_Options.l)" + #LineFeed
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
          Case 1 ; Linear search
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_LIST
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
                  Else
                    Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #LineFeed
                  EndIf
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      
                      If Primary()\SubField()\Type = #FIELD_TYPE_STRING01 Or Primary()\SubField()\Type = #FIELD_TYPE_STRING02
                        Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
                      Else
                        Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ")" + #LineFeed
                      EndIf
                      
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
          Case 2 ; Binary search
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_LIST
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
                  Else
                    Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #LineFeed
                  EndIf
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      
                      If Primary()\SubField()\Type = #FIELD_TYPE_STRING01 Or Primary()\SubField()\Type = #FIELD_TYPE_STRING02
                        Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
                      Else
                        Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ")" + #LineFeed
                      EndIf
                      
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0 ; Sort
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_LIST
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  Output + Comments::Tabulation(1) + "Procedure Sort" + Primary()\Field\Name + "(P_Options.l)" + #TwinLineFeed
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01
                    Output + Comments::Tabulation(2) + "SortList(" + InstanceStyle + Primary()\Field\Name + "$(), P_Options)" + #TwinLineFeed
                  Else
                    Output + Comments::Tabulation(2) + "SortList(" + InstanceStyle + Primary()\Field\Name + "(), P_Options)" + #TwinLineFeed
                  EndIf
                  
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed 
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      
                      Output + Comments::Tabulation(1) + "Procedure Sort" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_Options.l)" + #TwinLineFeed
                      
                      If Primary()\Field\Type = #FIELD_TYPE_STRING01
                        StructField.s = Primary()\Field\ExtensionShort + "\" + Primary()\SubField()\Name + "$"
                      Else
                        StructField.s = Primary()\Field\ExtensionShort + "\" + Primary()\SubField()\Name
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "SortStructuredList(" + InstanceStyle + Primary()\Field\Name + "(), P_Options, OffsetOf(" + StructField + "), TypeOf(" + StructField + "))" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure"  + #TwinLineFeed
                      
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
          Case 1 ; Linear search
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_LIST
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                    Flag = 1
                  Else
                    Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                    Flag = 0
                  EndIf
                  
                  Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #TwinLineFeed
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01
                    ArraySizeLoop.s = "ForEach " + InstanceStyle + Primary()\Field\Name + "$()"
                    IndexName.s = "ListIndex(" + InstanceStyle + Primary()\Field\Name + "$())"
                    Test01.s = "UCase(" + InstanceStyle + Primary()\Field\Name + "$()) = UCase(P_" + Primary()\Field\Name + "$)"
                    Test02.s = InstanceStyle + Primary()\Field\Name + "$() = P_" + Primary()\Field\Name + "$"
                  Else
                    ArraySizeLoop.s = "ForEach " + InstanceStyle + Primary()\Field\Name + "()"
                    IndexName.s = "ListIndex(" + InstanceStyle + Primary()\Field\Name + "())"
                    Test01.s = "UCase(" + InstanceStyle + Primary()\Field\Name + "()) = UCase(P_" + Primary()\Field\Name + ")"
                    Test02.s = InstanceStyle + Primary()\Field\Name + "() = P_" + Primary()\Field\Name
                  EndIf
                  
                  If Flag = 1
                    Output + Comments::Tabulation(2) + "If P_CaseSensitive = #True" + #TwinLineFeed
                    Output + InsertLinearSearch(3, ArraySizeLoop, Test01, IndexName) + #LineFeed
                    Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                    Output + InsertLinearSearch(3, ArraySizeLoop, Test02, IndexName) + #LineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                  Else 
                    Output + InsertLinearSearch(2, ArraySizeLoop, Test02, IndexName) + #LineFeed
                  EndIf
                  
                  Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex"+ #LineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure"  + #TwinLineFeed
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      
                      If Primary()\SubField()\Type = #FIELD_TYPE_STRING01 Or Primary()\SubField()\Type = #FIELD_TYPE_STRING02
                        Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong+ ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                        Flag = 1
                      Else
                        Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong+ ")" + #TwinLineFeed
                        Flag = 0
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #TwinLineFeed
                      
                      If Primary()\Field\Type = #FIELD_TYPE_STRING01
                        ArraySizeLoop.s = "ForEach " + InstanceStyle + Primary()\Field\Name + "()"
                        IndexName.s = "ListIndex(" + InstanceStyle + Primary()\Field\Name + "())"
                        Test01.s = "UCase(" + InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name + "$) = UCase(P_" + Primary()\SubField()\Name + "$)"
                        Test02.s = InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name + "$ = P_" + Primary()\SubField()\Name + "$"
                      Else
                        ArraySizeLoop.s = "ForEach " + InstanceStyle + Primary()\Field\Name + "()"
                        IndexName.s = "ListIndex(" + InstanceStyle + Primary()\Field\Name + "())"
                        Test01.s = "UCase(" + InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name + ") = UCase(P_" + Primary()\SubField()\Name + ")"
                        Test02.s = InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name + " = P_" + Primary()\SubField()\Name
                      EndIf
                      
                      If Flag = 1
                        Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + #TwinLineFeed
                        Output + InsertLinearSearch(3, ArraySizeLoop, Test01, IndexName) + #LineFeed
                        Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                        Output + InsertLinearSearch(3, ArraySizeLoop, Test02, IndexName) + #LineFeed
                        Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Else 
                        Output + InsertLinearSearch(2, ArraySizeLoop, Test02, IndexName) + #LineFeed
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex" + #LineFeed             
                      Output + Comments::Tabulation(1) + "EndProcedure"  + #TwinLineFeed
                      
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
          Case 2 ; Binary search
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_LIST
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                    Flag = 1
                  Else
                    Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                    Flag = 0
                  EndIf
                  
                  Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #LineFeed
                  Output + Comments::Tabulation(2) + "Protected StartPosition.l = 0" + #LineFeed
                  Output + Comments::Tabulation(2) + "Protected MiddlePosition.l = 0" + #LineFeed
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01
                    Output + Comments::Tabulation(2) + "Protected EndPosition.l = ListSize(" + InstanceStyle + Primary()\Field\Name + "$())"+ #TwinLineFeed
                    Instruction02.s = "SelectElement(" + InstanceStyle + Primary()\Field\Name + "$(), MiddlePosition)"
                    Test01.s = "UCase(P_" + Primary()\Field\Name + "$) < UCase(" + InstanceStyle + Primary()\Field\Name + "$())"
                    Test02.s = "UCase(P_" + Primary()\Field\Name + "$) > UCase(" + InstanceStyle + Primary()\Field\Name + "$())"
                    Test03.s = "P_" + Primary()\Field\Name + "$ < " + InstanceStyle + Primary()\Field\Name + "$()"
                    Test04.s = "P_" + Primary()\Field\Name + "$ > " + InstanceStyle + Primary()\Field\Name + "$()"
                  Else
                    Output + Comments::Tabulation(2) + "Protected EndPosition.l = ListSize(" + InstanceStyle + Primary()\Field\Name + "())"+ #TwinLineFeed
                    Instruction02 = "SelectElement(" + InstanceStyle + Primary()\Field\Name + "(), MiddlePosition)"
                    Test01.s = "UCase(P_" + Primary()\Field\Name + ") < UCase(" + InstanceStyle + Primary()\Field\Name + "())"
                    Test02.s = "UCase(P_" + Primary()\Field\Name + ") > UCase(" + InstanceStyle + Primary()\Field\Name + "())"
                    Test03.s = "P_" + Primary()\Field\Name + " < " + InstanceStyle + Primary()\Field\Name + "()"
                    Test04.s = "P_" + Primary()\Field\Name + " > " + InstanceStyle + Primary()\Field\Name + "()"
                  EndIf
                  
                  If Flag = 1
                    Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "If EndPosition > 1" + #TwinLineFeed
                    Output + InsertBinarySearch(4, Instruction02, Test01, Test02) + #LineFeed
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "If EndPosition > 1" + #TwinLineFeed
                    Output + InsertBinarySearch(4, Instruction02, Test03, Test04) + #LineFeed
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                  Else 
                    Output + Comments::Tabulation(2) + "If EndPosition > 1" + #TwinLineFeed
                    Output + InsertBinarySearch(3, Instruction02, Test03, Test04) + #LineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                  EndIf
                  
                  Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex" + #LineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      
                      If Primary()\SubField()\Type = #FIELD_TYPE_STRING01 Or Primary()\SubField()\Type = #FIELD_TYPE_STRING02
                        Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                        Flag = 1
                      Else
                        Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ")" + #TwinLineFeed
                        Flag = 0
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #LineFeed
                      Output + Comments::Tabulation(2) + "Protected StartPosition.l = 0" + #LineFeed
                      Output + Comments::Tabulation(2) + "Protected MiddlePosition.l = 0" + #LineFeed
                      
                      If Primary()\SubField()\Type = #FIELD_TYPE_STRING01
                        Output + Comments::Tabulation(2) + "Protected EndPosition.l = ListSize(" + InstanceStyle + Primary()\Field\Name + "())"+ #TwinLineFeed
                        Instruction02.s = "SelectElement(" + InstanceStyle + Primary()\Field\Name + "(), MiddlePosition)"
                        Test01.s = "UCase(P_" + Primary()\SubField()\Name + "$) < UCase(" + InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name + "$)"
                        Test02.s = "UCase(P_" + Primary()\SubField()\Name + "$) > UCase(" + InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name + "$)"
                        Test03.s = "P_" + Primary()\SubField()\Name + "$ < " + InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name + "$"
                        Test04.s = "P_" + Primary()\SubField()\Name + "$ > " + InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name + "$"
                      Else
                        Output + Comments::Tabulation(2) + "Protected EndPosition.l = ListSize(" + InstanceStyle + Primary()\Field\Name + "())"+ #TwinLineFeed
                        Instruction02.s = "SelectElement(" + InstanceStyle + Primary()\Field\Name + "(), MiddlePosition)"
                        Test01.s = "UCase(P_" + Primary()\SubField()\Name + ") < UCase(" + InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name + ")"
                        Test02.s = "UCase(P_" + Primary()\SubField()\Name + ") > UCase(" + InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name + ")"
                        Test03.s = "P_" + Primary()\SubField()\Name + " < " + InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name
                        Test04.s = "P_" + Primary()\SubField()\Name + " > " + InstanceStyle + Primary()\Field\Name + "()\" + Primary()\SubField()\Name
                      EndIf
                      
                      If Flag = 1
                        Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + #TwinLineFeed
                        Output + Comments::Tabulation(3) + "If EndPosition > 1" + #TwinLineFeed
                        Output + InsertBinarySearch(4, Instruction02, Test01, Test02) + #LineFeed
                        Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                        Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                        Output + Comments::Tabulation(3) + "If EndPosition > 1" + #TwinLineFeed
                        Output + InsertBinarySearch(4, Instruction02, Test03, Test04) + #LineFeed
                        Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                        Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Else 
                        Output + Comments::Tabulation(2) + "If EndPosition > 1" + #TwinLineFeed
                        Output + InsertBinarySearch(3, Instruction02, Test03, Test04) + #LineFeed
                        Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex" + #LineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure"  + #TwinLineFeed
                      
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
        EndSelect
        
    EndSelect
   
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dynamic Array Support Instruction <<<<<
  
  Procedure.s MethodDynamicArray(P_MethodID.l, P_Mode.b)
    
    Output.s = ""
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0 ; Sort
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_ARRAY
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  Output + Comments::Tabulation(1) + "Declare Sort" + Primary()\Field\Name + "(P_Options.l)" + #LineFeed
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      Output + Comments::Tabulation(1) + "Declare Sort" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_Options.l)" + #LineFeed
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
          Case 1 ; Linear search
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_ARRAY
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
                  Else
                    Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #LineFeed
                  EndIf
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      
                      If Primary()\SubField()\Type = #FIELD_TYPE_STRING01 Or Primary()\SubField()\Type = #FIELD_TYPE_STRING02
                        Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
                      Else
                        Output + Comments::Tabulation(1) + "Declare.l LinearSearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ")" + #LineFeed
                      EndIf
                      
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
          Case 2 ; Binary search
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_ARRAY
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
                  Else
                    Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #LineFeed
                  EndIf
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      
                      If Primary()\SubField()\Type = #FIELD_TYPE_STRING01 Or Primary()\SubField()\Type = #FIELD_TYPE_STRING02
                        Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
                      Else
                        Output + Comments::Tabulation(1) + "Declare.l BinarySearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ")" + #LineFeed
                      EndIf
                      
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0 ; Sort
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_ARRAY
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  Output + Comments::Tabulation(1) + "Procedure Sort" + Primary()\Field\Name + "(P_Options.l)" + #TwinLineFeed
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01
                    Output + Comments::Tabulation(2) + "SortArray(" + Primary()\Field\Name + "$(), P_Options)" + #TwinLineFeed
                  Else
                    Output + Comments::Tabulation(2) + "SortArray(" + Primary()\Field\Name + "(), P_Options)" + #TwinLineFeed
                  EndIf
                  
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed 
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      
                      Output + Comments::Tabulation(1) + "Procedure Sort" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_Options.l)" + #TwinLineFeed
                      
                      If Primary()\Field\Type = #FIELD_TYPE_STRING01
                        StructField.s = Primary()\Field\ExtensionShort + "\" + Primary()\SubField()\Name + "$"
                      Else
                        StructField.s = Primary()\Field\ExtensionShort + "\" + Primary()\SubField()\Name
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "SortStructuredArray(" + Primary()\Field\Name + "(), P_Options, OffsetOf(" + StructField + "), TypeOf(" + StructField + "))" + #TwinLineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure"  + #TwinLineFeed
                      
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
          Case 1 ; Linear search
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_ARRAY
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                    Flag = 1
                  Else
                    Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                    Flag = 0
                  EndIf
                  
                  Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #TwinLineFeed
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01
                    ArraySizeLoop.s = "For Index = 0 To ArraySize(" + Primary()\Field\Name + "$(), 1)"
                    IndexName.s = "Index"
                    Test01.s = "UCase(" + Primary()\Field\Name + "$(Index)) = UCase(P_" + Primary()\Field\Name + "$)"
                    Test02.s = Primary()\Field\Name + "$(Index) = P_" + Primary()\Field\Name + "$"
                  Else
                    ArraySizeLoop.s = "For Index = 0 To ArraySize(" + Primary()\Field\Name + "(), 1)"
                    IndexName.s = "Index"
                    Test01.s = "UCase(" + Primary()\Field\Name + "(Index)) = UCase(P_" + Primary()\Field\Name + ")"
                    Test02.s = Primary()\Field\Name + "(Index) = P_" + Primary()\Field\Name
                  EndIf
                  
                  If Flag = 1
                    Output + Comments::Tabulation(2) + "If P_CaseSensitive = #True" + #TwinLineFeed
                    Output + InsertLinearSearch(3, ArraySizeLoop, Test01, IndexName) + #LineFeed
                    Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                    Output + InsertLinearSearch(3, ArraySizeLoop, Test02, IndexName) + #LineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                  Else 
                    Output + InsertLinearSearch(2, ArraySizeLoop, Test02, IndexName) + #LineFeed
                  EndIf
                  
                  Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex"+ #LineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure"  + #TwinLineFeed
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      
                      If Primary()\SubField()\Type = #FIELD_TYPE_STRING01 Or Primary()\SubField()\Type = #FIELD_TYPE_STRING02
                        Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong+ ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                        Flag = 1
                      Else
                        Output + Comments::Tabulation(1) + "Procedure.l LinearSearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong+ ")" + #TwinLineFeed
                        Flag = 0
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #TwinLineFeed
                      
                      If Primary()\Field\Type = #FIELD_TYPE_STRING01
                        ArraySizeLoop.s = "For Index = 0 To ArraySize(" + Primary()\Field\Name + "(), 1)"
                        IndexName.s = "Index"
                        Test01.s = "UCase(" + Primary()\Field\Name + "(Index)\" + Primary()\SubField()\Name + "$) = UCase(P_" + Primary()\SubField()\Name + "$)"
                        Test02.s = Primary()\Field\Name + "(Index)\" + Primary()\SubField()\Name + "$ = P_" + Primary()\SubField()\Name + "$"
                      Else
                        ArraySizeLoop.s = "For Index = 0 To ArraySize(" + Primary()\Field\Name + "(), 1)"
                        IndexName.s = "Index"
                        Test01.s = "UCase(" + Primary()\Field\Name + "(Index)\" + Primary()\SubField()\Name + ") = UCase(P_" + Primary()\SubField()\Name + ")"
                        Test02.s = Primary()\Field\Name + "(Index)\" + Primary()\SubField()\Name + " = P_" + Primary()\SubField()\Name
                      EndIf
                      
                      If Flag = 1
                        Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + #TwinLineFeed
                        Output + InsertLinearSearch(3, ArraySizeLoop, Test01, IndexName) + #LineFeed
                        Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                        Output + InsertLinearSearch(3, ArraySizeLoop, Test02, IndexName) + #LineFeed
                        Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Else 
                        Output + InsertLinearSearch(2, ArraySizeLoop, Test02, IndexName) + #LineFeed
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex" + #LineFeed             
                      Output + Comments::Tabulation(1) + "EndProcedure"  + #TwinLineFeed
                      
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next
            
          Case 2 ; Binary search
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_ARRAY
                
                If Primary()\Field\Type <= #FIELD_TYPE_STRING02
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                    Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                    Flag = 1
                  Else
                    Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed
                    Flag = 0
                  EndIf
                  
                  Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #LineFeed
                  Output + Comments::Tabulation(2) + "Protected StartPosition.l = 0" + #LineFeed
                  Output + Comments::Tabulation(2) + "Protected MiddlePosition.l = 0" + #LineFeed
                  
                  If Primary()\Field\Type = #FIELD_TYPE_STRING01
                    Output + Comments::Tabulation(2) + "Protected EndPosition.l = ArraySize(" + Primary()\Field\Name + "$(), 1)"+ #TwinLineFeed
                    Test01.s = "UCase(P_" + Primary()\Field\Name + "$) < UCase(" + Primary()\Field\Name + "$(MiddlePosition))"
                    Test02.s = "UCase(P_" + Primary()\Field\Name + "$) > UCase(" + Primary()\Field\Name + "$(MiddlePosition))"
                    Test03.s = "P_" + Primary()\Field\Name + "$ < " + Primary()\Field\Name + "$(MiddlePosition)"
                    Test04.s = "P_" + Primary()\Field\Name + "$ > " + Primary()\Field\Name + "$(MiddlePosition)"
                  Else
                    Output + Comments::Tabulation(2) + "Protected EndPosition.l = ArraySize(" + Primary()\Field\Name + "(), 1)"+ #TwinLineFeed
                    Test01.s = "UCase(P_" + Primary()\Field\Name + ") < UCase(" + Primary()\Field\Name + "(MiddlePosition))"
                    Test02.s = "UCase(P_" + Primary()\Field\Name + ") > UCase(" + Primary()\Field\Name + "(MiddlePosition))"
                    Test03.s = "P_" + Primary()\Field\Name + " < " + Primary()\Field\Name + "(MiddlePosition)"
                    Test04.s = "P_" + Primary()\Field\Name + " > " + Primary()\Field\Name + "(MiddlePosition)"
                  EndIf
                  
                  If Flag = 1
                    Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "If EndPosition > 1" + #TwinLineFeed
                    Output + InsertBinarySearch(4, "", Test01, Test02) + #LineFeed
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "If EndPosition > 1" + #TwinLineFeed
                    Output + InsertBinarySearch(4, "", Test03, Test04) + #LineFeed
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                  Else 
                    Output + Comments::Tabulation(2) + "If EndPosition > 1" + #TwinLineFeed
                    Output + InsertBinarySearch(3, "", Test03, Test04) + #LineFeed
                    Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                  EndIf
                  
                  Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex" + #LineFeed
                  Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
                ElseIf Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  
                  ForEach Primary()\SubField()
                    
                    If Primary()\SubField()\Type <= #FIELD_TYPE_STRING02
                      
                      If Primary()\SubField()\Type = #FIELD_TYPE_STRING01 Or Primary()\SubField()\Type = #FIELD_TYPE_STRING02
                        Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                        Flag = 1
                      Else
                        Output + Comments::Tabulation(1) + "Procedure.l BinarySearch" + Primary()\Field\Name + "By" + Primary()\SubField()\Name + "(P_" + Primary()\SubField()\Name + Primary()\SubField()\ExtensionLong + ")" + #TwinLineFeed
                        Flag = 0
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #LineFeed
                      Output + Comments::Tabulation(2) + "Protected StartPosition.l = 0" + #LineFeed
                      Output + Comments::Tabulation(2) + "Protected MiddlePosition.l = 0" + #LineFeed
                      
                      If Primary()\Field\Type = #FIELD_TYPE_STRING01
                        Output + Comments::Tabulation(2) + "Protected EndPosition.l = ArraySize(" + Primary()\Field\Name + "(), 1)"+ #TwinLineFeed
                        Test01.s = "UCase(P_" + Primary()\SubField()\Name + "$) < UCase(" + Primary()\Field\Name + "(MiddlePosition)\" + Primary()\SubField()\Name + "$)"
                        Test02.s = "UCase(P_" + Primary()\SubField()\Name + "$) > UCase(" + Primary()\Field\Name + "(MiddlePosition)\" + Primary()\SubField()\Name + "$)"
                        Test03.s = "P_" + Primary()\SubField()\Name + "$ < " + Primary()\Field\Name + "(MiddlePosition)\" + Primary()\SubField()\Name + "$"
                        Test04.s = "P_" + Primary()\SubField()\Name + "$ > " + Primary()\Field\Name + "(MiddlePosition)\" + Primary()\SubField()\Name + "$"
                      Else
                        Output + Comments::Tabulation(2) + "Protected EndPosition.l = ListSize(" + Primary()\Field\Name + "())"+ #TwinLineFeed
                        Test01.s = "UCase(P_" + Primary()\SubField()\Name + ") < UCase(" + Primary()\Field\Name + "(MiddlePosition)\" + Primary()\SubField()\Name + ")"
                        Test02.s = "UCase(P_" + Primary()\SubField()\Name + ") > UCase(" + Primary()\Field\Name + "(MiddlePosition)\" + Primary()\SubField()\Name + ")"
                        Test03.s = "P_" + Primary()\SubField()\Name + " < " + Primary()\Field\Name + "(MiddlePosition)\" + Primary()\SubField()\Name
                        Test04.s = "P_" + Primary()\SubField()\Name + " > " + Primary()\Field\Name + "(MiddlePosition)\" + Primary()\SubField()\Name
                      EndIf
                      
                      If Flag = 1
                        Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + #TwinLineFeed
                        Output + Comments::Tabulation(3) + "If EndPosition > 1" + #TwinLineFeed
                        Output + InsertBinarySearch(4, "", Test01, Test02) + #LineFeed
                        Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                        Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                        Output + Comments::Tabulation(3) + "If EndPosition > 1" + #TwinLineFeed
                        Output + InsertBinarySearch(4, "", Test03, Test04) + #LineFeed
                        Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                        Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      Else 
                        Output + Comments::Tabulation(2) + "If EndPosition > 1" + #TwinLineFeed
                        Output + InsertBinarySearch(3, "", Test03, Test04) + #LineFeed
                        Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                      EndIf
                      
                      Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex" + #LineFeed
                      Output + Comments::Tabulation(1) + "EndProcedure"  + #TwinLineFeed
                      
                    EndIf
                    
                  Next
                  
                EndIf
                
              EndIf
              
            Next

        EndSelect
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Maths Support Instruction <<<<<
  
  Procedure.s MethodMaths(P_MethodID.l, P_Mode.b)
    
    If General\InstanceStyle = #INSTANCE_STYLE_OFF_MODULE
      
      VarNameR.s = "*" + General\ModuleName + "R"
      VarNameA.s = "*" + General\ModuleName + "A"
      VarNameB.s = "*" + General\ModuleName + "B"
      
      FullNameR.s = VarNameR + "." + General\ModuleName
      FullNameA.s = VarNameA + "." + General\ModuleName
      FullNameB.s = VarNameB + "." + General\ModuleName
      
      FirstElement(Primary())
      
      Select Primary()\Field\Type
          
        Case #FIELD_TYPE_LONG
          Instruct00.s = "0"
          Instruct01.s = "1"
          ReturnType.s = ".l"
          ConvertStr.s = "Str("
          ConvertDeci.s = ")"
          ConvertDeciPar.s = ""
          UnconvertStr.s = "Val("
          
        Case #FIELD_TYPE_QUAD
          Instruct00.s = "0"
          Instruct01.s = "1"
          ReturnType.s = ".q"
          ConvertStr.s = "Str("
          ConvertDeci.s = ")"
          ConvertDeciPar.s = ""
          UnconvertStr.s = "Val("
          
        Case #FIELD_TYPE_FLOAT
          Instruct00.s = "0.0"
          Instruct01.s = "1.0" 
          ReturnType.s = ".f"
          ConvertStr.s = "StrF("
          ConvertDeci.s = ", Decimal)"
          ConvertDeciPar.s = ", Decimal = 3"
          UnconvertStr.s = "ValF("
          
        Case #FIELD_TYPE_DOUBLE
          Instruct00.s = "0.0"
          Instruct01.s = "1.0" 
          ReturnType.s = ".d"
          ConvertStr.s = "StrD("
          ConvertDeci.s = ", Decimal)"
          ConvertDeciPar.s = ", Decimal = 6"
          UnconvertStr.s = "ValD("
          
      EndSelect
      
      Select P_Mode
          
        Case #METHOD_MODE_DECLARE
          
          Select P_MethodID
              
            Case 0
              Output.s = Comments::Tabulation(1) + "Declare Equal(" + FullNameA + ", " + FullNameB + ")" + #LineFeed
              
            Case 1
              Output.s = Comments::Tabulation(1) + "Declare Plus(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + #LineFeed
              
            Case 2
              Output.s = Comments::Tabulation(1) + "Declare Minus(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + #LineFeed
              
            Case 3
              Output.s = Comments::Tabulation(1) + "Declare Product(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + #LineFeed
              
            Case 4
              Output.s = Comments::Tabulation(1) + "Declare Divide(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + #LineFeed
              
            Case 5
              Output.s = Comments::Tabulation(1) + "Declare Zero(" + FullNameA + ")" + #LineFeed
              
            Case 6
              Output.s = Comments::Tabulation(1) + "Declare One(" + FullNameA + ")" + #LineFeed
              
            Case 7
              Output.s = Comments::Tabulation(1) + "Declare ProductByScalar(" + FullNameR + ", " + FullNameA + ", P_Scalar." + Primary()\Field\ExtensionShort + ")" + #LineFeed
              
            Case 8
              Output.s = Comments::Tabulation(1) + "Declare DivideByScalar(" + FullNameR + ", " + FullNameA + ", P_Scalar." + Primary()\Field\ExtensionShort + ")" + #LineFeed
              
            Case 9
              Output.s = Comments::Tabulation(1) + "Declare Copy(" + FullNameA + ", " + FullNameB + ")" + #LineFeed
              
            Case 10
              Output.s = Comments::Tabulation(1) + "Declare Compare(" + FullNameA + ", " + FullNameB + ")" + #LineFeed
              
            Case 11
              Output.s = Comments::Tabulation(1) + "Declare Swapping(" + FullNameA + ", " + FullNameB + ")" + #LineFeed
              
            Case 12
              If General\IsSquareMatrix = #True
                Output.s = Comments::Tabulation(1) + "Declare Identity(" + FullNameA + ")" + #LineFeed
              EndIf
              
            Case 13
              If General\IsSquareMatrix = #True
                Output.s = Comments::Tabulation(1) + "Declare Transpose(" + FullNameR + ", " + FullNameA + ")" + #LineFeed
              EndIf
              
            Case 14
              If General\IsSquareMatrix = #True
                Output.s = Comments::Tabulation(1) + "Declare SelfTranspose(" + FullNameA + ")" + #LineFeed
              EndIf
              
            Case 15
              If General\IsMatrix = #True
                Output.s = Comments::Tabulation(1) + "Declare Randomize(" + FullNameA + ", Min" + ReturnType + ", Max" + ReturnType + ", Resolution = 10000)" + #LineFeed
              EndIf
              
            Case 16
              If General\IsSquareMatrix = #True
                Output.s = Comments::Tabulation(1) + "Declare" + ReturnType + " Determinant(" + FullNameA + ")" + #LineFeed
              EndIf
              
            Case 17
              If General\IsSquareMatrix = #True
                Output.s = Comments::Tabulation(1) + "Declare.b Inverse(*Inverse." + General\ModuleName + ", " + FullNameA + ")" + #LineFeed
              EndIf
              
            Case 18
              If General\IsMatrix = #True
                For i = 1 To General\MatrixSizeI
                  Output.s + Comments::Tabulation(1) + "Declare.s FormatLine" + Str(i) + "("  + FullNameA + ConvertDeciPar + ")" + #LineFeed
                Next
              EndIf
              
            Case 19
              If General\IsMatrix = #True
                For i = 1 To General\MatrixSizeI
                  Output.s + Comments::Tabulation(1) + "Declare UnformatLine" + Str(i) + "("  + FullNameA + ", P_MatrixLine.s)" + #LineFeed
                Next
              EndIf
              
          EndSelect
          
        Case #METHOD_MODE_PROCEDURE
          
          Select P_MethodID
              
            Case 0
              Output.s = Comments::Tabulation(1) + "Procedure Equal(" + FullNameA + ", " + FullNameB + ")" + #TwinLineFeed
              
              ForEach Primary()
                OutPut + Comments::Tabulation(2) + VarNameA + "\" + Primary()\Field\Name + " = " + VarNameB + "\" + Primary()\Field\Name + #LineFeed
              Next
              
              OutPut + #LineFeed
              
            Case 1
              Output.s = Comments::Tabulation(1) + "Procedure Plus(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + #TwinLineFeed
              
              ForEach Primary()
                OutPut + Comments::Tabulation(2) + VarNameR + "\" + Primary()\Field\Name + " = " + VarNameA + "\" + Primary()\Field\Name + " + " + VarNameB + "\" + Primary()\Field\Name + #LineFeed
              Next
              
              OutPut + #LineFeed
              
            Case 2
              Output.s = Comments::Tabulation(1) + "Procedure Minus(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + #TwinLineFeed
              
              ForEach Primary()
                OutPut + Comments::Tabulation(2) + VarNameR + "\" + Primary()\Field\Name + " = " + VarNameA + "\" + Primary()\Field\Name + " - " + VarNameB + "\" + Primary()\Field\Name + #LineFeed
              Next
              
              OutPut + #LineFeed
              
            Case 3
              Output.s = Comments::Tabulation(1) + "Procedure Product(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + #TwinLineFeed
              
              If General\IsSquareMatrix = #False
                
                ForEach Primary()
                  OutPut + Comments::Tabulation(2) + VarNameR + "\" + Primary()\Field\Name + " = " + VarNameA + "\" + Primary()\Field\Name + " * " + VarNameB + "\" + Primary()\Field\Name + #LineFeed
                Next
                
              Else
                
                For i = 1 To General\MatrixSizeI
                  
                  For j = 1 To General\MatrixSizeI
                    
                    Result.s = VarNameR + "\e" + Str(i) + Str(j) + " = "
                    
                    For k = 1 To General\MatrixSizeI
                      
                      Sum.s = Sum + VarNameA + "\e" + Str(i) + Str(k) + " * " + VarNameB + "\e" + Str(k) + Str(j)
                      
                      If k < General\MatrixSizeI
                        Sum + " + "
                      EndIf
                      
                    Next
                    
                    OutPut + Comments::Tabulation(2) + Result + Sum + #LineFeed
                    
                    Result = ""
                    Sum = ""
                    
                  Next
                  
                Next
                
              EndIf
              
              OutPut + #LineFeed
              
            Case 4
              
              Output.s = Comments::Tabulation(1) + "Procedure Divide(" + FullNameR + ", " + FullNameA + ", " + FullNameB + ")" + #TwinLineFeed
              
              ForEach Primary()
                OutPut + Comments::Tabulation(2) + VarNameR + "\" + Primary()\Field\Name + " = " + VarNameA + "\" + Primary()\Field\Name + " / " + VarNameB + "\" + Primary()\Field\Name + #LineFeed
              Next
              
              OutPut + #LineFeed
              
            Case 5
              Output.s = Comments::Tabulation(1) + "Procedure Zero(" + FullNameA + ")" + #LineFeed
              
              ForEach Primary()
                
                If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + Comments::Tabulation(2) + VarNameA + " = " + Instruct00 + #LineFeed
                
                If ListIndex(Primary()) = ListSize(Primary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            Case 6
              Output.s = Comments::Tabulation(1) + "Procedure One(" + FullNameA + ")" + #LineFeed
              
              ForEach Primary()
                
                If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + Comments::Tabulation(2) + VarNameA + " = " + Instruct01 + #LineFeed
                
                If ListIndex(Primary()) = ListSize(Primary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            Case 7
              Output.s = Comments::Tabulation(1) + "Procedure ProductByScalar(" + FullNameR + ", " + FullNameA + ", P_Scalar." + Primary()\Field\ExtensionShort + ")" + #TwinLineFeed
              
              ForEach Primary()
                OutPut + Comments::Tabulation(2) + VarNameR + "\" + Primary()\Field\Name + " = " + VarNameA + "\" + Primary()\Field\Name + " * P_Scalar" + #LineFeed
              Next
              
              OutPut + #LineFeed
              
            Case 8
              Output.s = Comments::Tabulation(1) + "Procedure DivideByScalar(" + FullNameR + ", " + FullNameA + ", P_Scalar." + Primary()\Field\ExtensionShort + ")" + #TwinLineFeed
              
              ForEach Primary()
                OutPut + Comments::Tabulation(2) + VarNameR + "\" + Primary()\Field\Name + " = " + VarNameA + "\" + Primary()\Field\Name + " / P_Scalar" + #LineFeed
              Next
              
              OutPut + #LineFeed
              
            Case 9
              Output.s = Comments::Tabulation(1) + "Procedure Copy(" + FullNameA + ", " + FullNameB + ")" + #TwinLineFeed
              
              ForEach Primary()
                
                If Primary()\Field\Type = #FIELD_TYPE_MODULE
                  OutPut + Comments::Tabulation(2) + Primary()\Field\ExternModuleName + "::Copy(" + VarNameA + "\" + Primary()\Field\Name + ", " + VarNameB + "\" + Primary()\Field\Name + ")"  + #LineFeed
                Else  
                  OutPut + Comments::Tabulation(2) + VarNameB + "\" + Primary()\Field\Name + " = " + VarNameA + "\" + Primary()\Field\Name + #LineFeed
                EndIf
                
              Next
              
              OutPut + #LineFeed
              
            Case 10
              Output.s = Comments::Tabulation(1) + "Procedure Compare(" + FullNameA + ", " + FullNameB + ")" + #TwinLineFeed
              
              ForEach Primary()
                OutPut + Comments::Tabulation(2) + "If " + VarNameA + "\" + Primary()\Field\Name + " <> " + VarNameB + "\" + Primary()\Field\Name + #LineFeed
                OutPut + Comments::Tabulation(3) + "ProcedureReturn #False" + #LineFeed
                OutPut + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
              Next
              
              Output + Comments::Tabulation(2) + "ProcedureReturn #True" + #LineFeed
              
            Case 11
              Output.s = Comments::Tabulation(1) + "Procedure Swapping(" + FullNameA + ", " + FullNameB + ")" + #TwinLineFeed
              
              ForEach Primary()
                If Primary()\Field\Type = #FIELD_TYPE_MODULE
                  OutPut + Comments::Tabulation(2) + Primary()\Field\ExternModuleName + "::Swapping(" + VarNameA + "\" + Primary()\Field\Name + ", " + VarNameB + "\" + Primary()\Field\Name + ")"  + #LineFeed
                Else
                  OutPut + Comments::Tabulation(2) + "Swap " + VarNameA + "\" + Primary()\Field\Name + ", " + VarNameB + "\" + Primary()\Field\Name + #LineFeed
                EndIf
                
              Next
              
              OutPut + #LineFeed
              
            Case 12
              If General\IsSquareMatrix = #True
                Output.s = Comments::Tabulation(1) + "Procedure Identity(" + FullNameA + ")" + #TwinLineFeed
                
                For j = 1 To General\MatrixSizeI
                  For i = 1 To General\MatrixSizeI
                    
                    If i <> j
                      Output + Comments::Tabulation(2) + VarNameA + "\e" + Str(i) + Str(j) + " = " + Instruct00 + #LineFeed
                    Else
                      Output + Comments::Tabulation(2) + VarNameA + "\e" + Str(i) + Str(j) + " = " + Instruct01 + #LineFeed
                    EndIf
                    
                  Next
                Next
                
                OutPut + #LineFeed
                
              EndIf
              
            Case 13
              If General\IsSquareMatrix = #True
                Output.s = Comments::Tabulation(1) + "Procedure Transpose(" + FullNameR + ", " + FullNameA + ")" + #TwinLineFeed
                For j = 1 To General\MatrixSizeI
                  For i = 1 To General\MatrixSizeI
                    Output + Comments::Tabulation(2) + VarNameR + "\e" + Str(i) + Str(j) + " = " + VarNameA + "\e" + Str(j) + Str(i) + #LineFeed
                  Next
                Next
                OutPut + #LineFeed
              EndIf
              
            Case 14
              If General\IsSquareMatrix = #True
                Output.s = Comments::Tabulation(1) + "Procedure SelfTranspose(" + FullNameA + ")" + #TwinLineFeed
                For I = 1 To General\MatrixSizeI - 1
                  For J = I To General\MatrixSizeI
                    If J <> I
                      Output + Comments::Tabulation(2) + "Swap " + VarNameA + "\e" + Str(i) + Str(j) + ", " + VarNameA + "\e" + Str(J) + Str(I) + #LineFeed
                    EndIf
                  Next
                Next
                OutPut + #LineFeed
              EndIf
              
            Case 15
              If General\IsMatrix = #True
                Output.s = Comments::Tabulation(1) + "Procedure Randomize(" + FullNameA + ", Min" + ReturnType + ", Max" + ReturnType + ", Resolution = 10000)" + #TwinLineFeed
                For j = 1 To General\MatrixSizeJ
                  For i = 1 To General\MatrixSizeI
                    Output + Comments::Tabulation(2) + VarNameA + "\e" + Str(i) + Str(j) + " = (Min + (Max - Min) * Random(Resolution) / Resolution)" + #LineFeed
                  Next
                Next
                OutPut + #LineFeed
              EndIf
              
            Case 16
              If General\IsSquareMatrix = #True
                
                Output.s = Comments::Tabulation(1) + "Procedure" + ReturnType + " Determinant(" + FullNameA + ")" + #TwinLineFeed
                
                Select General\MatrixSizeI
                    
                  Case 2 
                    Output.s + Comments::Tabulation(2) + "ProcedureReturn " + VarNameA + "\e11 * " + VarNameA + "\e22 - " + VarNameA + "\e12 * " + VarNameA + "\e21" + #LineFeed
                    
                  Case 3
                    Output.s + Comments::Tabulation(2) + "ProcedureReturn (" + VarNameA + "\e11 * (" + VarNameA + "\e22 * " + VarNameA + "\e33 - " + VarNameA + "\e23 * " + VarNameA + "\e32) - " + VarNameA + "\e12 * (" + VarNameA + "\e21 * " + VarNameA + "\e33 - " + VarNameA + "\e23 * " + VarNameA + "\e31) + " + VarNameA + "\e13 * (" + VarNameA + "\e21 * " + VarNameA + "\e32 - " + VarNameA + "\e22 * " + VarNameA + "\e31))" + #LineFeed
                    
                  Case 4
                    Output.s + Comments::Tabulation(2) + "ProcedureReturn (" + VarNameA + "\e11 * " + VarNameA + "\e22 * " + VarNameA + "\e33 * " + VarNameA + "\e44 - " + VarNameA + "\e11 * " + VarNameA + "\e22 * " + VarNameA + "\e34 * " + VarNameA + "\e43 - " + VarNameA + "\e11 * " + VarNameA + "\e32 * " + VarNameA + "\e23 * " + VarNameA + "\e44 + " + VarNameA + "\e11 * " + VarNameA + "\e32 * " + VarNameA + "\e24 * " + VarNameA + "\e43 + " + VarNameA + "\e11 * " + VarNameA + "\e42 * " + VarNameA + "\e23 * " + VarNameA + "\e34 - " + VarNameA + "\e11 * " + VarNameA + "\e42 * " + VarNameA + "\e24 * " + VarNameA + "\e33 - " + VarNameA + "\e21 * " + VarNameA + "\e12 * " + VarNameA + "\e33 * " + VarNameA + "\e44 + " + VarNameA + "\e21 * " + VarNameA + "\e12 * " + VarNameA + "\e34 * " + VarNameA + "\e43 + " + VarNameA + "\e21 * " + VarNameA + "\e32 * " + VarNameA + "\e13 * " + VarNameA + "\e44 - " + VarNameA + "\e21 * " + VarNameA + "\e32 * " + VarNameA + "\e14 * " + VarNameA + "\e43 - " + VarNameA + "\e21 * " + VarNameA + "\e42 * " + VarNameA + "\e13 * " + VarNameA + "\e34 + " + VarNameA + "\e21 * " + VarNameA + "\e42 * " + VarNameA + "\e14 * " + VarNameA + "\e33 + " + VarNameA + "\e31 * " + VarNameA + "\e12 * " + VarNameA + "\e23 * " + VarNameA + "\e44 - " + VarNameA + "\e31 * " + VarNameA + "\e12 * " + VarNameA + "\e24 * " + VarNameA + "\e43 - " + VarNameA + "\e31 * " + VarNameA + "\e22 * " + VarNameA + "\e13 * " + VarNameA + "\e44 + " + VarNameA + "\e31 * " + VarNameA + "\e22 * " + VarNameA + "\e14 * " + VarNameA + "\e43 + " + VarNameA + "\e31 * " + VarNameA + "\e42 * " + VarNameA + "\e13 * " + VarNameA + "\e24 - " + VarNameA + "\e31 * " + VarNameA + "\e42 * " + VarNameA + "\e14 * " + VarNameA + "\e23 - " + VarNameA + "\e41 * " + VarNameA + "\e12 * " + VarNameA + "\e23 * " + VarNameA + "\e34 + " + VarNameA + "\e41 * " + VarNameA + "\e12 * " + VarNameA + "\e24 * " + VarNameA + "\e33 + " + VarNameA + "\e41 * " + VarNameA + "\e22 * " + VarNameA + "\e13 * " + VarNameA + "\e34 - " + VarNameA + "\e41 * " + VarNameA + "\e22 * " + VarNameA + "\e14 * " + VarNameA + "\e33 - " + VarNameA + "\e41 * " + VarNameA + "\e32 * " + VarNameA + "\e13 * " + VarNameA + "\e24 + " + VarNameA + "\e41 * " + VarNameA + "\e32 * " + VarNameA + "\e14 * " + VarNameA + "\e23)" + #LineFeed
                    
                EndSelect
                
              EndIf
              
            Case 17
              If General\IsSquareMatrix = #True
                
                Output.s = Comments::Tabulation(1) + "Procedure.b Inverse(*Inverse." + General\ModuleName + ", " + FullNameA + ")" + #TwinLineFeed
                Output + Comments::Tabulation(2) + "Copy(" + VarNameA + ", CopyA." + General\ModuleName + ")" + #LineFeed
                Output + Comments::Tabulation(2) + "Cofactor_Determinant" + ReturnType + " = Determinant(" + VarNameA + ")" + #TwinLineFeed
                Output + Comments::Tabulation(2) + "If Cofactor_Determinant <> 0.0" + #LineFeed
                
                Select General\MatrixSizeI
                    
                  Case 2
                    
                    Output.s + Comments::Tabulation(3) + "*Inverse\e11 = Copy\e22 / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e12 = -Copy\e12 / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e21 = -Copy\e21 / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e22 = Copy\e11 / Cofactor_Determinant" + #LineFeed
                    
                  Case 3
                    
                    Output.s + Comments::Tabulation(3) + "*Inverse\e11 = (CopyA\e22 * CopyA\e33 - CopyA\e23 * CopyA\e32) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e12 = (CopyA\e13 * CopyA\e32 - CopyA\e12 * CopyA\e33) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e13 = (CopyA\e12 * CopyA\e23 - CopyA\e13 * CopyA\e22) / Cofactor_Determinant" + #LineFeed
                    
                    Output.s + Comments::Tabulation(3) + "*Inverse\e21 = (CopyA\e23 * CopyA\e31 - CopyA\e21 * CopyA\e33) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e22 = (CopyA\e11 * CopyA\e33 - CopyA\e13 * CopyA\e31) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e23 = (CopyA\e13 * CopyA\e21 - CopyA\e11 * CopyA\e23) / Cofactor_Determinant" + #LineFeed
                    
                    Output.s + Comments::Tabulation(3) + "*Inverse\e31 = (CopyA\e21 * CopyA\e32 - CopyA\e22 * CopyA\e31) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e32 = (CopyA\e12 * CopyA\e31 - CopyA\e11 * CopyA\e32) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e33 = (CopyA\e11 * CopyA\e22 - CopyA\e12 * CopyA\e21) / Cofactor_Determinant" + #LineFeed
                    
                  Case 4
                    
                    Output.s + Comments::Tabulation(3) + "*Inverse\e11 = (CopyA\e22 * CopyA\e33 * CopyA\e44 - CopyA\e22 * CopyA\e34 * CopyA\e43 - CopyA\e32 * CopyA\e23 * CopyA\e44 + CopyA\e32 * CopyA\e24 * CopyA\e43 + CopyA\e42 * CopyA\e23 * CopyA\e34 - CopyA\e42 * CopyA\e24 * CopyA\e33) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e12 = (CopyA\e12 * CopyA\e34 * CopyA\e43 + CopyA\e32 * CopyA\e13 * CopyA\e44 - CopyA\e32 * CopyA\e14 * CopyA\e43 - CopyA\e42 * CopyA\e13 * CopyA\e34 + CopyA\e42 * CopyA\e14 * CopyA\e33 - CopyA\e12 * CopyA\e33 * CopyA\e44) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e13 = (CopyA\e12 * CopyA\e23 * CopyA\e44 - CopyA\e12 * CopyA\e24 * CopyA\e43 - CopyA\e22 * CopyA\e13 * CopyA\e44 + CopyA\e22 * CopyA\e14 * CopyA\e43 + CopyA\e42 * CopyA\e13 * CopyA\e24 - CopyA\e42 * CopyA\e14 * CopyA\e23) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e14 = (CopyA\e12 * CopyA\e24 * CopyA\e33 + CopyA\e22 * CopyA\e13 * CopyA\e34 - CopyA\e22 * CopyA\e14 * CopyA\e33 - CopyA\e32 * CopyA\e13 * CopyA\e24 + CopyA\e32 * CopyA\e14 * CopyA\e23 - CopyA\e12 * CopyA\e23 * CopyA\e34) / Cofactor_Determinant" + #LineFeed
                    
                    Output.s + Comments::Tabulation(3) + "*Inverse\e21 = (CopyA\e21 * CopyA\e34 * CopyA\e43 + CopyA\e31 * CopyA\e23 * CopyA\e44 - CopyA\e31 * CopyA\e24 * CopyA\e43 - CopyA\e41 * CopyA\e23 * CopyA\e34 + CopyA\e41 * CopyA\e24 * CopyA\e33 - CopyA\e21 * CopyA\e33 * CopyA\e44) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e22 = (CopyA\e11 * CopyA\e33 * CopyA\e44 - CopyA\e11 * CopyA\e34 * CopyA\e43 - CopyA\e31 * CopyA\e13 * CopyA\e44 + CopyA\e31 * CopyA\e14 * CopyA\e43 + CopyA\e41 * CopyA\e13 * CopyA\e34 - CopyA\e41 * CopyA\e14 * CopyA\e33) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e23 = (CopyA\e11 * CopyA\e24 * CopyA\e43 + CopyA\e21 * CopyA\e13 * CopyA\e44 - CopyA\e21 * CopyA\e14 * CopyA\e43 - CopyA\e41 * CopyA\e13 * CopyA\e24 + CopyA\e41 * CopyA\e14 * CopyA\e23 - CopyA\e11 * CopyA\e23 * CopyA\e44) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e24 = (CopyA\e11 * CopyA\e23 * CopyA\e34 - CopyA\e11 * CopyA\e24 * CopyA\e33 - CopyA\e21 * CopyA\e13 * CopyA\e34 + CopyA\e21 * CopyA\e14 * CopyA\e33 + CopyA\e31 * CopyA\e13 * CopyA\e24 - CopyA\e31 * CopyA\e14 * CopyA\e23) / Cofactor_Determinant" + #LineFeed
                    
                    Output.s + Comments::Tabulation(3) + "*Inverse\e31 = (CopyA\e21 * CopyA\e32 * CopyA\e44 - CopyA\e21 * CopyA\e34 * CopyA\e42 - CopyA\e31 * CopyA\e22 * CopyA\e44 + CopyA\e31 * CopyA\e24 * CopyA\e42 + CopyA\e41 * CopyA\e22 * CopyA\e34 - CopyA\e41 * CopyA\e24 * CopyA\e32) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e32 = (CopyA\e11 * CopyA\e34 * CopyA\e42 + CopyA\e31 * CopyA\e12 * CopyA\e44 - CopyA\e31 * CopyA\e14 * CopyA\e42 - CopyA\e41 * CopyA\e12 * CopyA\e34 + CopyA\e41 * CopyA\e14 * CopyA\e32 - CopyA\e11 * CopyA\e32 * CopyA\e44) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e33 = (CopyA\e11 * CopyA\e22 * CopyA\e44 - CopyA\e11 * CopyA\e24 * CopyA\e42 - CopyA\e21 * CopyA\e12 * CopyA\e44 + CopyA\e21 * CopyA\e14 * CopyA\e42 + CopyA\e41 * CopyA\e12 * CopyA\e24 - CopyA\e41 * CopyA\e14 * CopyA\e22) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e34 = (CopyA\e11 * CopyA\e24 * CopyA\e32 + CopyA\e21 * CopyA\e12 * CopyA\e34 - CopyA\e21 * CopyA\e14 * CopyA\e32 - CopyA\e31 * CopyA\e12 * CopyA\e24 + CopyA\e31 * CopyA\e14 * CopyA\e22 - CopyA\e11 * CopyA\e22 * CopyA\e34) / Cofactor_Determinant" + #LineFeed
                    
                    Output.s + Comments::Tabulation(3) + "*Inverse\e41 = (CopyA\e41 * CopyA\e23 * CopyA\e32 - CopyA\e21 * CopyA\e32 * CopyA\e43 + CopyA\e21 * CopyA\e33 * CopyA\e42 + CopyA\e31 * CopyA\e22 * CopyA\e43 - CopyA\e31 * CopyA\e23 * CopyA\e42 - CopyA\e41 * CopyA\e22 * CopyA\e33) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e42 = (CopyA\e11 * CopyA\e32 * CopyA\e43 - CopyA\e11 * CopyA\e33 * CopyA\e42 - CopyA\e31 * CopyA\e12 * CopyA\e43 + CopyA\e31 * CopyA\e13 * CopyA\e42 + CopyA\e41 * CopyA\e12 * CopyA\e33 - CopyA\e41 * CopyA\e13 * CopyA\e32) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e43 = (CopyA\e11 * CopyA\e23 * CopyA\e42 + CopyA\e21 * CopyA\e12 * CopyA\e43 - CopyA\e21 * CopyA\e13 * CopyA\e42 - CopyA\e41 * CopyA\e12 * CopyA\e23 + CopyA\e41 * CopyA\e13 * CopyA\e22 - CopyA\e11 * CopyA\e22 * CopyA\e43) / Cofactor_Determinant" + #LineFeed
                    Output.s + Comments::Tabulation(3) + "*Inverse\e44 = (CopyA\e11 * CopyA\e22 * CopyA\e33 - CopyA\e11 * CopyA\e23 * CopyA\e32 - CopyA\e21 * CopyA\e12 * CopyA\e33 + CopyA\e21 * CopyA\e13 * CopyA\e32 + CopyA\e31 * CopyA\e12 * CopyA\e23 - CopyA\e31 * CopyA\e13 * CopyA\e22) / Cofactor_Determinant" + #LineFeed
                    
                EndSelect
                
                Output.s + Comments::Tabulation(3) + "Result.b = #True" + #LineFeed 
                Output.s + Comments::Tabulation(2) + "Else" + #LineFeed
                Output.s + Comments::Tabulation(3) + "Identity(*Inverse)" + #LineFeed
                Output.s + Comments::Tabulation(3) + "Result = #False" + #LineFeed
                Output.s + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed 
                Output.s + Comments::Tabulation(2) + "ProcedureReturn Result" + #LineFeed
                
              EndIf
              
            Case 18
              If General\IsMatrix = #True
                
                For i = 1 To General\MatrixSizeI
                  
                  Output.s + Comments::Tabulation(1) + "Procedure.s FormatLine" + Str(i) + "("  + FullNameA + ConvertDeciPar + ")" + #TwinLineFeed
                  Internal.s = Chr(34) + "[" + Chr(34) + " + "
                  
                  For j = 1 To General\MatrixSizeJ
                    
                    Internal + ConvertStr + VarNameA + "\e" + Str(i) + Str(j) + ConvertDeci
                    
                    If j < General\MatrixSizeJ
                      Internal + " + " + Chr(34) + " : " + Chr(34) + " + "
                    Else
                      Internal + " + " + Chr(34) + "]" + Chr(34)
                    EndIf
                    
                  Next
                  
                  Output.s + Comments::Tabulation(2) + "ProcedureReturn " + Internal + #LineFeed
                  Output.s + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
                Next
                
              EndIf
              
            Case 19
              If General\IsMatrix = #True
                
                For i = 1 To General\MatrixSizeI
                  
                  Output.s + Comments::Tabulation(1) + "Procedure UnformatLine" + Str(i) + "("  + FullNameA + ", P_MatrixLine.s)" + #TwinLineFeed
                  
                  For j = 1 To General\MatrixSizeJ
                    
                    Output + Comments::Tabulation(2) + VarNameA + "\e" + Str(i) + Str(j) + " = " + UnconvertStr + "StringField(StringField(StringField(P_MatrixLine, 2, "
                    Output + Chr(34) + "[" + Chr(34) + "), 1, "  + Chr(34) + "]" + Chr(34) + "), " + Str(j) + ", " + Chr(34) + ":" + Chr(34) + "))"
                    
                    If j < General\MatrixSizeJ
                      Output + #LineFeed
                    Else
                      Output + #TwinLineFeed
                    EndIf
                    
                  Next
                  
                  Output.s + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                  
                Next
                
              EndIf
              
          EndSelect
          
          If P_MethodID < 12
            Output.s + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          Else
            If General\IsMatrix = #True And P_MethodID < 18
              Output.s + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            EndIf
          EndIf
          
      EndSelect
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< PrefFile Support Instructions <<<<<
  
  Procedure.s PrefsKey(*InstanceA.Instance, Style.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    Select Style
        
      Case 0
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + Chr(34) + BuiltDynamicArrayIndexList(*InstanceA\Field, 6)
        
      Case 1
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name  + "_" + Chr(34) + " + Str(" + BuiltDynamicArrayIndexList(*InstanceA\Field, 1) + ")"
        
      Case 2
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name + "_" + Chr(34) + " + Str(" + BuiltDynamicArrayIndexList(*InstanceA\Field, 1) + ") + "  + Chr(34) + "_" + Chr(34) + " + Str(" + *InstanceA\SubField()\ArrayIndexName + ")" 
        
      Case 3
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + Chr(34) + " + Str(" + *InstanceA\Field\Name + "ID)"
        
      Case 4
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name + "_" + Chr(34) + " + Str(" + *InstanceA\Field\Name + "ID)"
        
      Case 5
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name + "_" + Chr(34) + " + Str(" + *InstanceA\Field\Name + "ID) + "  + Chr(34) + "_" + Chr(34) + " + Str(" + *InstanceA\SubField()\ArrayIndexName + ")" 
        
      Case 6
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name + "_" + Chr(34) + " + Str(ListIndex(" + InstanceStyle + *InstanceA\Field\Name + "())) + "  + Chr(34) + "_" + Chr(34) + " + Str(" + *InstanceA\SubField()\ArrayIndexName + ")" 
        
      Case 7
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + Chr(34)
        
      Case 8
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name + Chr(34)
        
      Case 9
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name + "_" + Chr(34) + " + Str(" + *InstanceA\SubField()\ArrayIndexName + ")" 
        
      Case 10
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + Chr(34) + " + Str(" + *InstanceA\Field\ArrayIndexName + ")"
        
      Case 11
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name + "_" + Chr(34) + " + Str(" + *InstanceA\Field\ArrayIndexName + ")"
        
      Case 12
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name + "_" + Chr(34) + " + Str(" + *InstanceA\Field\ArrayIndexName + ") + " + Chr(34) + "_" + Chr(34) + " + Str(" + *InstanceA\SubField()\ArrayIndexName + ")" 
        
      Case 13
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_Key_" + Chr(34) + " + Str(" + *InstanceA\Field\Name + "ID)"
        
      Case 14
        PrefsKey.s = Chr(34) + *InstanceA\Field\Name + "_" + Chr(34) + " + Str(ListIndex(" + InstanceStyle + *InstanceA\Field\Name + "()))"
        
    EndSelect
    
    ProcedureReturn PrefsKey
  EndProcedure
  
  Procedure.s DynamicArrayReDim_PrefsFile(*FieldA.Field, TabSize.b, P_InstanceCameFrom.b, *ParentField.Field = #Null)
    
    If *FieldA\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    If General\SecondaryInstance = #True And P_InstanceCameFrom = #CAME_FROM_SECONDARY
      InstanceStyle.s = "Secondary\"
    EndIf
    
    For Index = 1 To *FieldA\DynamicArrayDimensionCount
      Instruction.s + Comments::Tabulation(TabSize) + *FieldA\Name + "_Max_" + Str(Index) + "D.l = ReadPreferenceLong(" + Chr(34) + *FieldA\Name + "_Max_" + Str(Index) + "D" + Chr(34) + ", 0)" + #LineFeed
    Next 
    
    If *ParentField = #Null
      Instruction + Comments::Tabulation(TabSize) + "ReDim " + InstanceStyle + *FieldA\Name + DollarSign + "(" + BuiltDynamicArrayIndexList(*FieldA, 3) + ")" + #TwinLinefeed
    Else
      Instruction + Comments::Tabulation(TabSize) + "ReDim " + InstanceStyle + *ParentField\Name + "(" + BuiltDynamicArrayIndexList(*ParentField, 1) + ")\" + *FieldA\Name + DollarSign + "(" + BuiltDynamicArrayIndexList(*FieldA, 3) + ")" + #TwinLinefeed
    EndIf
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s InstructionPrefsFile(*InstanceA.Instance, TabSize.b, Mode.b, P_InstanceCameFrom.b)
    
    If *InstanceA\Field\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    If General\SecondaryInstance = #True And P_InstanceCameFrom = #CAME_FROM_SECONDARY
      InstanceStyle.s = "Secondary\"
    EndIf
    
    Select Mode
        
      Case #INSTRUCTION_MODE_READ_PREF
        
        Select *InstanceA\Field\Style
            
          Case #FIELD_STYLE_ARRAY
            
            Instruction.s = DynamicArrayReDim_PrefsFile(*InstanceA\Field, TabSize, P_InstanceCameFrom)
            Instruction + AddDynamicArrayOpeningLoop(*InstanceA\Field, @TabSize, P_InstanceCameFrom)
            DynamicArrayIndexList.s = BuiltDynamicArrayIndexList(*InstanceA\Field, 1)

            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = ReadPreferenceLong(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$(" + DynamicArrayIndexList + ") = ReadPreferenceString(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "$(" + DynamicArrayIndexList + "))" + #EmptyString + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = ReadPreferenceString(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #EmptyString + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::ReadPrefs(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      TabSize + 1
                      Instruction + DynamicArrayReDim_PrefsFile(*InstanceA\SubField(), TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceLong(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = ReadPreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLinefeed
                      TabSize - 1
                      
                    Case #FIELD_STYLE_LIST
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\SubField()\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\SubField()\Name + "ID = 0 To " + *InstanceA\SubField()\Name + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddElement(" + InstanceStyle + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" +  #LineFeed
                      
                    Case #FIELD_STYLE_MAP
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\SubField()\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\SubField()\Name + "ID = 0 To " + *InstanceA\SubField()\Name + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddMapElement(" + InstanceStyle + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" +  #LineFeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = ReadPreferenceLong(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$ = ReadPreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = ReadPreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed

                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceLong(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])";+ #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" ;+ #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" ;+ #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])" ;+ #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name+ "[" + *InstanceA\SubField()\ArrayIndexName + "])" ;+ #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize+1) + "Next" +  #LineFeed
                        
                  EndSelect
                  
                Next

            EndSelect
            
            Instruction + AddDynamicArrayClosingLoop(*InstanceA\Field, @TabSize)
            
          Case #FIELD_STYLE_LIST

            Instruction = Comments::Tabulation(TabSize) + *InstanceA\Field\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\Field\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + "For " + *InstanceA\Field\Name + "ID = 0 To " + *InstanceA\Field\Name + "_Max" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "AddElement(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "())" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::ReadPrefs(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
             
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Instruction + DynamicArrayReDim_PrefsFile(*InstanceA\SubField(), TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceLong(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLinefeed
                      
                    Case #FIELD_STYLE_LIST
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\SubField()\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\SubField()\Name + "ID = 0 To " + *InstanceA\SubField()\Name + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddElement(" + InstanceStyle + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" +  #LineFeed
                      
                    Case #FIELD_STYLE_MAP
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\SubField()\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\SubField()\Name + "ID = 0 To " + *InstanceA\SubField()\Name + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddMapElement(" + InstanceStyle + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" +  #LineFeed
                      
                    Case #FIELD_STYLE_BASIC

                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceLong(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$ = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed

                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceLong(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name+ "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize+1) + "Next" +  #LineFeed
                      
                  EndSelect
                  
                Next
   
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
          Case #FIELD_STYLE_MAP
            
            Instruction = Comments::Tabulation(TabSize) + *InstanceA\Field\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\Field\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + "For " + *InstanceA\Field\Name + "ID = 0 To " + *InstanceA\Field\Name + "_Max" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "AddMapElement(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "(), ReadPreferenceString(" + PrefsKey(*InstanceA, 13) + ", " + #EmptyString  + "))" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "$())" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::ReadPrefs(" + PrefsKey(*InstanceA, 3) + ", "  + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                   
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      Instruction + DynamicArrayReDim_PrefsFile(*InstanceA\SubField(), TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceLong(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLinefeed
                      
                    Case #FIELD_STYLE_LIST
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\SubField()\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\SubField()\Name + "ID = 0 To " + *InstanceA\SubField()\Name + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddElement(" + InstanceStyle + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" +  #LineFeed
                      
                    Case #FIELD_STYLE_MAP
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\SubField()\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\SubField()\Name + "ID = 0 To " + *InstanceA\SubField()\Name + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddMapElement(" + InstanceStyle + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" +  #LineFeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceLong(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$ = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ReadPreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceLong(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name+ "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize+1) + "Next" +  #LineFeed
                      
                  EndSelect
                  
                Next

            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
          Case #FIELD_STYLE_BASIC
            
            Instruction = ""
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = ReadPreferenceLong(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "$ = ReadPreferenceString(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + "$)"
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = ReadPreferenceString(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_MODULE
                Instruction = Comments::Tabulation(TabSize) + *InstanceA\Field\ExternModuleName + "::ReadPrefs(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")" 
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Instruction + DynamicArrayReDim_PrefsFile(*InstanceA\SubField(), TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLinefeed
                      
                    Case #FIELD_STYLE_LIST
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\SubField()\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\SubField()\Name + "ID = 0 To " + *InstanceA\SubField()\Name + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddElement(" + InstanceStyle + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" +  #LineFeed
                      
                    Case #FIELD_STYLE_MAP
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\SubField()\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\SubField()\Name + "ID = 0 To " + *InstanceA\SubField()\Name + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddElement(" + InstanceStyle + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" +  #LineFeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = ReadPreferenceLong(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$ = ReadPreferenceString(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = ReadPreferenceString(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize) + #LineFeed + Comments::Tabulation(TabSize) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceLong(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])";+ #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" ;+ #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" ;+ #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])" ;+ #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name+ "[" + *InstanceA\SubField()\ArrayIndexName + "])" ;+ #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize) + #LineFeed + Comments::Tabulation(TabSize) + "Next" +  #LineFeed
                      
                  EndSelect
                  
                Next

            EndSelect
            
          Case #FIELD_STYLE_BASIC_ARRAY
            
            Instruction = Comments::Tabulation(TabSize) + "For " + *InstanceA\Field\ArrayIndexName + " = 0 To " + *InstanceA\Field\ArraySizeLoop + #LineFeed

            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = ReadPreferenceLong(" + PrefsKey(*InstanceA, 10) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 10) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 10) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 10) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 10) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$[" + *InstanceA\Field\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 10) + ", " + InstanceStyle + *InstanceA\Field\Name + "$[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name+ "[" + *InstanceA\Field\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 10) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::ReadPrefs(" + PrefsKey(*InstanceA, 10) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                  
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Instruction + DynamicArrayReDim_PrefsFile(*InstanceA\SubField(), TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLinefeed
                      
                    Case #FIELD_STYLE_LIST
                      Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\Name + "_Max = ReadPreferenceLong(" + Chr(34) + *InstanceA\SubField()\Name + "_Max" + Chr(34) + ", 0) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\SubField()\Name + "ID = 0 To " + *InstanceA\SubField()\Name + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddElement(" + InstanceStyle + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" +  #LineFeed
                      
                    Case #FIELD_STYLE_MAP
                     
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceLong(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$() = ReadPreferenceString(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = ReadPreferenceString(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = ReadPreferenceLong(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$ = ReadPreferenceString(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = ReadPreferenceString(" + PrefsKey(*InstanceA, 11) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceLong(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceInteger(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceQuad(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceFloat(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceDouble(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = ReadPreferenceString(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize+1) + "Next" +  #LineFeed

                  EndSelect
                  
                Next 
 
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
        EndSelect
        
      Case #INSTRUCTION_MODE_WRITE_PREF
        
        Select *InstanceA\Field\Style
            
          Case #FIELD_STYLE_ARRAY
            
            Instruction.s = ""
            
            For Index = 1 To *InstanceA\Field\DynamicArrayDimensionCount
              Instruction + Comments::Tabulation(TabSize) + "WritePreferenceLong(" + Chr(34) + *InstanceA\Field\Name + "_Max_" + Str(Index) + "D" + Chr(34) + ", " + DynamicArraySize(*InstanceA\Field, Str(Index)) + ")" + #TwinLineFeed
            Next 
            
            Instruction + AddDynamicArrayOpeningLoop(*InstanceA\Field, @TabSize, P_InstanceCameFrom)
            DynamicArrayIndexList.s = BuiltDynamicArrayIndexList(*InstanceA\Field, 1)
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "$(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::WritePrefs(" + PrefsKey(*InstanceA, 0) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                    Case #FIELD_STYLE_LIST
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_MAP
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 1) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(*InstanceA, 2) + ", " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize+1) + "Next" +  #LineFeed
                      
                  EndSelect
                  
                Next

            EndSelect
            
            Instruction + AddDynamicArrayClosingLoop(*InstanceA\Field, @TabSize)
            
          Case #FIELD_STYLE_LIST
            
            Instruction = Comments::Tabulation(TabSize) + "WritePreferenceLong(" + Chr(34) + *InstanceA\Field\Name + "_Max" + Chr(34) + ", ListSize(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()))" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 14) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 14) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 14) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 14) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 14) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 14) + ", " + InstanceStyle + *InstanceA\Field\Name + "$())" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 14) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::WritePrefs(" + PrefsKey(*InstanceA, 14) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                    Case #FIELD_STYLE_LIST
                    Case #FIELD_STYLE_MAP
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 6) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 6) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 6) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 6) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 6) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(*InstanceA, 6) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(*InstanceA, 6) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "Next" +  #LineFeed
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
          Case #FIELD_STYLE_MAP
            
            Instruction = Comments::Tabulation(TabSize) + "WritePreferenceLong(" + Chr(34) + *InstanceA\Field\Name + "_Max" + Chr(34) + ", MapSize(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()))" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + *InstanceA\Field\Name + "ID = 0" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + Chr(34) + *InstanceA\Field\Name + "_Key_" + Chr(34) + " + Str(" + *InstanceA\Field\Name + "ID)" + ", MapKey(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()))" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "$())" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::WritePrefs(" + PrefsKey(*InstanceA, 3) + ", " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                  
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                       
                    Case #FIELD_STYLE_ARRAY
                    Case #FIELD_STYLE_LIST
                    Case #FIELD_STYLE_MAP
                        
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                        
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 4) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(*InstanceA, 5) + ", " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "Next" +  #LineFeed
                      
                  EndSelect
                  
                Next

            EndSelect
            
            Instruction + Comments::Tabulation(TabSize+1) + *InstanceA\Field\Name + "ID + 1" + #LineFeed
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
          Case #FIELD_STYLE_BASIC
            
            GroupName.s = Chr(34) + *InstanceA\Field\Name + Chr(34)
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize) + "WritePreferenceString(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + "$)"
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize) + "WritePreferenceString(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_MODULE
                Instruction = Comments::Tabulation(TabSize) + *InstanceA\Field\ExternModuleName + "::WritePrefs(" + PrefsKey(*InstanceA, 7) + ", " + InstanceStyle + *InstanceA\Field\Name + ")" 
               
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                    Case #FIELD_STYLE_LIST
                    Case #FIELD_STYLE_MAP
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize) + "WritePreferenceString(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize) + "WritePreferenceString(" + PrefsKey(*InstanceA, 8) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + PrefsKey(*InstanceA, 9) + ", " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])"  + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize) + "Next" +  #LineFeed
                      
                  EndSelect
                  
                Next
 
            EndSelect
            
          Case #FIELD_STYLE_BASIC_ARRAY
            
            Instruction = Comments::Tabulation(TabSize) + "For " + *InstanceA\Field\ArrayIndexName + " = 0 To " + *InstanceA\Field\ArraySizeLoop + #LineFeed
            GroupName.s = Chr(34) + *InstanceA\Field\Name + "_" + Chr(34) + " + Str(" + *InstanceA\Field\ArrayIndexName + ")"
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + GroupName + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceInteger(" + GroupName + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceQuad(" + GroupName + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceFloat(" + GroupName + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceDouble(" + GroupName + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + GroupName + ", " + InstanceStyle + *InstanceA\Field\Name + "$[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + GroupName + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::WritePrefs(" + GroupName + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                 
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                    Case #FIELD_STYLE_LIST
                    Case #FIELD_STYLE_MAP
                      
                    Case #FIELD_STYLE_BASIC
                      
                      GroupName2.s = GroupName + "_" + *InstanceA\SubField()\Name + ", "
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceLong(" + GroupName2 + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceInteger(" + GroupName2 + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceQuad(" + GroupName2 + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceFloat(" + GroupName2 + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceDouble(" + GroupName2 + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + GroupName2 + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + "WritePreferenceString(" + GroupName2 + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      Instruction + Comments::Tabulation(TabSize) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_CHARACTER, #FIELD_TYPE_WORD, #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceLong(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceInteger(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceQuad(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceFloat(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceDouble(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + "WritePreferenceString(" + PrefsKey(*InstanceA, 12) + ", " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize+1) + "Next" +  #LineFeed

                  EndSelect
                  
                Next 

            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
        EndSelect
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s MethodPrefFile(P_MethodID.l, P_Mode.b)
    
    Output.s = ""
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + General\InstanceID + " = -1"
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + General\InstanceID + " = " + #EmptyString
        InstanceStyle.s = "Instances()\"

      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
        InstanceStyle.s = "*" + General\ModuleName + "A\"
    EndSelect
    
    If P_MethodID >= 2
      
      FirstElement(Primary())
      
      If Levenshtein::Correlation("PrefFileName", Primary()\Field\Name) > 0.9
        PrefFileName00.s = ""
        PrefFileName01.s = InstanceStyle + Primary()\Field\Name
        SkipFirstField = #True
      Else
        PrefFileName00.s = "P_FileName.s"
        PrefFileName01.s = "P_FileName"
        SkipFirstField = #False
      EndIf
      
    EndIf 
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0
            Output.s = Comments::Tabulation(1) + "Declare ReadPrefs(P_GroupName.s" + ExtraParam + ")" + #LineFeed
            
          Case 1
            Output.s = Comments::Tabulation(1) + "Declare WritePrefs(P_GroupName.s" + ExtraParam + ")" + #LineFeed
            
          Case 2
            Output.s = Comments::Tabulation(1) + "Declare CreatePrefs(" + PrefFileName00 + ExtraParam + ")" + #LineFeed
            
          Case 3
            Output = Comments::Tabulation(1) + "Declare OpenPrefs(" + PrefFileName00 + ExtraParam + ")" + #LineFeed
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0
            
            Output.s = Comments::Tabulation(1) + "Procedure ReadPrefs(P_GroupName.s" + ExtraParam + ")" + #TwinLineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                Output + Comments::Tabulation(2) + "PreferenceGroup(P_GroupName)" + #LineFeed
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(2) + #LineFeed
                  EndIf 
                  
                  Output + InstructionPrefsFile(Primary(), 2, #INSTRUCTION_MODE_READ_PREF, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(2) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                Output2.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionPrefsFile(Primary(), 4, #INSTRUCTION_MODE_READ_PREF, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(2) + "If P_InstanceID = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If P_Index = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If P_Name = "  + #EmptyString + #TwinLineFeed
                EndSelect
                
                Output + Comments::Tabulation(3) + "Instances_Max.l = ReadPreferenceLong(P_GroupName + " + Chr(34) + "_Instances_Max" + Chr(34) + ", 0) - 1"+ #TwinLineFeed
                Output + Comments::Tabulation(3) + "For Index = 0 to Instances_Max" + #TwinLineFeed
                Output + Comments::Tabulation(4) + "PreferenceGroup(P_GroupName + " + Chr(34) + "_InstanceID_" + Chr(34) + " + Str(Index))" + #LineFeed
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(4) + "AddElement(Instances())" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(4) + "AddMapElement(Instances())" + #LineFeed
                    
                EndSelect

                Output + OutPut2
                Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
 
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    Output + Comments::Tabulation(4) + "PreferenceGroup(P_GroupName + " + Chr(34) + "_InstanceID_" + Chr(34) + " + Str(P_InstanceID))" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(3) + "If SelectElement(Instances(), P_Index)" + #TwinLineFeed
                    Output + Comments::Tabulation(4) + "PreferenceGroup(P_GroupName + " + Chr(34) + "_InstanceID_" + Chr(34) + " + Str(P_Index))" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(4) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                    
                EndSelect
                
                Output + OutPut2
                Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + InstructionPrefsFile(Secondary(), 2, #INSTRUCTION_MODE_READ_PREF, #CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
          Case 1
            Output.s = Comments::Tabulation(1) + "Procedure WritePrefs(P_GroupName.s" + ExtraParam + ")" + #TwinLineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                Output + Comments::Tabulation(2) + "PreferenceGroup(P_GroupName)" + #LineFeed
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(2) + #LineFeed
                  EndIf 
                  
                  Output + InstructionPrefsFile(Primary(), 2, #INSTRUCTION_MODE_WRITE_PREF, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(2) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                Output2.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionPrefsFile(Primary(), 4, #INSTRUCTION_MODE_WRITE_PREF, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(2) + "If P_InstanceID = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If P_Index = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If P_Name = "  + #EmptyString + #TwinLineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(3) + "WritePreferenceLong(P_GroupName + " + Chr(34) + "Instances_Max" + Chr(34) + ", ListSize(Instances()))"+ #TwinLineFeed
                Output + Comments::Tabulation(3) + "Foreach Instances()" + #TwinLineFeed
                Output + Comments::Tabulation(4) + "PreferenceGroup(P_GroupName + " + Chr(34) + "_InstanceID_" + Chr(34) + " + Str(ListIndex(Instances())))" + #LineFeed
                Output + OutPut2
                Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(3) + "If SelectElement(Instances(), P_Index)" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(4) + "PreferenceGroup(P_GroupName + " + Chr(34) + "_InstanceID_" + Chr(34) + " + Str(P_InstanceID))" + #LineFeed
                Output + OutPut2
                Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + InstructionPrefsFile(Secondary(), 2, #INSTRUCTION_MODE_WRITE_PREF, #CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
          Case 2
            
            Output = Comments::Tabulation(1) + "Procedure CreatePrefs("+ PrefFileName00 + ExtraParam + ")" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If CreatePreferences(" + PrefFileName01 + ")" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                ForEach Primary()
                  
                  If SkipFirstField = #True
                    
                    If ListSize(Primary()) = 1
                      Break
                    Else
                      NextElement(Primary())
                      SkipFirstField = #False
                      Output + Comments::Tabulation(3) + #LineFeed
                    EndIf
                    
                  EndIf
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(3) + #LineFeed
                  EndIf 
                  
                  Output + InstructionPrefsFile(Primary(), 3, #INSTRUCTION_MODE_WRITE_PREF, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(3) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                Output2.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(5) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionPrefsFile(Primary(), 5, #INSTRUCTION_MODE_WRITE_PREF, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(5) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(3) + "If P_InstanceID = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(3) + "If P_Index = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If P_Name = "  + #EmptyString + #TwinLineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(4) + "WritePreferenceLong(" + Chr(34) + "Instances_Max" + Chr(34) + ", ListSize(Instances()))"+ #TwinLineFeed
                Output + Comments::Tabulation(4) + "Foreach Instances()" + #TwinLineFeed
                Output + Comments::Tabulation(5) + "PreferenceGroup(" + Chr(34) + "InstanceID_" + Chr(34) + " + Str(ListIndex(Instances())))" + #LineFeed
                Output + OutPut2
                Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(3) + "Else" + #TwinLineFeed
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(4) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(4) + "If SelectElement(Instances(), P_Index)" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(4) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(5) + "PreferenceGroup(" + Chr(34) + "InstanceID_" + Chr(34) + " + Str(P_InstanceID))" + #LineFeed
                Output + OutPut2
                Output + Comments::Tabulation(4) + "EndIf" + #TwinLineFeed
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(3) + #LineFeed
                EndIf 
                
                Output + InstructionPrefsFile(Secondary(), 3, #INSTRUCTION_MODE_WRITE_PREF, #CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(3) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
            Output + Comments::Tabulation(3) + "ClosePreferences()" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            
          Case 3
            
            Output = Comments::Tabulation(1) + "Procedure OpenPrefs(" + PrefFileName00 + ExtraParam + ")" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If OpenPreferences(" + PrefFileName01 + ")" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                ForEach Primary()
                  
                  If SkipFirstField = #True
                    
                    If ListSize(Primary()) = 1
                      Break
                    Else
                      NextElement(Primary())
                      SkipFirstField = #False
                      Output + Comments::Tabulation(3) + #LineFeed
                    EndIf
                    
                  EndIf
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(3) + #LineFeed
                  EndIf 
                  
                  Output + InstructionPrefsFile(Primary(), 3, #INSTRUCTION_MODE_READ_PREF, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(3) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                Output2.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(5) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionPrefsFile(Primary(), 5, #INSTRUCTION_MODE_READ_PREF, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(5) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(3) + "If P_InstanceID = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(3) + "If P_Index = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If P_Name = "  + #EmptyString + #TwinLineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(4) + "Instances_Max.l = ReadPreferenceLong(" + Chr(34) + "Instances_Max" + Chr(34) + ", 0) - 1"+ #TwinLineFeed
                Output + Comments::Tabulation(4) + "For Index = 0 to Instances_Max" + #TwinLineFeed
                Output + Comments::Tabulation(5) + "PreferenceGroup(" + Chr(34) + "InstanceID_" + Chr(34) + " + Str(Index))" + #LineFeed
                Output + OutPut2
                Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(3) + "Else" + #TwinLineFeed
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(4) + "If SearchInstances(P_InstanceID) <> -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(4) + "If SelectElement(Instances(), P_Index)" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(4) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(5) + "PreferenceGroup(" + Chr(34) + "InstanceID_" + Chr(34) + " + Str(P_InstanceID))" + #LineFeed
                Output + OutPut2
                Output + Comments::Tabulation(4) + "EndIf" + #TwinLineFeed
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(3) + #LineFeed
                EndIf 
                
                Output + InstructionPrefsFile(Secondary(), 3, #INSTRUCTION_MODE_READ_PREF, #CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(3) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
            Output + Comments::Tabulation(3) + "ClosePreferences()" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            
        EndSelect
        
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< BinaryFile Support Instruction <<<<<
  
  Procedure.s DynamicArrayReDim_BinaryFile(*FieldA.Field, TabSize.b, FM.s, P_InstanceCameFrom.b, *ParentField.Field = #Null)
    
    If *FieldA\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    If General\SecondaryInstance = #True And P_InstanceCameFrom = #CAME_FROM_SECONDARY
      InstanceStyle.s = "Secondary\"
    EndIf
    
    For Index = 1 To *FieldA\DynamicArrayDimensionCount
      Instruction.s + Comments::Tabulation(TabSize) + *FieldA\Name + "_Max_" + Str(Index) + "D.l = " + FM + "ReadLong(FileID)" + #LineFeed
    Next 
    
    If *ParentField = #Null
      Instruction + Comments::Tabulation(TabSize) + "ReDim " + InstanceStyle + *FieldA\Name + DollarSign + "(" + BuiltDynamicArrayIndexList(*FieldA, 3) + ")" + #TwinLinefeed
    Else
      Instruction + Comments::Tabulation(TabSize) + "ReDim " + InstanceStyle + *ParentField\Name + "(" + BuiltDynamicArrayIndexList(*ParentField, 1) + ")\" + *FieldA\Name + DollarSign + "(" + BuiltDynamicArrayIndexList(*FieldA, 3) + ")" + #TwinLinefeed
    EndIf
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s InstructionBinaryFile(*InstanceA.Instance, TabSize.b, Mode.b, P_InstanceCameFrom.b)
    
    If *InstanceA\Field\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    If General\SecondaryInstance = #True And P_InstanceCameFrom = #CAME_FROM_SECONDARY
      InstanceStyle.s = "Secondary\"
    EndIf
    
    Select Mode
        
      Case #INSTRUCTION_MODE_READ_BINARY, #INSTRUCTION_MODE_WRITE_BINARY
        FM.s = ""
        FMN.s = ""
        WS.s = "N"
        
      Case #INSTRUCTION_MODE_READ_ENCODED, #INSTRUCTION_MODE_WRITE_ENCODED
        FM = FormatFileModule(General\EncodedModule())
        FMN = General\EncodedModule()\Name
        WS = ""
        
      Case #INSTRUCTION_MODE_READ_CRYPTED, #INSTRUCTION_MODE_WRITE_CRYPTED
        FM = FormatFileModule(General\CryptedModule())
        FMN = General\CryptedModule()\Name
        WS = ""
        
    EndSelect
    
    Select Mode
        
      Case #INSTRUCTION_MODE_READ_BINARY, #INSTRUCTION_MODE_READ_ENCODED, #INSTRUCTION_MODE_READ_CRYPTED
        
        Select *InstanceA\Field\Style
            
          Case #FIELD_STYLE_ARRAY
            
            Instruction.s = DynamicArrayReDim_BinaryFile(*InstanceA\Field, TabSize, FM, P_InstanceCameFrom)
            Instruction + AddDynamicArrayOpeningLoop(*InstanceA\Field, @TabSize, P_InstanceCameFrom)
            DynamicArrayIndexList.s = BuiltDynamicArrayIndexList(*InstanceA\Field, 1)
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadByte(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_ASCII
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_UNICODE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_CHARACTER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_WORD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadWord(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadLong(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadInteger(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadQuad(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadFloat(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadDouble(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$(" + DynamicArrayIndexList + ") = " + FM + "ReadString(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + FM + "ReadString(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Instruction + DynamicArrayReDim_BinaryFile(*InstanceA\SubField(), TabSize+1, FM, P_InstanceCameFrom, *InstanceA\Field):TabSize + 1
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG 
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect 
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #Linefeed
                      TabSize - 1

                    Case #FIELD_STYLE_LIST
                      CounterName.s = *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name
                      Instruction + Comments::Tabulation(TabSize + 1) + CounterName + "_Max = " + FM + "ReadLong(FileID) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + CounterName + "ID = 0 To " + CounterName + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddElement(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG 
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect 
                      
                      Instruction + Comments::Tabulation(TabSize+1) + "Next" + #Linefeed
                      
                    Case #FIELD_STYLE_MAP
                      
                      CounterName.s = *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name
                      Instruction + Comments::Tabulation(TabSize + 1) + CounterName + "_Max = " + FM + "ReadLong(FileID) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + CounterName + "ID = 0 To " + CounterName + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddMapElement(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + DollarSign + "(), " + FM + "ReadString(FileID))" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG 
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect 
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG 
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$ = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + " = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name +  "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                             
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed

                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + AddDynamicArrayClosingLoop(*InstanceA\Field, @TabSize)
            
          Case #FIELD_STYLE_LIST
            
            CounterName.s = *InstanceA\Field\Name + "ID"
            Instruction = Comments::Tabulation(TabSize) + *InstanceA\Field\Name + "_Max = " + FM + "ReadLong(FileID) - 1" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + "For " + CounterName + " = 0 To " + *InstanceA\Field\Name + "_Max" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "AddElement(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "())" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_ASCII
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_UNICODE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_CHARACTER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_WORD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_LONG  
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$() = " + FM + "ReadString(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Instruction + DynamicArrayReDim_BinaryFile(*InstanceA\SubField(), TabSize+1, FM, P_InstanceCameFrom, *InstanceA\Field):TabSize + 1
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #Linefeed
                      TabSize - 1
                      
                    Case #FIELD_STYLE_LIST
                      CounterName.s = *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name
                      Instruction + Comments::Tabulation(TabSize+1) + CounterName + "_Max = " + FM + "ReadLong(FileID) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize+1) + "For " + CounterName + "ID = 0 To " + CounterName + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddElement(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                      
                    Case #FIELD_STYLE_MAP
                      
                      CounterName.s = *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name
                      Instruction + Comments::Tabulation(TabSize + 1) + CounterName + "_Max = " + FM + "ReadLong(FileID) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + CounterName + "ID = 0 To " + CounterName + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddMapElement(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + DollarSign + "(), " + FM + "ReadString(FileID))" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
          Case #FIELD_STYLE_MAP
            
            Instruction = Comments::Tabulation(TabSize) + *InstanceA\Field\Name + "_Max = " + FM + "ReadLong(FileID) - 1" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + "For " + *InstanceA\Field\Name + "ID = 0 To " + *InstanceA\Field\Name + "_Max" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "AddMapElement(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "(), " + FM + "ReadString(FileID))" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_ASCII
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_UNICODE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_CHARACTER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_WORD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$() = " + FM + "ReadString(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
 
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Instruction + DynamicArrayReDim_BinaryFile(*InstanceA\SubField(), TabSize+1, FM, P_InstanceCameFrom, *InstanceA\Field):TabSize + 1
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #Linefeed
                      TabSize - 1
                      
                    Case #FIELD_STYLE_LIST
                      CounterName.s = *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name
                      Instruction + Comments::Tabulation(TabSize + 1) + CounterName + "_Max = " + FM + "ReadLong(FileID) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + CounterName + "ID = 0 To " + CounterName + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddElement(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                      
                    Case #FIELD_STYLE_MAP
                      
                      CounterName.s = *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name
                      Instruction + Comments::Tabulation(TabSize + 1) + CounterName + "_Max = " + FM + "ReadLong(FileID) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + CounterName + "ID = 0 To " + CounterName + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "AddMapElement(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + DollarSign + "(), " + FM + "ReadString(FileID))" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$ = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = " + FM + "ReadString(FileID)" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                           
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
          Case #FIELD_STYLE_BASIC
            
            Instruction = ""
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadByte(FileID)"
                
              Case #FIELD_TYPE_ASCII
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadAsciiCharacter(FileID)"
                
              Case #FIELD_TYPE_UNICODE
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadUnicodeCharacter(FileID)"
                
              Case #FIELD_TYPE_CHARACTER
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadCharacter(FileID)"
                
              Case #FIELD_TYPE_WORD
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadWord(FileID)"
                
              Case #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadLong(FileID)"
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadInteger(FileID)"
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadQuad(FileID)"
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadFloat(FileID)"
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadDouble(FileID)"
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "$ = " + FM + "ReadString(FileID)"
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + " = " + FM + "ReadString(FileID)"
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize) + *InstanceA\Field\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Instruction + DynamicArrayReDim_BinaryFile(*InstanceA\SubField(), TabSize, FM, P_InstanceCameFrom, *InstanceA\Field);:TabSize + 1
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name +  "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #Linefeed
                      
                    Case #FIELD_STYLE_LIST
                      CounterName.s = *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name
                      Instruction + Comments::Tabulation(TabSize) + CounterName + "_Max = " + FM + "ReadLong(FileID) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize) + "For " + CounterName + "ID = 0 To " + CounterName + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "AddElement(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign + "())" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name +  "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                           
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize) + "Next" + #Linefeed
                      
                    Case #FIELD_STYLE_MAP
                      CounterName.s = *InstanceA\Field\Name + "_" + *InstanceA\SubField()\Name
                      Instruction + Comments::Tabulation(TabSize) + CounterName + "_Max = " + FM + "ReadLong(FileID) - 1" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize) + "For " + CounterName + "ID = 0 To " + CounterName + "_Max" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "AddMapElement(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + DollarSign + "(), " + FM + "ReadString(FileID))" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                           
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name +  "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize) + "Next" + #Linefeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$ = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name +  "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize) + #LineFeed + Comments::Tabulation(TabSize) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                         
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name +  "\" + *InstanceA\SubField()\Name +  "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize) + "Next" + #Linefeed
                        
                  EndSelect
                  
                Next
                
            EndSelect
            
          Case #FIELD_STYLE_BASIC_ARRAY
            
            Instruction = Comments::Tabulation(TabSize) + "For " + *InstanceA\Field\ArrayIndexName + " = 0 To " + *InstanceA\Field\ArraySizeLoop + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadByte(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_ASCII
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_UNICODE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_CHARACTER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadCharacter(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_WORD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadWord(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadLong(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadInteger(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadQuad(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadFloat(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadDouble(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "$[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID," + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      Instruction + DynamicArrayReDim_BinaryFile(*InstanceA\SubField(), TabSize+1, FM, P_InstanceCameFrom, *InstanceA\Field):TabSize + 1
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name +"(" + DynamicArrayIndexList2 + ") = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ") = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ") = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID," + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #Linefeed
                      TabSize - 1
                      
                    Case #FIELD_STYLE_LIST
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID," + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_MAP
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "() = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\Field\ExternModuleName + "(FileID," + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed   
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$ = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID," + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed   
                           
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadByte(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadAsciiCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadUnicodeCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadCharacter(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadWord(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadLong(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadInteger(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadQuad(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadFloat(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadDouble(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + FM + "ReadString(FileID)" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Read" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID," + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed   
                           
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #LineFeed
                      
                  EndSelect
                  
                Next 
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
        EndSelect
        
      Case #INSTRUCTION_MODE_WRITE_BINARY, #INSTRUCTION_MODE_WRITE_ENCODED, #INSTRUCTION_MODE_WRITE_CRYPTED

        Select *InstanceA\Field\Style
            
          Case #FIELD_STYLE_ARRAY
            
            Instruction.s = ""
            
            For Index = 1 To *InstanceA\Field\DynamicArrayDimensionCount
              Instruction + Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, " + DynamicArraySize(*InstanceA\Field, Str(Index)) + ")" + #TwinLineFeed
            Next 
            
            Instruction + AddDynamicArrayOpeningLoop(*InstanceA\Field, @TabSize, P_InstanceCameFrom)
            DynamicArrayIndexList.s = BuiltDynamicArrayIndexList(*InstanceA\Field, 1)
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_ASCII
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_UNICODE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_CHARACTER
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_WORD
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "$(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Write" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      TabSize + 1
                      
                      For Index = 1 To *InstanceA\SubField()\DynamicArrayDimensionCount
                        Instruction + Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, " + DynamicArraySize(*InstanceA\SubField(), Str(Index), P_InstanceCameFrom, *InstanceA\Field) + ")" + #TwinLineFeed
                      Next 
                      
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                      TabSize - 1 
                      
                    Case #FIELD_STYLE_LIST
                      Instruction + Comments::Tabulation(TabSize+1) + FM + "WriteLong(FileID, ListSize(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()))" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                      
                    Case #FIELD_STYLE_MAP
                      Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, MapSize(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()))" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "WriteStringN(FileID, MapKey(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()))" + #LineFeed
            
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed  
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteByte" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteAsciiCharacter" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteUnicodeCharacter" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteCharacter" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteWord" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteLong" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteInteger" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteQuad" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteFloat" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteDouble" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed     
                                            
                  EndSelect
                  
                Next  

            EndSelect
            
            Instruction + AddDynamicArrayClosingLoop(*InstanceA\Field, @TabSize)
            
          Case #FIELD_STYLE_LIST
            Instruction = Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, ListSize(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()))" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_ASCII
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_UNICODE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_CHARACTER
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_WORD
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "$())" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Write" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      TabSize + 1
                      
                      For Index = 1 To *InstanceA\SubField()\DynamicArrayDimensionCount
                        Instruction + Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, " + DynamicArraySize(*InstanceA\SubField(), Str(Index)) + ")" + #TwinLineFeed
                      Next 
                      
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)

                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                      TabSize - 1 
                      
                    Case #FIELD_STYLE_LIST
                      Instruction + Comments::Tabulation(TabSize+1) + FM + "WriteLong(FileID, ListSize(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()))" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                           
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed    
                      
                    Case #FIELD_STYLE_MAP
                      Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, MapSize(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()))" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "WriteStringN(FileID, MapKey(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()))" + #LineFeed
            
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                           
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                           
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteByte" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteAsciiCharacter" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteUnicodeCharacter" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteCharacter" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteWord" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteLong" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteInteger" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteQuad" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteFloat" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteDouble" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " +  InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "])" + #LineFeed
                           
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed     

                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
          Case #FIELD_STYLE_MAP
            
            Instruction = Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, MapSize(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()))" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "WriteStringN(FileID, MapKey(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()))" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_ASCII
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_UNICODE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_CHARACTER
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_WORD
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "$())" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Write" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      TabSize + 1
                      
                      For Index = 1 To *InstanceA\SubField()\DynamicArrayDimensionCount
                        Instruction + Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, " + DynamicArraySize(*InstanceA\SubField(), Str(Index)) + ")" + #TwinLineFeed
                      Next 
                      
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                      TabSize - 1 
                      
                    Case #FIELD_STYLE_LIST
                      Instruction + Comments::Tabulation(TabSize+1) + FM + "WriteLong(FileID, ListSize(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()))" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                      
                    Case #FIELD_STYLE_MAP
                      Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, MapSize(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()))" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "WriteStringN(FileID, MapKey(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()))" + #LineFeed
            
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                           
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                              
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                            
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed    
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
          Case #FIELD_STYLE_BASIC
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_ASCII
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_UNICODE
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_CHARACTER
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_WORD
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_LONG                
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "$)"
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")"
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize) + *InstanceA\Field\ExternModuleName + "::Write" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + ")" 
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY

                      For Index = 1 To *InstanceA\SubField()\DynamicArrayDimensionCount
                        Instruction + Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, " + DynamicArraySize(*InstanceA\SubField(), Str(Index)) + ")" + #TwinLineFeed
                      Next 
                      
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed

                    Case #FIELD_STYLE_LIST
                      Instruction + Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, ListSize(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()))" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                       
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed
                      
                    Case #FIELD_STYLE_MAP
                      Instruction + Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, MapSize(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()))" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "WriteStringN(FileID, MapKey(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()))" + #LineFeed
            
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$())" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "]))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize) + "Next" + #Linefeed    
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
          Case #FIELD_STYLE_BASIC_ARRAY
            
            Instruction + Comments::Tabulation(TabSize) + "For " + *InstanceA\Field\ArrayIndexName + " = 0 To " + *InstanceA\Field\ArraySizeLoop + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_ASCII
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_UNICODE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_CHARACTER
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_WORD
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_LONG
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_INTEGER
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_STRING01
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "$[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                
              Case #FIELD_TYPE_MODULE
                Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Write" + FMN + *InstanceA\Field\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
                 
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_ARRAY
                      
                      For Index = 1 To *InstanceA\SubField()\DynamicArrayDimensionCount
                        Instruction + Comments::Tabulation(TabSize) + FM + "WriteLong(FileID, " + DynamicArraySize(*InstanceA\SubField(), Str(Index)) + ")" + #TwinLineFeed
                      Next 
                      
                      Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                      DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + "))" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                      TabSize - 1 
                      
                    Case #FIELD_STYLE_LIST
                      Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, ListSize(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()))" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                      
                    Case #FIELD_STYLE_MAP
                      Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, MapSize(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()))" + #TwinLineFeed
                      Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      Instruction + Comments::Tabulation(TabSize + 2) + "WriteStringN(FileID, MapKey(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()))" + #LineFeed
             
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "())" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$)" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed
                          
                      EndSelect
                      
                    Case #FIELD_STYLE_BASIC_ARRAY
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteByte(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_ASCII
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteAsciiCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_UNICODE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteUnicodeCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_CHARACTER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteCharacter(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_WORD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteWord(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_LONG
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteLong(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_INTEGER
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteInteger(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteQuad(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteFloat(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteDouble(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + FM + "WriteString" + WS + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                        Case #FIELD_TYPE_MODULE
                          Instruction + Comments::Tabulation(TabSize + 2) + *InstanceA\SubField()\ExternModuleName + "::Write" + FMN + *InstanceA\SubField()\ExternModuleName + "(FileID, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName +  "])" + #LineFeed
                          
                      EndSelect
                      
                      Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed    
                      
                  EndSelect
                  
                Next 
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
        EndSelect
        
    EndSelect
    
    If Mode = #INSTRUCTION_MODE_READ_CRYPTED Or Mode = #INSTRUCTION_MODE_WRITE_CRYPTED
      Instruction = ReplaceString(Instruction, "FileID", "FileID, P_Key")
    EndIf
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s MethodBinaryFile(P_MethodID.l, P_Mode.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + General\InstanceID + " = -1"
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + General\InstanceID + " = " + #EmptyString
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    If General\SecondaryInstance = #True And P_InstanceCameFrom = #CAME_FROM_SECONDARY
      InstanceStyle.s = "Secondary\"
    EndIf
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0
            Output.s = Comments::Tabulation(1) + "Declare Read" + General\ModuleName + "(FileID.i" + ExtraParam + ")" + #LineFeed
            
          Case 1
            Output.s = Comments::Tabulation(1) + "Declare Write" + General\ModuleName + "(FileID.i" + ExtraParam + ")" + #LineFeed
            
          Case 2
            Output.s = Comments::Tabulation(1) + "Declare Create" + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #LineFeed
            
          Case 3
            Output.s = Comments::Tabulation(1) + "Declare Open" + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #LineFeed
            
          Case 4
            Output.s = Comments::Tabulation(1) + "Declare Read" + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #LineFeed
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0
            
            Output.s = Comments::Tabulation(1) + "Procedure Read" + General\ModuleName + "(FileID.i" + ExtraParam + ")" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(2) + #LineFeed
                  EndIf 
                  
                  Output + InstructionBinaryFile(Primary(), 2, #INSTRUCTION_MODE_READ_BINARY, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(2) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                
                Output + #LineFeed 
                Output2.s = ""
                Output3.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(4) + #LineFeed
                    Output3 + Comments::Tabulation(3) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionBinaryFile(Primary(), 4, #INSTRUCTION_MODE_READ_BINARY, #CAME_FROM_PRIMARY) + #LineFeed
                  Output3 + InstructionBinaryFile(Primary(), 3, #INSTRUCTION_MODE_READ_BINARY, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(4) + #LineFeed
                    Output3 + Comments::Tabulation(3) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(2) + "If P_InstanceID = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If P_Index = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If P_Name = "  + #EmptyString + #TwinLineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(3) + "Instance_Max = ReadLong(FileID) - 1" + #TwinLineFeed
                Output + Comments::Tabulation(3) + "For InstanceID = 0 to Instance_Max" + #TwinLineFeed
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX 
                    Output + Comments::Tabulation(4) + "AddElement(Instances())" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(4) + "AddMapElement(Instances(), ReadString(FileID))" + #LineFeed
                    
                EndSelect

                Output + OutPut2
                Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed

                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) = -1" + #LineFeed
                    Output + Comments::Tabulation(4) + "AddElement(Instances())" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX 
                    Output + Comments::Tabulation(3) + "If Not SelectElement(Instances(), P_Index)" + #LineFeed
                    Output + Comments::Tabulation(4) + "AddElement(Instances())" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If Not FindMapElement(Instances(), P_Name)" + #LineFeed
                    Output + Comments::Tabulation(4) + "AddMapElement(Instances(), P_Name)" + #LineFeed
                    
                EndSelect

                Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
                Output + OutPut3
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + InstructionBinaryFile(Secondary(), 2, #INSTRUCTION_MODE_READ_BINARY, #CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
          Case 1
            
            Output.s = Comments::Tabulation(1) + "Procedure Write" + General\ModuleName + "(FileID.i" + ExtraParam + ")" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(2) + #LineFeed
                  EndIf 
                  
                  Output + InstructionBinaryFile(Primary(), 2, #INSTRUCTION_MODE_WRITE_BINARY, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(2) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                
                Output + #LineFeed 
                Output2.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionBinaryFile(Primary(), 4, #INSTRUCTION_MODE_WRITE_BINARY, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next

                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = -1" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "WriteLong(FileID, ListSize(Instances()))" + #TwinLineFeed

                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = " + #EmptyString + #TwinLineFeed
                    Output + Comments::Tabulation(3) + "WriteLong(FileID, MapSize(Instances()))" + #TwinLineFeed
                    
                EndSelect 
                
                Output + Comments::Tabulation(3) + "Foreach Instances()" + #LineFeed
                Output + OutPut2
                Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed

                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX 
                    Output + Comments::Tabulation(3) + "If SelectElement(Instances(), P_Index)" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                    
                EndSelect 

                Output + OutPut2
                Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + InstructionBinaryFile(Secondary(), 2, #INSTRUCTION_MODE_WRITE_BINARY, #CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
          Case 2,3,4
            
            If P_MethodID = 2
              Output = Comments::Tabulation(1) + "Procedure Create" + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "FileHandle = CreateFile(FileID, P_FileName)" + #TwinLineFeed
            ElseIf P_MethodID = 3
              Output = Comments::Tabulation(1) + "Procedure Open" + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "FileHandle = OpenFile(FileID, P_FileName)" + #TwinLineFeed
            ElseIf P_MethodID = 4
              Output = Comments::Tabulation(1) + "Procedure Read" + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "FileHandle = ReadFile(FileID, P_FileName)" + #TwinLineFeed
            EndIf
            
            Output + Comments::Tabulation(2) + "If FileID = #PB_Any" + #LineFeed
            Output + Comments::Tabulation(3) + "FileID = FileHandle" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If IsFile(FileID) <> 0" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(3) + #LineFeed
                  EndIf 
                  
                  If P_MethodID = 2
                    Output + InstructionBinaryFile(Primary(), 3, #INSTRUCTION_MODE_WRITE_BINARY, #CAME_FROM_PRIMARY) + #LineFeed
                  ElseIf P_MethodID = 3 Or P_MethodID = 4
                    Output + InstructionBinaryFile(Primary(), 3, #INSTRUCTION_MODE_READ_BINARY, #CAME_FROM_PRIMARY) + #LineFeed
                  EndIf
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(3) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                
                Output + #LineFeed 
                Output2.s = ""
                Output3.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    
                    Output2 + Comments::Tabulation(5) + #LineFeed
                    
                    If P_MethodID = 3 Or P_MethodID = 4
                      Output3 + Comments::Tabulation(4) + #LineFeed
                    EndIf
                    
                  EndIf 
                  
                  If P_MethodID = 2
                    Output2 + InstructionBinaryFile(Primary(), 5, #INSTRUCTION_MODE_WRITE_BINARY, #CAME_FROM_PRIMARY) + #LineFeed
                  ElseIf P_MethodID = 3 Or P_MethodID = 4
                    Output2 + InstructionBinaryFile(Primary(), 5, #INSTRUCTION_MODE_READ_BINARY, #CAME_FROM_PRIMARY) + #LineFeed
                    Output3 + InstructionBinaryFile(Primary(), 4, #INSTRUCTION_MODE_READ_BINARY, #CAME_FROM_PRIMARY) + #LineFeed
                  EndIf
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    
                    Output2 + Comments::Tabulation(5) + #LineFeed
                    
                    If P_MethodID = 3 Or P_MethodID = 4
                      Output3 + Comments::Tabulation(4) + #LineFeed
                    EndIf
                    
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                If P_MethodID = 2
                  
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX 
                    Output + Comments::Tabulation(3) + "If " + StringField(General\InstanceID, 1, ".") + " = -1" + #TwinLineFeed
                    Output + Comments::Tabulation(4) + "WriteLong(FileID, ListSize(Instances()))" + #TwinLineFeed

                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If " + StringField(General\InstanceID, 1, ".") + " = " + #EmptyString + #TwinLineFeed
                    Output + Comments::Tabulation(4) + "WriteLong(FileID, MapSize(Instances()))" + #TwinLineFeed
                    
                EndSelect 

                  Output + Comments::Tabulation(4) + "Foreach Instances()" + #LineFeed
                  Output + OutPut2
                  Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed
                  Output + Comments::Tabulation(3) + "Else" + #TwinLineFeed
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID
                      Output + Comments::Tabulation(4) + "If SearchInstances(P_InstanceID) <> -1" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX 
                      Output + Comments::Tabulation(4) + "If SelectElement(Instances(), P_Index)" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(4) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                      
                  EndSelect 
                  
                  Output + OutPut2
                  Output + Comments::Tabulation(4) + "EndIf" + #TwinLineFeed
                  
                  If General\SecondaryInstance = #False
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                  Else
                    Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
                  EndIf
                  
                ElseIf P_MethodID = 3 Or P_MethodID = 4
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID
                      Output + Comments::Tabulation(3) + "If P_InstanceID = -1" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX 
                      Output + Comments::Tabulation(3) + "If P_Index = -1" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(3) + "If P_Name = " + #EmptyString + #TwinLineFeed
                      
                  EndSelect 

                  Output + Comments::Tabulation(4) + "Instance_Max = ReadLong(FileID) - 1" + #TwinLineFeed
                  Output + Comments::Tabulation(4) + "For InstanceID = 0 to Instance_Max" + #TwinLineFeed
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX 
                      Output + Comments::Tabulation(5) + "AddElement(Instances())" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(5) + "AddMapElement(Instances(), ReadString(FileID))" + #LineFeed
                      
                  EndSelect
                  
                  Output + OutPut2
                  Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed
                  Output + Comments::Tabulation(3) + "Else" + #TwinLineFeed
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID
                      Output + Comments::Tabulation(4) + "If SearchInstances(P_InstanceID) = -1" + #LineFeed
                      Output + Comments::Tabulation(5) + "AddElement(Instances())" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX 
                      Output + Comments::Tabulation(4) + "If Not SelectElement(Instances(), P_Index)" + #LineFeed
                      Output + Comments::Tabulation(5) + "AddElement(Instances())" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(4) + "If Not FindMapElement(P_InstanceID) = -1" + #LineFeed
                      Output + Comments::Tabulation(5) + "AddMapElement(Instances(), P_Name)" + #LineFeed
                      
                  EndSelect 
                  
                  Output + Comments::Tabulation(4) + "EndIf" + #LineFeed
                  Output + OutPut3
                  
                  If General\SecondaryInstance = #False
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                  Else
                    Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
                  EndIf
                  
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(3) + #LineFeed
                EndIf 
                
                If P_MethodID = 2
                  Output + InstructionBinaryFile(Secondary(), 3, #INSTRUCTION_MODE_WRITE_BINARY, #CAME_FROM_SECONDARY) + #LineFeed
                ElseIf P_MethodID = 3 Or P_MethodID = 4
                  Output + InstructionBinaryFile(Secondary(), 3, #INSTRUCTION_MODE_READ_BINARY, #CAME_FROM_SECONDARY) + #LineFeed
                EndIf
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(3) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
            Output + Comments::Tabulation(3) + "CloseFile(FileID)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
        EndSelect
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s MethodEncodedFile(P_MethodID.l, P_Mode.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + General\InstanceID + " = -1"
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + General\InstanceID + " = " + #EmptyString
        
      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
        
    EndSelect
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0
            Output.s = Comments::Tabulation(1) + "Declare Read" + General\EncodedModule()\Name + General\ModuleName + "(FileID.i" + ExtraParam + ")" + #LineFeed
            
          Case 1
            Output.s = Comments::Tabulation(1) + "Declare Write" + General\EncodedModule()\Name + General\ModuleName + "(FileID.i" + ExtraParam + ")" + #LineFeed
            
          Case 2
            Output.s = Comments::Tabulation(1) + "Declare Create" + General\EncodedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #LineFeed
            
          Case 3
            Output.s = Comments::Tabulation(1) + "Declare Open" + General\EncodedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #LineFeed
            
          Case 4
            Output.s = Comments::Tabulation(1) + "Declare Read" + General\EncodedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #LineFeed
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0
            Output.s = Comments::Tabulation(1) + "Procedure Read" + General\EncodedModule()\Name + General\ModuleName + "(FileID.i" + ExtraParam + ")" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(2) + #LineFeed
                  EndIf 
                  
                  Output + InstructionBinaryFile(Primary(), 2, #INSTRUCTION_MODE_READ_ENCODED,0) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(2) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                Output + #LineFeed 
                Output2.s = ""
                Output3.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(4) + #LineFeed
                    Output3 + Comments::Tabulation(3) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionBinaryFile(Primary(), 4, #INSTRUCTION_MODE_READ_ENCODED,0) + #LineFeed
                  Output3 + InstructionBinaryFile(Primary(), 3, #INSTRUCTION_MODE_READ_ENCODED,0) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(4) + #LineFeed
                    Output3 + Comments::Tabulation(3) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = " + #EmptyString + #TwinLineFeed
                    
                EndSelect
                  
                Output + Comments::Tabulation(3) + "Instance_Max = " + FormatFileModule(General\EncodedModule()) + "ReadLong(FileID) - 1" + #TwinLineFeed
                Output + Comments::Tabulation(3) + "For InstanceID = 0 to Instance_Max" + #TwinLineFeed

                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(4) + "AddElement(Instances())"
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(4) + "AddMapElement(Instances(), " + FormatFileModule(General\EncodedModule()) + "ReadString(FileID))"
                    
                EndSelect

                Output + OutPut2
                Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed

                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) = -1" + #LineFeed
                    Output + Comments::Tabulation(4) + "AddElement(Instances())" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(3) + "If Not SelectElement(Instances(), P_Index)" + #LineFeed
                    Output + Comments::Tabulation(4) + "AddElement(Instances())" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If Not FindMapElement(Instances(), P_Name)" + #LineFeed
                    Output + Comments::Tabulation(4) + "AddMapElement(Instances(), P_Name)" + #LineFeed
                    
                EndSelect

                Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
                Output + OutPut3
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + InstructionBinaryFile(Secondary(), 2, #INSTRUCTION_MODE_READ_ENCODED, #CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
            
          Case 1
            Output.s = Comments::Tabulation(1) + "Procedure Write" + General\EncodedModule()\Name + General\ModuleName + "(FileID.i" + ExtraParam + ")" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(2) + #LineFeed
                  EndIf 
                  
                  Output + InstructionBinaryFile(Primary(), 2, #INSTRUCTION_MODE_WRITE_ENCODED,0) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(2) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                
                Output + #LineFeed 
                Output2.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionBinaryFile(Primary(), 4, #INSTRUCTION_MODE_WRITE_ENCODED,0) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = -1" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + FormatFileModule(General\EncodedModule()) + "WriteLong(FileID, ListSize(Instances()))" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = " + #EmptyString + #TwinLineFeed
                    Output + Comments::Tabulation(3) + FormatFileModule(General\EncodedModule()) + "WriteLong(FileID, MapSize(Instances()))" + #TwinLineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(3) + "Foreach Instances()" + #LineFeed
                Output + OutPut2
                Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX 
                    Output + Comments::Tabulation(3) + "If SelectElement(Instances(), P_Index)" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                    
                EndSelect 
                
                Output + OutPut2
                Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + InstructionBinaryFile(Secondary(), 2, #INSTRUCTION_MODE_WRITE_ENCODED, #CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
          Case 2, 3, 4
            
            If P_MethodID = 2
              Output.s = Comments::Tabulation(1) + "Procedure Create" + General\EncodedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "FileHandle = CreateFile(FileID, P_FileName)" + #TwinLineFeed
            ElseIf P_MethodID = 3
              Output.s = Comments::Tabulation(1) + "Procedure Open" + General\EncodedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "FileHandle = OpenFile(FileID, P_FileName)" + #TwinLineFeed
            ElseIf P_MethodID = 4
              Output.s = Comments::Tabulation(1) + "Procedure Read" + General\EncodedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s" + ExtraParam + ")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "FileHandle = ReadFile(FileID, P_FileName)" + #TwinLineFeed
            EndIf
            
            Output + Comments::Tabulation(2) + "If FileID = #PB_Any" + #LineFeed
            Output + Comments::Tabulation(3) + "FileID = FileHandle" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If IsFile(FileID) <> 0" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(3) + #LineFeed
                  EndIf 
                  
                  If P_MethodID = 2
                    Output + InstructionBinaryFile(Primary(), 3, #INSTRUCTION_MODE_WRITE_ENCODED,0) + #LineFeed
                  ElseIf P_MethodID = 3 Or P_MethodID = 4
                    Output + InstructionBinaryFile(Primary(), 3, #INSTRUCTION_MODE_READ_ENCODED,0) + #LineFeed
                  EndIf
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(3) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                Output + #LineFeed 
                Output2.s = ""
                Output3.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(5) + #LineFeed
                    Output3 + Comments::Tabulation(4) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionBinaryFile(Primary(), 5, #INSTRUCTION_MODE_READ_ENCODED,0) + #LineFeed
                  Output3 + InstructionBinaryFile(Primary(), 4, #INSTRUCTION_MODE_READ_ENCODED,0) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(5) + #LineFeed
                    Output3 + Comments::Tabulation(4) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(3) + "If " + StringField(General\InstanceID, 1, ".") + " = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If " + StringField(General\InstanceID, 1, ".") + " = " + #EmptyString + #TwinLineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(4) + "Instance_Max = " + FormatFileModule(General\EncodedModule()) + "ReadLong(FileID) - 1" + #TwinLineFeed
                Output + Comments::Tabulation(4) + "For InstanceID = 0 to Instance_Max" + #TwinLineFeed
  
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(5) + "AddElement(Instances())"
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(5) + "AddMapElement(Instances(), " + FormatFileModule(General\EncodedModule()) + "ReadString(FileID))"
                    
                EndSelect
                
                Output + OutPut2
                Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(3) + "Else" + #TwinLineFeed
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(4) + "If SearchInstances(P_InstanceID) = -1" + #LineFeed
                    Output + Comments::Tabulation(5) + "AddElement(Instances())" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(4) + "If Not SelectElement(Instances(), P_Index)" + #LineFeed
                    Output + Comments::Tabulation(5) + "AddElement(Instances())" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(4) + "If Not FindMapElement(Instances(), P_Name)" + #LineFeed
                    Output + Comments::Tabulation(5) + "AddMapElement(Instances())" + #LineFeed
                    
                EndSelect
                
                Output + Comments::Tabulation(4) + "EndIf" + #LineFeed
                Output + OutPut3
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(3) + #LineFeed
                EndIf 
                
                If P_MethodID = 2
                  Output + InstructionBinaryFile(Secondary(), 3, #INSTRUCTION_MODE_WRITE_ENCODED,1) + #LineFeed
                ElseIf P_MethodID = 3 Or P_MethodID = 4
                  Output + InstructionBinaryFile(Secondary(), 3, #INSTRUCTION_MODE_READ_ENCODED,1) + #LineFeed
                EndIf
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(3) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
            Output + Comments::Tabulation(3) + "CloseFile(FileID)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            
        EndSelect
        
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s MethodCryptedFile(P_MethodID.l, P_Mode.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + General\InstanceID + " = -1"
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + General\InstanceID + " = " + #EmptyString
        
      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
        
    EndSelect
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0
            Output.s = Comments::Tabulation(1) + "Declare Read" + General\CryptedModule()\Name + General\ModuleName + "(FileID.i, P_Key.s" + ExtraParam + ")" + #LineFeed
            
          Case 1
            Output.s = Comments::Tabulation(1) + "Declare Write" + General\CryptedModule()\Name + General\ModuleName + "(FileID.i, P_Key.s" + ExtraParam + ")" + #LineFeed
            
          Case 2
            Output.s = Comments::Tabulation(1) + "Declare Create" + General\CryptedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s, P_Key.s" + ExtraParam + ")" + #LineFeed
            
          Case 3
            Output.s = Comments::Tabulation(1) + "Declare Open" + General\CryptedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s, P_Key.s" + ExtraParam + ")" + #LineFeed
            
          Case 4
            Output.s = Comments::Tabulation(1) + "Declare Read" + General\CryptedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s, P_Key.s" + ExtraParam + ")" + #LineFeed
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0
            
            Output.s = Comments::Tabulation(1) + "Procedure Read" + General\CryptedModule()\Name + General\ModuleName + "(FileID.i, P_Key.s" + ExtraParam + ")" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(2) + #LineFeed
                  EndIf 
                  
                  Output + InstructionBinaryFile(Primary(), 2, #INSTRUCTION_MODE_READ_CRYPTED, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(2) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                Output + #LineFeed 
                Output2.s = ""
                Output3.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(4) + #LineFeed
                    Output3 + Comments::Tabulation(3) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionBinaryFile(Primary(), 4, #INSTRUCTION_MODE_READ_CRYPTED, #CAME_FROM_PRIMARY) + #LineFeed
                  Output3 + InstructionBinaryFile(Primary(), 3, #INSTRUCTION_MODE_READ_CRYPTED, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(4) + #LineFeed
                    Output3 + Comments::Tabulation(3) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(2) + "If P_InstanceID = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX 
                    Output + Comments::Tabulation(2) + "If P_Index = -1" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If P_Name = " + #EmptyString + #TwinLineFeed
                    
                EndSelect 
                
                Output + Comments::Tabulation(3) + "Instance_Max = " + FormatFileModule(General\CryptedModule()) + "ReadLong(FileID, P_Key) - 1" + #TwinLineFeed
                Output + Comments::Tabulation(3) + "For InstanceID = 0 to Instance_Max" + #TwinLineFeed

                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                    Output + Comments::Tabulation(4) + "AddElement(Instances())"
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(4) + "AddMapElement(Instances(), " + FormatFileModule(General\CryptedModule()) + "ReadString(FileID, P_Key))"
                    
                EndSelect
               
                Output + OutPut2
                Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed

                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) = -1" + #LineFeed
                    Output + Comments::Tabulation(4) + "AddElement(Instances())" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_INDEX 
                    Output + Comments::Tabulation(3) + "If Not SelectElement(Instances(), P_Index)" + #LineFeed
                    Output + Comments::Tabulation(4) + "AddElement(Instances())" + #LineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If Not FindMapElement(Instances(), P_Name)" + #LineFeed
                    Output + Comments::Tabulation(4) + "AddMapElement(Instances())" + #LineFeed
                    
                EndSelect 

                Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
                Output + OutPut3
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + InstructionBinaryFile(Secondary(), 2, #INSTRUCTION_MODE_READ_CRYPTED, #CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
          Case 1
            
            Output.s = Comments::Tabulation(1) + "Procedure Write" + General\CryptedModule()\Name + General\ModuleName + "(FileID.i, P_Key.s" + ExtraParam + ")" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(2) + #LineFeed
                  EndIf 
                  
                  Output + InstructionBinaryFile(Primary(), 2, #INSTRUCTION_MODE_WRITE_CRYPTED,0) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(2) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                
                Output + #LineFeed 
                Output2.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionBinaryFile(Primary(), 4, #INSTRUCTION_MODE_WRITE_CRYPTED,0) + #LineFeed
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next

                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX 
                    Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = -1" + #TwinLineFeed
                    Output + Comments::Tabulation(3) + FormatFileModule(General\CryptedModule()) + "WriteLong(FileID, P_Key, ListSize(Instances()))" + #TwinLineFeed
                    
                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(2) + "If " + StringField(General\InstanceID, 1, ".") + " = " + #EmptyString + #TwinLineFeed
                    Output + Comments::Tabulation(3) + FormatFileModule(General\CryptedModule()) + "WriteLong(FileID, P_Key, MapSize(Instances()))" + #TwinLineFeed
                    
                EndSelect 
                
                Output + Comments::Tabulation(3) + "Foreach Instances()" + #LineFeed
                Output + OutPut2
                Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
                Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                
                Select General\InstanceStyle
                    
                  Case #INSTANCE_STYLE_MULTIPLE_ID
                    Output + Comments::Tabulation(3) + "If SearchInstances(P_InstanceID) <> -1" + #LineFeed

                  Case #INSTANCE_STYLE_MULTIPLE_INDEX 
                    Output + Comments::Tabulation(3) + "If SelectElement(Instances(), P_Index)" + #LineFeed

                  Case #INSTANCE_STYLE_MULTIPLE_NAME
                    Output + Comments::Tabulation(3) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                    
                EndSelect 
                
                Output + OutPut2
                Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                
                If General\SecondaryInstance = #False
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                Else
                  Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + InstructionBinaryFile(Secondary(), 2, #INSTRUCTION_MODE_WRITE_CRYPTED,#CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
          Case 2, 3, 4
            
            If P_MethodID = 2
              Output.s = Comments::Tabulation(1) + "Procedure Create" + General\CryptedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s, P_Key.s" + ExtraParam + ")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "FileHandle = CreateFile(FileID, P_FileName)" + #TwinLineFeed
            ElseIf P_MethodID = 3
              Output.s = Comments::Tabulation(1) + "Procedure Open" + General\CryptedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s, P_Key.s" + ExtraParam + ")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "FileHandle = OpenFile(FileID, P_FileName)" + #TwinLineFeed
            ElseIf P_MethodID = 4
              Output.s = Comments::Tabulation(1) + "Procedure Read" + General\CryptedModule()\Name + General\ModuleName + "File(FileID.i, P_FileName.s, P_Key.s" + ExtraParam + ")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "FileHandle = ReadFile(FileID, P_FileName)" + #TwinLineFeed
            EndIf
            
            Output + Comments::Tabulation(2) + "If FileID = #PB_Any" + #LineFeed
            Output + Comments::Tabulation(3) + "FileID = FileHandle" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If IsFile(FileID) <> 0" + #TwinLineFeed
            
            If P_MethodID = 2
              Output  + Comments::Tabulation(3) + FormatFileModule(General\CryptedModule()) + "WriteString(FileID, P_Key, " + Chr(34) +General\CryptedModule()\Name + General\ModuleName + "File" + Chr(34) + ")"
              TabSize = 3
            ElseIf P_MethodID = 3 Or P_MethodID = 4
              TabSize = 4
              Output + Comments::Tabulation(3) + "If " + FormatFileModule(General\CryptedModule()) + "ReadString(FileID, P_Key) = " + Chr(34) +General\CryptedModule()\Name + General\ModuleName + "File" + Chr(34) + #LineFeed
            EndIf
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(TabSize) + #LineFeed
                  EndIf 
                  
                  If P_MethodID = 2
                    Output + InstructionBinaryFile(Primary(), TabSize, #INSTRUCTION_MODE_WRITE_CRYPTED,0) + #LineFeed
                  ElseIf P_MethodID = 3 Or P_MethodID = 4
                    Output + InstructionBinaryFile(Primary(), TabSize, #INSTRUCTION_MODE_READ_CRYPTED,0) + #LineFeed
                  EndIf
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(TabSize) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                
                Output + #LineFeed 
                Output2.s = ""
                Output3.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    
                    Output2 + Comments::Tabulation(5) + #LineFeed
                    
                    If P_MethodID = 3 Or P_MethodID = 4
                      Output3 + Comments::Tabulation(5) + #LineFeed
                    EndIf
                    
                  EndIf 
                  
                  If P_MethodID = 2
                    Output2 + InstructionBinaryFile(Primary(), 5, #INSTRUCTION_MODE_WRITE_CRYPTED,0) + #LineFeed
                  ElseIf P_MethodID = 3 Or P_MethodID = 4
                    Output2 + InstructionBinaryFile(Primary(), 6, #INSTRUCTION_MODE_READ_CRYPTED,0) + #LineFeed
                    Output3 + InstructionBinaryFile(Primary(), 5, #INSTRUCTION_MODE_READ_CRYPTED,0) + #LineFeed
                  EndIf
                  
                  If ListIndex(Primary()) = ListSize(Primary()) - 1
                    
                    Output2 + Comments::Tabulation(5) + #LineFeed
                    
                    If P_MethodID = 3 Or P_MethodID = 4
                      Output3 + Comments::Tabulation(5) + #LineFeed
                    EndIf
                    
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                If P_MethodID = 2
                  
                  Output + Comments::Tabulation(3) + #LineFeed 
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX 
                      Output + Comments::Tabulation(3) + "If " + StringField(General\InstanceID, 1, ".") + " = -1" + #TwinLineFeed
                      Output + Comments::Tabulation(4) + FormatFileModule(General\CryptedModule()) + "WriteLong(FileID, P_Key, ListSize(Instances()))" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(3) + "If " + StringField(General\InstanceID, 1, ".") + " = " + #EmptyString + #TwinLineFeed
                      Output + Comments::Tabulation(4) + FormatFileModule(General\CryptedModule()) + "WriteLong(FileID, P_Key, MapSize(Instances()))" + #TwinLineFeed
                      
                  EndSelect 
                  
                  Output + Comments::Tabulation(4) + "Foreach Instances()" + #LineFeed
                  Output + OutPut2
                  Output + Comments::Tabulation(4) + "Next" + #TwinLineFeed
                  Output + Comments::Tabulation(3) + "Else" + #TwinLineFeed

                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID
                      Output + Comments::Tabulation(4) + "If SearchInstances(P_InstanceID) <> -1" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(4) + "If SelectElement(Instances(), P_Index)" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME  
                      Output + Comments::Tabulation(4) + "If FindMapElement(Instances(), P_Name)" + #LineFeed
                      
                  EndSelect    

                  Output + OutPut2
                  Output + Comments::Tabulation(4) + "EndIf" + #TwinLineFeed
                  
                  If General\SecondaryInstance = #False
                    Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
                  Else
                    Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
                  EndIf
                  
                ElseIf P_MethodID = 3 Or P_MethodID = 4
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX 
                      Output + Comments::Tabulation(4) + "If " + StringField(General\InstanceID, 1, ".") + " = -1" + #TwinLineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(4) + "If " + StringField(General\InstanceID, 1, ".") + " = " + #EmptyString + #TwinLineFeed
                      
                  EndSelect 
       
                  Output + Comments::Tabulation(5) + "Instance_Max = " + FormatFileModule(General\CryptedModule()) + "ReadLong(FileID, P_Key) - 1" + #TwinLineFeed
                  Output + Comments::Tabulation(5) + "For InstanceID = 0 to Instance_Max" + #TwinLineFeed
                  
                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(6) + "AddElement(Instances())"
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME
                      Output + Comments::Tabulation(6) + "AddMapElement(Instances(), " + FormatFileModule(General\CryptedModule()) + "ReadString(FileID, P_Key))"
                      
                  EndSelect
                  
                  Output + OutPut2
                  Output + Comments::Tabulation(5) + "Next" + #TwinLineFeed
                  Output + Comments::Tabulation(4) + "Else" + #TwinLineFeed

                  Select General\InstanceStyle
                      
                    Case #INSTANCE_STYLE_MULTIPLE_ID
                      Output + Comments::Tabulation(5) + "If SearchInstances(P_InstanceID) = -1" + #LineFeed
                      Output + Comments::Tabulation(6) + "AddElement(Instances())" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_INDEX
                      Output + Comments::Tabulation(5) + "If Not SelectElement(P_Index)" + #LineFeed
                      Output + Comments::Tabulation(6) + "AddElement(Instances())" + #LineFeed
                      
                    Case #INSTANCE_STYLE_MULTIPLE_NAME  
                      Output + Comments::Tabulation(5) + "If Not FindMapElement(P_Name) = -1" + #LineFeed
                      Output + Comments::Tabulation(6) + "AddMapElement(Instances(), P_Name)" + #LineFeed
                      
                  EndSelect    

                  Output + Comments::Tabulation(5) + "EndIf" + #LineFeed
                  Output + OutPut3
                  
                  If General\SecondaryInstance = #False
                    Output + Comments::Tabulation(4) + "EndIf" + #TwinLineFeed
                  Else
                    Output + Comments::Tabulation(4) + "EndIf" + #LineFeed
                  EndIf
                  
                EndIf
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(4) + #LineFeed
                EndIf 
                
                If P_MethodID = 2
                  Output + InstructionBinaryFile(Secondary(), 3, #INSTRUCTION_MODE_WRITE_CRYPTED, #CAME_FROM_SECONDARY) + #LineFeed
                ElseIf P_MethodID = 3 Or P_MethodID = 4
                  Output + InstructionBinaryFile(Secondary(), 4, #INSTRUCTION_MODE_READ_CRYPTED, #CAME_FROM_SECONDARY) + #LineFeed
                EndIf
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(4) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
            If P_MethodID = 3 Or P_MethodID = 4
              Output + Comments::Tabulation(4) + "Success = #True" + #TwinLineFeed
              Output + Comments::Tabulation(3) + "Else" + #TwinLineFeed
              Output + Comments::Tabulation(4) + "Success = #False" + #TwinLineFeed
              Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
            EndIf
            
            Output + Comments::Tabulation(3) + "CloseFile(FileID)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            
            If P_MethodID = 3 Or P_MethodID = 4
              Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
            EndIf
            
        EndSelect
        
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< XMLFile Support Instruction <<<<<
  
  Procedure.s InstructionXMLFile(*InstanceA.Instance, TabSize.b, Mode.b, InstanceCameFrom.b)
    
    If *InstanceA\Field\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        ExtraParam1.s = ""
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + General\InstanceID + " = -1"
        ExtraParam1.s = StringField(General\InstanceID, 1, ".") + ", "
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + General\InstanceID + " = " + #EmptyString
        ExtraParam1.s = StringField(General\InstanceID, 1, ".") + ", "
        InstanceStyle.s = "Instances()\"
        
        
      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
        ExtraParam1.s = "*" + General\ModuleName + "A, "
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    If General\SecondaryInstance = #True And InstanceCameFrom = 1
      ExtraParam.s = ""
      ExtraParam1.s = ""
      InstanceStyle.s = "Secondary\"
    EndIf
    
    Select Mode
        
      Case #INSTRUCTION_MODE_XML_SET_ATTRIB
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Input.s = Chr(34) + *InstanceA\Field\Name + Chr(34) + ", Str(" + InstanceStyle + *InstanceA\Field\Name + ")"
            
          Case #FIELD_TYPE_FLOAT
            Input = Chr(34) + *InstanceA\Field\Name + Chr(34) + ", StrF(" + InstanceStyle + *InstanceA\Field\Name +", 14)"
            
          Case #FIELD_TYPE_DOUBLE
            Input = Chr(34) + *InstanceA\Field\Name + Chr(34) + ", StrD(" + InstanceStyle + *InstanceA\Field\Name +  ", 25)"
            
          Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
            Input = Chr(34) + *InstanceA\Field\Name + Chr(34) + ", " + InstanceStyle + *InstanceA\Field\Name + DollarSign 
            
        EndSelect
        
      Case #INSTRUCTION_MODE_XML_GET_ATTRIB  
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Output.s = " = Val("
            
          Case #FIELD_TYPE_FLOAT
            Output = " = ValF("
            
          Case #FIELD_TYPE_DOUBLE
            Output = " = ValD("
            
          Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
            Output = " = " 
            
        EndSelect
        
    EndSelect
    
    Instruction.s = ""
    
    Select Mode 
        
      Case #INSTRUCTION_MODE_XML_SET_NODE
        
        Select *InstanceA\Field\Style
            
          Case #FIELD_STYLE_ARRAY
            
            Instruction = Comments::Tabulation(TabSize) + "FieldNode = CreateXMLNode(ModuleNode, " + Chr(34) + *InstanceA\Field\Name + Chr(34) + ")" + #TwinLineFeed
            
            For Index = 1 To *InstanceA\Field\DynamicArrayDimensionCount
              Instruction + Comments::Tabulation(TabSize) + "SetXMLAttribute(FieldNode, " + Chr(34) + *InstanceA\Field\Name + "_Max_" + Str(Index) + "D" + Chr(34) + ", Str(" + DynamicArraySize(*InstanceA\Field, Str(Index)) + "))" + #LineFeed
            Next 
            
            Instruction + #LineFeed + AddDynamicArrayOpeningLoop(*InstanceA\Field, @TabSize)
            Instruction + Comments::Tabulation(TabSize + 1) + "IndexNode = CreateXMLNode(FieldNode, " + Chr(34) + *InstanceA\Field\Name + "_Index" + Chr(34) + ")" + #LineFeed
            
            For Index = *InstanceA\Field\DynamicArrayDimensionCount To 1 Step -1 
              Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLAttribute(IndexNode, " + Chr(34) + *InstanceA\Field\DynamicArrayDimensionIndexName[Index-1] + Chr(34) + ", Str(" + *InstanceA\Field\DynamicArrayDimensionIndexName[Index-1] + ")" + #LineFeed
            Next 
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, Str(" + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + "))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrF(" + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + ", 14))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrD(" + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + ", 25))" + #LineFeed                  
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + DollarSign + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + ")" + #LineFeed                  
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, Str(" + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + "\" + *InstanceA\SubField()\Name + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrF(" + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + "\" + *InstanceA\SubField()\Name + ", 14))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrD(" + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) +  "\" + *InstanceA\SubField()\Name + ", 25))" + #LineFeed                  
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) +  "\" + *InstanceA\SubField()\Name + "$)" + #LineFeed                  
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) +  "\" + *InstanceA\SubField()\Name + ")" + #LineFeed                  
                          
                      EndSelect
                      
                  EndSelect
                  
                Next
 
            EndSelect
            
            Instruction + AddDynamicArrayClosingLoop(*InstanceA\Field, @TabSize)
            
          Case #FIELD_STYLE_LIST
            Instruction + Comments::Tabulation(TabSize) + "FieldNode = CreateXMLNode(ModuleNode, " + Chr(34) + *InstanceA\Field\Name + Chr(34) + ")" + #LineFeed
            Instruction + Comments::Tabulation(TabSize) + "SetXMLAttribute(FieldNode, " + Chr(34) + "ElementCount" + Chr(34) +", Str(ListSize(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()))" + #TwinLineFeed
            
            Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "IndexNode = CreateXMLNode(FieldNode, " + Chr(34) + "Element" + Chr(34) + ")" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLAttribute(IndexNode, " + Chr(34) + "ID" + Chr(34) + ", Str(ListIndex(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()))" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, Str(" + InstanceStyle + *InstanceA\Field\Name + "()))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrF(" + InstanceStyle + *InstanceA\Field\Name + "(), 14))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrD(" + InstanceStyle + *InstanceA\Field\Name + "(), 25))" + #LineFeed                  
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "())" + #LineFeed                  
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, Str(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrF(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ", 14))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrD(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ", 25))" + #LineFeed                  
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed                  
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed                  
                          
                      EndSelect
                      
                  EndSelect
                  
                Next

            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
          Case #FIELD_STYLE_MAP
            Instruction + Comments::Tabulation(TabSize) + "FieldNode = CreateXMLNode(ModuleNode, " + Chr(34) + *InstanceA\Field\Name + Chr(34) + ")" + #LineFeed
            Instruction + Comments::Tabulation(TabSize) + "SetXMLAttribute(FieldNode, " + Chr(34) + "ElementCount" + Chr(34) +", Str(MapSize(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()))" + #LineFeed
            Instruction + Comments::Tabulation(TabSize) + "ElementID.l = 0" + #TwinLineFeed
            
            Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "IndexNode = CreateXMLNode(FieldNode, " + Chr(34) + "Element" + Chr(34) + ")" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLAttribute(IndexNode, " + Chr(34) + "ID" + Chr(34) + ", Str(ElementID)) : ElementID + 1" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLAttribute(IndexNode, " + Chr(34) + "Key" + Chr(34) + ", MapKey(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "())" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, Str(" + InstanceStyle + *InstanceA\Field\Name + "()))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrF(" + InstanceStyle + *InstanceA\Field\Name + "(), 14))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrD(" + InstanceStyle + *InstanceA\Field\Name + "(), 25))" + #LineFeed                  
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "())" + #LineFeed                  
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, Str(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrF(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ", 14))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrD(" + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ", 25))" + #LineFeed                  
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$)" + #LineFeed                  
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + ")" + #LineFeed                  
                          
                      EndSelect
                      
                  EndSelect
                  
                Next

            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
          Case #FIELD_STYLE_BASIC
            Instruction = Comments::Tabulation(TabSize) + "FieldNode = CreateXMLNode(ModuleNode, " + Chr(34) + *InstanceA\Field\Name + Chr(34) + ")" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize) + "SetXMLNodeText(FieldNode, Str(" + InstanceStyle + *InstanceA\Field\Name + "))" ;+ #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize) + "SetXMLNodeText(FieldNode, StrF(" + InstanceStyle + *InstanceA\Field\Name + ", 14))" ;+ #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize) + "SetXMLNodeText(FieldNode, StrD(" + InstanceStyle + *InstanceA\Field\Name + ", 25))" ;+ #LineFeed                  
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize) + "SetXMLNodeText(FieldNode, " + InstanceStyle + *InstanceA\Field\Name + DollarSign + ")" ;+ #LineFeed                  
  
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, Str(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrF(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ", 14))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, StrD(" + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ", 25))" + #LineFeed                  
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$)" + #LineFeed                  
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(IndexNode, " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + ")" + #LineFeed                  
                          
                      EndSelect
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
          Case #FIELD_STYLE_BASIC_ARRAY
            Instruction = Comments::Tabulation(TabSize) + "FieldNode = CreateXMLNode(ModuleNode, " + Chr(34) + *InstanceA\Field\Name + Chr(34) + ")" + #TwinLineFeed 
            Instruction + Comments::Tabulation(TabSize) + "For " + *InstanceA\Field\ArrayIndexName + " = 0 To " + *InstanceA\Field\ArraySizeLoop + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "IndexNode = CreateXMLNode(FieldNode, " + Chr(34) + *InstanceA\Field\ArrayIndexName + Chr(34) + ")" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLAttribute(IndexNode, " + Chr(34) + "ID" + Chr(34) + ", Str(" + *InstanceA\Field\ArrayIndexName + "))" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(FieldNode, Str(" + InstanceStyle + *InstanceA\Field\Name +  "[" + *InstanceA\Field\ArrayIndexName + "]))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(FieldNode, StrF(" + InstanceStyle + *InstanceA\Field\Name +  "[" + *InstanceA\Field\ArrayIndexName + "], 14))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(FieldNode, StrD(" + InstanceStyle + *InstanceA\Field\Name +  "[" + *InstanceA\Field\ArrayIndexName + "], 25))" + #LineFeed                  
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(FieldNode, " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed                  
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(FieldNode, Str(" + InstanceStyle + *InstanceA\Field\Name +  "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(FieldNode, StrF(" + InstanceStyle + *InstanceA\Field\Name +  "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ", 14))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(FieldNode, StrD(" + InstanceStyle + *InstanceA\Field\Name +  "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ", 25))" + #LineFeed                  
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(FieldNode, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$)" + #LineFeed                  
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 1) + "SetXMLNodeText(FieldNode, " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + ")" + #LineFeed                  
                                                    
                      EndSelect
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize) + "Next"
            
        EndSelect   
        
      Case #INSTRUCTION_MODE_XML_GET_NODE
        
        Instruction = Comments::Tabulation(TabSize) + "Case " + Chr(34) + *InstanceA\Field\Name + Chr(34) + #LineFeed
        
        Select *InstanceA\Field\Style
            
          Case #FIELD_STYLE_ARRAY
            For Index = 1 To *InstanceA\Field\DynamicArrayDimensionCount
              Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\Name + "_Max_" + Str(Index) + "D = " + "GetXMLAttribute(FieldNode, " + Chr(34) + *InstanceA\Field\Name + "_Max_" + Str(Index) + "D" + Chr(34) + ")" + #LineFeed
            Next 
            
            Instruction + Comments::Tabulation(TabSize + 1) + "ReDim " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "(" + BuiltDynamicArrayIndexList(*InstanceA, 3) + ")" + #Linefeed
            Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\Name + "_Index = 1" + #TwinLineFeed
            
            TabSize + 1
            Instruction + AddDynamicArrayOpeningLoop(*InstanceA\Field, @TabSize)
            Instruction + Comments::Tabulation(TabSize + 1) + "IndexNode = ChildXMLNode(FieldNode, " + *InstanceA\Field\Name + "_Index)" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "If GetXMLNodeName(IndexNode) = " + Chr(34) + *InstanceA\Field\Name + "_Index" + Chr(34) + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + " = Val(GetXMLNodeText(FieldNode))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + " = ValF(GetXMLNodeText(FieldNode))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + " = ValD(GetXMLNodeText(FieldNode))" + #LineFeed
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + DollarSign + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + " = Trim(GetXMLNodeText(FieldNode))" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + "\" + *InstanceA\SubField()\Name + " = Val(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + "\" + *InstanceA\SubField()\Name + " = ValF(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + "\" + *InstanceA\SubField()\Name + " = ValD(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + "\" + *InstanceA\SubField()\Name + "$ = Trim(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + BuiltDynamicArrayIndexList(*InstanceA\Field, 2) + "\" + *InstanceA\SubField()\Name + " = Trim(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                      EndSelect
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize + 1) + "EndIf" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\Name + "_Index + 1" + #LineFeed 
            Instruction + AddDynamicArrayClosingLoop(*InstanceA\Field, @TabSize)
            TabSize - 1
            
          Case #FIELD_STYLE_LIST
            Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\Name + "_Max = GetXMLAttribute(FieldNode, " + Chr(34) + "ElementCount" + Chr(34) +")" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\Field\Name + "ID = 1 To " + *InstanceA\Field\Name + "_Max" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 2) + "IndexNode = ChildXMLNode(FieldNode, " + *InstanceA\Field\Name + "ID)" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 2) + "If GetXMLNodeName(IndexNode) = " + Chr(34) + "Element" + Chr(34) + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 3) + "AddElement(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "())" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "() = Val(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "() = ValF(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "() = ValD(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + DollarSign + "() = Trim(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = Val(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ValF(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ValD(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$ = Trim(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = Trim(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                      EndSelect
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize + 2) + "EndIf" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "Next"
            
          Case #FIELD_STYLE_MAP
            Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\Name + "_Max = GetXMLAttribute(FieldNode, " + Chr(34) + "ElementCount" + Chr(34) +")" + #TwinLineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\Field\Name + "ID = 1 To " + *InstanceA\Field\Name + "_Max" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 2) + "IndexNode = ChildXMLNode(FieldNode, " + *InstanceA\Field\Name + "ID)" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 2) + "If GetXMLNodeName(IndexNode) = " + Chr(34) + "Element" + Chr(34) + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 3) + "AddMapElement(" + InstanceStyle + *InstanceA\Field\Name + DollarSign + "(), GetXMLAttribute(IndexNode, " + Chr(34) + "Key"+ Chr(34)+ "))" + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "() = Val(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "() = ValF(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "() = ValD(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + DollarSign + "() = Trim(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = Val(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ValF(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = ValD(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$ = Trim(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + " = Trim(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                      EndSelect
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize + 2) + "EndIf" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "Next"
            
          Case #FIELD_STYLE_BASIC
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + " = Val(GetXMLNodeText(FieldNode))"
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + " = ValF(GetXMLNodeText(FieldNode))"
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + " = ValD(GetXMLNodeText(FieldNode))"
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 1) + InstanceStyle + *InstanceA\Field\Name + DollarSign + " = Trim(GetXMLNodeText(FieldNode))"
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = Val(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = ValF(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = ValD(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$ = Trim(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 2) + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + " = Trim(GetXMLNodeText(FieldNode))" + #LineFeed
                          
                      EndSelect
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
          Case #FIELD_STYLE_BASIC_ARRAY
            Instruction + Comments::Tabulation(TabSize + 1) + "For " + *InstanceA\Field\ArrayIndexName + " = 0 To " + *InstanceA\Field\ArraySizeLoop + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 2) + "IndexNode = ChildXMLNode(FieldNode, " + *InstanceA\Field\ArrayIndexName + " + 1)" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 2) + "If GetXMLNodeName(IndexNode) = " + Chr(34) + *InstanceA\Field\ArrayIndexName + Chr(34) + #LineFeed
            
            Select *InstanceA\Field\Type
                
              Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = Val(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_FLOAT
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = ValF(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_DOUBLE
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "] = ValD(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_STRING01, #FIELD_TYPE_STRING02
                Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + DollarSign + "[" + *InstanceA\Field\ArrayIndexName + "] = Trim(GetXMLNodeText(IndexNode))" + #LineFeed
                
              Case #FIELD_TYPE_STRUCTURE
                
                ForEach *InstanceA\SubField()
                  
                  Select *InstanceA\SubField()\Style
                      
                    Case #FIELD_STYLE_BASIC
                      
                      Select *InstanceA\SubField()\Type
                          
                        Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                          Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = Val(GetXMLNodeText(IndexNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_FLOAT
                          Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = ValF(GetXMLNodeText(IndexNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_DOUBLE
                          Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = ValD(GetXMLNodeText(IndexNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING01
                          Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$ = Trim(GetXMLNodeText(IndexNode))" + #LineFeed
                          
                        Case #FIELD_TYPE_STRING02
                          Instruction + Comments::Tabulation(TabSize + 3) + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + " = Trim(GetXMLNodeText(IndexNode))" + #LineFeed
                             
                      EndSelect
                      
                  EndSelect
                  
                Next
                
            EndSelect
            
            Instruction + Comments::Tabulation(TabSize + 2) + "EndIf" + #LineFeed
            Instruction + Comments::Tabulation(TabSize + 1) + "Next"
            
        EndSelect  
        
      Case #INSTRUCTION_MODE_XML_SET_ATTRIB
        
        Select *InstanceA\Field\Style
            
          Case #FIELD_STYLE_BASIC
            Instruction = Comments::Tabulation(TabSize) + "SetXMLAttribute(CurrentNode, " + Input + ")"
            
        EndSelect    
        
      Case #INSTRUCTION_MODE_XML_GET_ATTRIB
        
        Select *InstanceA\Field\Style
            
          Case #FIELD_STYLE_BASIC
            Instruction = Comments::Tabulation(TabSize) + InstanceStyle + *InstanceA\Field\Name + DollarSign + Output + "GetXMLAttribute(CurrentNode, " + Chr(34) + *InstanceA\Field\Name + Chr(34) + "))"
            
        EndSelect    
        
    EndSelect    
    
    ProcedureReturn Instruction
  EndProcedure
  
  Procedure.s MethodXMLFile(P_MethodID.l, P_Mode.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + General\InstanceID + " = -1"
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + General\InstanceID + " = " + #EmptyString
        
      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
        
    EndSelect
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0 ; Set XML Node
            Output.s = Comments::Tabulation(1) + "Declare XML_SetNode(CurrentNode" + ExtraParam + ")" + #LineFeed
            
          Case 1 ; Get XML Node
            Output.s = Comments::Tabulation(1) + "Declare XML_GetNode(CurrentNode" + ExtraParam + ")" + #LineFeed
            
          Case 2 ; Set XML Attribute
            Output.s = Comments::Tabulation(1) + "Declare XML_SetAttribute(CurrentNode" + ExtraParam + ", NodeName.s = " + Chr(34) + General\ModuleName + Chr(34) + ")" + #LineFeed
            
          Case 3 ; Get XML Attribute
            Output.s = Comments::Tabulation(1) + "Declare XML_GetAttribute(CurrentNode" + ExtraParam + ", NodeName.s = " + Chr(34) + General\ModuleName + Chr(34) + ", Index = 1)" + #LineFeed
            
          Case 4 ; Add Attribute
            Output.s = Comments::Tabulation(1) + "Declare XML_AddAttribute(CurrentNode" + ExtraParam + ")" + #LineFeed
            
          Case 5 ; Collect Attribute
            Output.s = Comments::Tabulation(1) + "Declare XML_CollectAttribute(CurrentNode" + ExtraParam + ")" + #LineFeed
            
          Case 6
            Output.s = Comments::Tabulation(1) + "Declare XML_CreateFile(FileID.l, P_FileName.s" + ExtraParam + ")" + #LineFeed
            
          Case 7, 8
            
            If P_MethodID = 7
              CommandNamePrefix.s = "XML_Load"
              Parameter00.s = "P_FileName.s" + ExtraParam
            ElseIf P_MethodID = 8
              CommandNamePrefix = "XML_Catch"
              Parameter00 = "*Buffer, BufferSize.l" + ExtraParam
            EndIf
            
            Output.s = Comments::Tabulation(1) + "Declare " + CommandNamePrefix + "File(FileID.l, " + Parameter00 + ")" + #LineFeed
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0 ; Set XML Node
            Output.s = Comments::Tabulation(1) + "Procedure XML_SetNode(CurrentNode" + ExtraParam + ")" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If ParentXMLNode(CurrentNode) = #Null" + #LineFeed
            Output + Comments::Tabulation(3) + "ModuleNode = CreateXMLNode(CurrentNode, " + Chr(34) + General\ModuleName + Chr(34) + ")" + #LineFeed
            Output + Comments::Tabulation(2) + "Else" + #LineFeed
            Output + Comments::Tabulation(3) + "ModuleNode = CurrentNode" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #LineFeed
            
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #True
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(2) + #LineFeed
                  EndIf 
                  
                  Output + InstructionXMLFile(Primary(), 2, #INSTRUCTION_MODE_XML_SET_NODE,0) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(2) + #LineFeed
                    EndIf
                  EndIf
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #True
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf 
                
                Output + InstructionXMLFile(Secondary(), 2, #INSTRUCTION_MODE_XML_SET_NODE, 1) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(2) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
          Case 1 ; Get XML Node
            Output.s = Comments::Tabulation(1) + "Procedure XML_GetNode(CurrentNode" + ExtraParam + ")" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If ParentXMLNode(CurrentNode) = #Null" + #LineFeed
            Output + Comments::Tabulation(3) + "ModuleNode = ChildXMLNode(CurrentNode)" + #LineFeed
            Output + Comments::Tabulation(3) + "If GetXMLNodeName(ModuleNode) = " + Chr(34) + General\ModuleName + Chr(34) + #LineFeed
            Output + Comments::Tabulation(4) + "Success = #True" + #LineFeed
            Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
            Output + Comments::Tabulation(2) + "Else" + #LineFeed
            Output + Comments::Tabulation(3) + "Success = #True" + #LineFeed
            Output + Comments::Tabulation(3) + "ModuleNode = CurrentNode" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If Success = #True" + #TwinLineFeed
            Output + Comments::Tabulation(3) + "FieldNode = ChildXMLNode(ModuleNode)" + #TwinLineFeed
            Output + Comments::Tabulation(3) + "While FieldNode" + #TwinLineFeed
            Output + Comments::Tabulation(4) + "Select GetXMLNodeName(FieldNode)" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #True
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(5) + #LineFeed
                  EndIf 
                  
                  Output + InstructionXMLFile(Primary(), 5, #INSTRUCTION_MODE_XML_GET_NODE,0) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(5) + #LineFeed
                    EndIf
                  EndIf
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #True
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(5) + #LineFeed
                EndIf 
                
                Output + InstructionXMLFile(Secondary(), 5, #INSTRUCTION_MODE_XML_GET_NODE, 1) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(5) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
            Output + Comments::Tabulation(4) + "EndSelect" + #TwinLineFeed
            Output + Comments::Tabulation(4) + "FieldNode = NextXMLNode(FieldNode)" + #TwinLineFeed
            Output + Comments::Tabulation(3) + "Wend" + #TwinLineFeed  
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
            
          Case 2 ; Set XML Attribute
            Output.s = Comments::Tabulation(1) + "Procedure XML_SetAttribute(CurrentNode" + ExtraParam + ", NodeName.s = " + Chr(34) + General\ModuleName + Chr(34) + ")" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "ModuleNode = CreateXMLNode(CurrentNode, NodeName)" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                ForEach Primary()
                  
                  If Primary()\Field\Style = #FIELD_STYLE_BASIC
                    Output + ReplaceString(InstructionXMLFile(Primary(), 2, #INSTRUCTION_MODE_XML_SET_ATTRIB,0), "CurrentNode", "ModuleNode") + #LineFeed
                  EndIf
                  
                Next
                
                Output + #LineFeed
                
            EndSelect
            
          Case 3 ; Get XML Attribute
            Output.s = Comments::Tabulation(1) + "Procedure XML_GetAttribute(CurrentNode" + ExtraParam + ", NodeName.s = " + Chr(34) + General\ModuleName + Chr(34) + ", Index = 1)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "ModuleNode = ChildXMLNode(CurrentNode, Index)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If GetXMLNodeName(ModuleNode) = NodeName" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                ForEach Primary()
                  
                  If Primary()\Field\Style = #FIELD_STYLE_BASIC
                    Output + ReplaceString(InstructionXMLFile(Primary(), 3, #INSTRUCTION_MODE_XML_GET_ATTRIB,0), "CurrentNode", "ModuleNode") + #LineFeed
                  EndIf
                  
                Next
                
            EndSelect
            
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            
          Case 4 ; Add Attribute
            Output.s = Comments::Tabulation(1) + "Procedure XML_AddAttribute(CurrentNode" + ExtraParam + ")" + #TwinLineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                ForEach Primary()
                  
                  If Primary()\Field\Style = #FIELD_STYLE_BASIC
                    Output + InstructionXMLFile(Primary(), 2, #INSTRUCTION_MODE_XML_SET_ATTRIB,0) + #LineFeed
                  EndIf
                  
                Next
                
                Output + #LineFeed
                
            EndSelect
            
          Case 5 ; Collect Attribute
            Output.s = Comments::Tabulation(1) + "Procedure XML_CollectAttribute(CurrentNode" + ExtraParam + ")" + #TwinLineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                ForEach Primary()
                  
                  If Primary()\Field\Style = #FIELD_STYLE_BASIC
                    Output + InstructionXMLFile(Primary(), 2, #INSTRUCTION_MODE_XML_GET_ATTRIB,0) + #LineFeed
                  EndIf
                  
                Next
                
                Output + #LineFeed
                
            EndSelect
            
          Case 6
            Output.s = Comments::Tabulation(1) + "Procedure XML_CreateFile(FileID.l, P_FileName.s" + ExtraParam + ")" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "FileHandle = CreateXML(FileID)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If FileID = #PB_Any" + #LineFeed
            Output + Comments::Tabulation(3) + "FileID = FileHandle" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If IsXML(FileID)" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE
                Output + Comments::Tabulation(3) + "XML_SetNode(RootXMLNode(FileID))" + #LineFeed
                Output + Comments::Tabulation(3) + "; XML_SetAttribute(RootXMLNode(FileID))" + #LineFeed
                
              Case #INSTANCE_STYLE_OFF_MODULE
                Output + Comments::Tabulation(3) + "XML_SetNode(RootXMLNode(FileID), *" + General\ModuleName + "A)" + #LineFeed
                Output + Comments::Tabulation(3) + "; XML_SetAttribute(RootXMLNode(FileID), *" + General\ModuleName + "A)" + #LineFeed
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME    
                Output + Comments::Tabulation(3) + "XML_SetNode(RootXMLNode(FileID), " + General\InstanceID + ")" + #LineFeed
                
            EndSelect
            
            Output + Comments::Tabulation(3) + "FormatXML(FileID, #PB_XML_ReFormat | #PB_XML_ReIndent)" + #LineFeed
            Output + Comments::Tabulation(3) + "SaveXML(FileID, FileName)" + #LineFeed
            Output + Comments::Tabulation(3) + "FreeXML(FileID)" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            
          Case 7, 8
            
            If P_MethodID = 7
              CommandNamePrefix00.s = "XML_Load"
              CommandNamePrefix01.s = "Load"
              Parameter00.s = "FileName.s" + ExtraParam
              Parameter01.s = "FileName"
            ElseIf P_MethodID = 8
              CommandNamePrefix00 = "XML_Catch"
              CommandNamePrefix01 = "Catch"
              Parameter00 = "*Buffer, BufferSize.l" + ExtraParam
              Parameter01 = "*Buffer, BufferSize"
            EndIf
            
            Output.s = Comments::Tabulation(1) + "Procedure " + CommandNamePrefix00 + "File(FileID.l, " + Parameter00 + ")" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "FileHandle = " + CommandNamePrefix01 + "XML(FileID, " + Parameter01 + ")" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If FileID = #PB_Any" + #LineFeed
            Output + Comments::Tabulation(3) + "FileID = FileHandle" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If IsXML(FileID)" + #LineFeed
            Output + Comments::Tabulation(3) + "FormatXML(FileID, #PB_XML_CutNewline)" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE
                Output + Comments::Tabulation(3) + "XML_GetNode(RootXMLNode(FileID))" + #LineFeed
                Output + Comments::Tabulation(3) + "; XML_GetAttribute(RootXMLNode(FileID))" + #LineFeed
                
              Case #INSTANCE_STYLE_OFF_MODULE
                Output + Comments::Tabulation(3) + "XML_GetNode(RootXMLNode(FileID), *" + General\ModuleName + "A)" + #LineFeed
                Output + Comments::Tabulation(3) + ";XML_GetAttribute(RootXMLNode(FileID), *" + General\ModuleName + "A)" + #LineFeed
                                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME    
                Output + Comments::Tabulation(3) + "XML_GetNode(RootXMLNode(FileID), " + General\InstanceID + ")" + #LineFeed
                
            EndSelect
            
            Output + Comments::Tabulation(3) + "FreeXML(FileID)" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            
        EndSelect
        
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< JSONFile Support Instruction <<<<<
  
  Procedure.s MethodJSONFile(P_MethodID.l, P_Mode.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        ExtraParam.s = ""
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
        ExtraParam.s = ", " + General\InstanceID + " = -1"
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        ExtraParam.s = ", " + General\InstanceID + " = " + #EmptyString
        
      Case #INSTANCE_STYLE_OFF_MODULE
        ExtraParam.s = ", *" + General\ModuleName + "A." + General\ModuleName
        
    EndSelect
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0
            Output.s = Comments::Tabulation(1) + "Declare Create" + General\ModuleName + "JSONFile(FileID.l, FileName.s" + ExtraParam + ")" + #LineFeed
            
          Case 1
            Parameter00.s = "FileName.s" + ExtraParam
            Parameter01.s = "FileName"
            
            Output.s = Comments::Tabulation(1) + "Declare Load" + General\ModuleName + "JSONFile(FileID.l, " + Parameter00 + ")" + #LineFeed
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0 
            Output.s = Comments::Tabulation(1) + "Procedure Create" + General\ModuleName + "JSONFile(FileID.l, P_FileName.s" + ExtraParam + ")" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "FileHandle = CreateJSON(FileID, #PB_JSON_NoCase)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If FileID = #PB_Any" + #LineFeed
            Output + Comments::Tabulation(3) + "FileID = FileHandle" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If IsJSON(FileID)" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE
                Output + Comments::Tabulation(3) + "InsertJSONStructure(JSONValue(FileID), @Instance, Instance)" + #LineFeed
                
              Case #INSTANCE_STYLE_OFF_MODULE
                Output + Comments::Tabulation(3) + "InsertJSONStructure(JSONValue(FileID), *" + General\ModuleName + "A, " +  General\ModuleName + ")" + #LineFeed
 
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME    
                Output + Comments::Tabulation(3) + "InsertJSONList(JSONValue(FileID), Instances())" + #LineFeed
                
            EndSelect
            
            Output + Comments::Tabulation(3) + "SaveJSON(FileID, P_FileName, #PB_JSON_PrettyPrint)" + #LineFeed
            Output + Comments::Tabulation(3) + "FreeJSON(FileID)" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            
          Case 1
            Output.s = Comments::Tabulation(1) + "Procedure Load" + General\ModuleName + "JSONFile(FileID.l, P_FileName.s" + ExtraParam + ")" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "FileHandle = LoadJSON(FileID, P_FileName, #PB_JSON_NoCase)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If FileID = #PB_Any" + #LineFeed
            Output + Comments::Tabulation(3) + "FileID = FileHandle" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If IsJSON(FileID)" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE
                Output + Comments::Tabulation(3) + "ExtractJSONStructure(JSONValue(FileID), @Instance, Instance)" + #LineFeed
                
              Case #INSTANCE_STYLE_OFF_MODULE
                Output + Comments::Tabulation(3) + "ExtractJSONStructure(JSONValue(FileID), *" + General\ModuleName + "A, " +  General\ModuleName + ")" + #LineFeed
 
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME    
                Output + Comments::Tabulation(3) + "ExtractJSONList(JSONValue(FileID), Instances())" + #LineFeed
                
            EndSelect
            
            Output + Comments::Tabulation(3) + "FreeJSON(FileID)" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            
        EndSelect
        
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< DataBase Support Instruction <<<<<
  
  Procedure.s GenerateDatabaseTableHeader(P_Style.b, *StructA.Struct)
    
    If *StructA <> #Null
      
      Select P_Style
          
        Case 0
          
          ForEach *StructA\Fields()
            
            If FindString(*StructA\Fields(), "$")
              Name.s = Left(*StructA\Fields(), Len(*StructA\Fields())-1)
              Extension.s = "$"
            Else
              Name.s = StringField(*StructA\Fields(), 1, ".")
              Extension.s = StringField(*StructA\Fields(), 2, ".")
            EndIf
            
            If Name = "PrimaryKeyID"
              TableHeader.s + Name + " INTEGER PRIMARY KEY"
            Else
              
              Select Extension
                  
                Case "b", "a", "c", "u", "w", "l", "q", "i"
                  TableHeader + Name + " INTEGER"
                  
                Case "f", "d"
                  TableHeader + Name + " REAL"
                  
                Case "s", "$"
                  TableHeader + Name + " STRING"
                  
              EndSelect
              
            EndIf
            
            If ListIndex(*StructA\Fields()) < ListSize(*StructA\Fields()) -1 
              TableHeader + ", "
            EndIf
            
          Next
          
        Case 1
          
         ForEach *StructA\Fields() 
            
            If FindString(*StructA\Fields(), "$")
              Name.s = Left(*StructA\Fields(), Len(*StructA\Fields())-1)
            Else
              Name.s = StringField(*StructA\Fields(), 1, ".")
            EndIf
            
            If Name <> "PrimaryKeyID"
              TableHeader.s + Name 
              
              If ListIndex(*StructA\Fields()) < ListSize(*StructA\Fields()) -1 
                TableHeader + ", "
              EndIf
              
            EndIf
            
          Next
          
      EndSelect
      
    Else
      
      Select P_Style
          
        Case 0
          
          ForEach Primary()
            
            If Primary()\Field\Name = "PrimaryKeyID"
              TableHeader.s + Primary()\Field\Name + " INTEGER PRIMARY KEY"
            Else
              
              Select Primary()\Field\ExtensionShort
                  
                Case "b", "a", "c", "u", "w", "l", "q", "i"
                  TableHeader + Primary()\Field\Name + " INTEGER"
                  
                Case "f", "d"
                  TableHeader + Primary()\Field\Name + " REAL"
                  
                Case "s", "$"
                  TableHeader + Primary()\Field\Name + " STRING"
                  
              EndSelect
              
            EndIf
            
            If ListIndex(Primary()) < ListSize(Primary()) -1 
              TableHeader + ", "
            EndIf
            
          Next
          
        Case 1
          
          ForEach Primary()

            If Primary()\Field\Name <> "PrimaryKeyID"
              
              TableHeader.s + Primary()\Field\Name
              
              If ListIndex(Primary()) < ListSize(Primary()) -1 
                TableHeader + ", "
              EndIf
              
            EndIf
            
          Next
          
      EndSelect
      
    EndIf
    
    ProcedureReturn "(" + TableHeader + ")"
  EndProcedure
  
  Procedure.s GenerateCreateDatabaseTableCall(TabSize.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        
        ForEach Primary()
          
          If Primary()\Field\Style = #FIELD_STYLE_LIST
            
            If Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
              Output.s + Comments::Tabulation(TabSize) + "CreateDatabase" + Primary()\Field\Name + "Table(DatabaseID, " + Chr(34) + Primary()\Field\Name + Chr(34) + ")" + #LineFeed
            EndIf
            
          EndIf
          
        Next
        
      Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
        Output = Comments::Tabulation(TabSize) + "CreateDatabaseTable(DatabaseID, " + Chr(34) + General\ModuleName + Chr(34) + ")" + #LineFeed
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GenerateCreateDatabaseTable()
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        
        ForEach Primary()
          
          If Primary()\Field\Style = #FIELD_STYLE_LIST
            
            If Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
              SearchInternalStruct(Primary()\Field\ExtensionShort)
              Output.s + Comments::Tabulation(1) + "Procedure.b CreateDatabase" + Primary()\Field\Name + "Table(DatabaseID.l, TableName.s)" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, " + Chr(34) + "CREATE TABLE IF NOT EXISTS " + Chr(34) + " + TableName + " + Chr(34) + GenerateDatabaseTableHeader(0, General\Struct()) + Chr(34) + ")" + #LineFeed
              Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
              Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
              Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
              
            EndIf
            
          EndIf
          
        Next
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        Output.s + Comments::Tabulation(1) + "Procedure.b CreateDatabaseTable(DatabaseID.l, TableName.s)" + #TwinLineFeed
        Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, " + Chr(34) + "CREATE TABLE IF NOT EXISTS " + Chr(34) + " + TableName + " + Chr(34) + GenerateDatabaseTableHeader(0, #Null) + Chr(34) + ")" + #LineFeed
        Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
        Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
        Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GenerateInsertDatabaseEntry() 
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        
        ForEach Primary()
          
          If Primary()\Field\Style = #FIELD_STYLE_LIST
            
            If Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
              
              SearchInternalStruct(Primary()\Field\ExtensionShort)
              
              Output.s + Comments::Tabulation(1) + "Procedure.b InsertDatabase" + Primary()\Field\Name + "TableEntry(DatabaseID, TableName.s, *" + Primary()\Field\ExtensionShort + "A." + Primary()\Field\ExtensionShort +")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "Protected DatabaseRequest.s = " + Chr(34) + "INSERT INTO " + Chr(34) + " + TableName + " + Chr(34) + " " + GenerateDatabaseTableHeader(1, General\Struct()) + " VALUES ('" + Chr(34) + #LineFeed
              
              ForEach General\Struct()\Fields()
                
                If FindString(General\Struct()\Fields(), "$")
                  Name.s = Left(General\Struct()\Fields(), Len(General\Struct()\Fields())-1)
                  Extension.s = "$"
                Else
                  Name.s = StringField(General\Struct()\Fields(), 1, ".")
                  Extension.s = StringField(General\Struct()\Fields(), 2, ".")
                EndIf
                
                If Name <> "PrimaryKeyID"
                  
                  Select Extension
                      
                    Case "b", "a", "c", "u", "w", "l", "q", "i"
                      Output + Comments::Tabulation(2) + "DatabaseRequest + Str(*" + Primary()\Field\ExtensionShort + "A\" + Name + ")"
                      
                    Case "f"
                      Output + Comments::Tabulation(2) + "DatabaseRequest + StrF(*" + Primary()\Field\ExtensionShort + "A\" + Name + ", 14)"
                      
                    Case "d"
                      Output + Comments::Tabulation(2) + "DatabaseRequest + StrD(*" + Primary()\Field\ExtensionShort + "A\" + Name + ", 25)"
                      
                    Case "s"
                      Output + Comments::Tabulation(2) + "DatabaseRequest + *" + Primary()\Field\ExtensionShort + "A\" + Name
                      
                    Case "$"
                      Output + Comments::Tabulation(2) + "DatabaseRequest + *" + Primary()\Field\ExtensionShort + "A\" + Name + "$"
                      
                  EndSelect
                  
                  If ListIndex(General\Struct()\Fields()) < ListSize(General\Struct()\Fields()) - 1 
                    Output + " + " + Chr(34) + "', '" + Chr(34)  + #LineFeed
                  ElseIf ListIndex(General\Struct()\Fields()) = ListSize(General\Struct()\Fields()) - 1 
                    Output + " + " + Chr(34) + "')" + Chr(34)  + #TwinLineFeed
                  EndIf   
                  
                EndIf
                
              Next
              
              Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, DatabaseRequest)" + #LineFeed
              Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
              Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
              Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
              
            EndIf
            
          EndIf
          
        Next
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        
        Output.s + Comments::Tabulation(1) + "Procedure.b InsertDatabaseTableEntry(DatabaseID, TableName.s, *InstanceA.Instance)" + #TwinLineFeed
        Output + Comments::Tabulation(2) + "Protected DatabaseRequest.s = " + Chr(34) + "INSERT INTO " + Chr(34) + " + TableName + " + Chr(34) + " " + GenerateDatabaseTableHeader(1, #Null) + " VALUES ('" + Chr(34) + #LineFeed
        
        ForEach Primary()
          
          If Primary()\Field\Name <> "PrimaryKeyID"
            
            Select Primary()\Field\ExtensionShort
                
              Case "b", "a", "c", "u", "w", "l", "q", "i"
                Output + Comments::Tabulation(2) + "DatabaseRequest + Str(*InstanceA\" + Primary()\Field\Name + ")"
                
              Case "f"
                Output + Comments::Tabulation(2) + "DatabaseRequest + StrF(*InstanceA\" + Primary()\Field\Name + ", 14)"
                
              Case "d"
                Output + Comments::Tabulation(2) + "DatabaseRequest + StrD(*InstanceA\" + Primary()\Field\Name + ", 25)"
                
              Case "s", "$"
                Output + Comments::Tabulation(2) + "DatabaseRequest + *InstanceA\" + Primary()\Field\Name
                
            EndSelect
            
            If ListIndex(Primary()) < ListSize(Primary()) - 1 
              Output + " + " + Chr(34) + "', '" + Chr(34)  + #LineFeed
            ElseIf ListIndex(Primary()) = ListSize(Primary()) - 1 
              Output + " + " + Chr(34) + "')" + Chr(34)  + #TwinLineFeed
            EndIf   
            
          EndIf
          
        Next
        
        Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, DatabaseRequest)" + #LineFeed
        Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
        Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
        Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure 
  
  Procedure.s GenerateUpdateDatabaseEntry() 
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        
        ForEach Primary()
          
          If Primary()\Field\Style = #FIELD_STYLE_LIST
            
            If Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
              
              SearchInternalStruct(Primary()\Field\ExtensionShort)
              
              Output.s + Comments::Tabulation(1) + "Procedure.b UpdateDatabase" + Primary()\Field\Name + "TableEntry(DatabaseID, TableName.s, *" + Primary()\Field\ExtensionShort + "A." + Primary()\Field\ExtensionShort +")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "Protected DatabaseRequest.s = " + Chr(34) + "UPDATE " + Chr(34) + " + TableName + " + Chr(34)  + " SET " + Chr(34) + #LineFeed
              
              ForEach General\Struct()\Fields()
                
                If FindString(General\Struct()\Fields(), "$")
                  Name.s = Left(General\Struct()\Fields(), Len(General\Struct()\Fields())-1)
                  Extension.s = "$"
                Else
                  Name.s = StringField(General\Struct()\Fields(), 1, ".")
                  Extension.s = StringField(General\Struct()\Fields(), 2, ".")
                EndIf
                
                If Name <> "PrimaryKeyID"
                  
                  Select Extension
                      
                    Case "b", "a", "c", "u", "w", "l", "q", "i"
                      Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + Name + "='" + Chr(34) + " + Str(*" + Primary()\Field\ExtensionShort + "A\" + Name + ")"
                      
                    Case "f"
                      Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + Name + "='" + Chr(34) + " + StrF(*" + Primary()\Field\ExtensionShort + "A\" + Name + ", 14)"
                      
                    Case "d"
                      Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + Name + "='" + Chr(34) + " + StrD(*" + Primary()\Field\ExtensionShort + "A\" + Name + ", 25)"
                      
                    Case "s"
                      Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + Name + "='" + Chr(34) + " + *" + Primary()\Field\ExtensionShort + "A\" + Name
                      
                    Case "$"
                      Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + Name + "='" + Chr(34) + " + *" + Primary()\Field\ExtensionShort + "A\" + Name + "$"
                      
                  EndSelect
                  
                  If ListIndex(General\Struct()\Fields()) < ListSize(General\Struct()\Fields()) - 1 
                    Output + " + " + Chr(34) + "', '" + Chr(34)  + #LineFeed
                  ElseIf ListIndex(General\Struct()\Fields()) = ListSize(General\Struct()\Fields()) - 1 
                    Output + " + " + Chr(34) + "'" + Chr(34)  + #LineFeed
                  EndIf   
                  
                EndIf
                
              Next
              
              Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + "WHERE PrimaryKeyID='" + Chr(34) + " + Str(*" + Primary()\Field\ExtensionShort + "A\PrimaryKeyID) + " + Chr(34) + "'" + Chr(34) + #TwinLineFeed
              Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, DatabaseRequest)" + #LineFeed
              Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
              Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
              Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
              
            EndIf
            
          EndIf
          
        Next
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
   
        Output.s + Comments::Tabulation(1) + "Procedure.b UpdateDatabaseTableEntry(DatabaseID, TableName.s, *InstanceA.Instance)" + #TwinLineFeed
        Output + Comments::Tabulation(2) + "Protected DatabaseRequest.s = " + Chr(34) + "UPDATE " + Chr(34) + " + TableName + " + Chr(34)  + " SET " + Chr(34) + #LineFeed
        
        ForEach Primary()
          
          If Primary()\Field\Name <> "PrimaryKeyID"
            
            Select Primary()\Field\ExtensionShort
                
              Case "b", "a", "c", "u", "w", "l", "q", "i" 
                Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + Primary()\Field\Name + "='" + Chr(34) + " + Str(*InstanceA\" + Primary()\Field\Name + ")"
                
              Case "f"
                Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + Primary()\Field\Name + "='" + Chr(34) + " + StrF(*InstanceA\" + Primary()\Field\Name + ", 14)"
                
              Case "d"
                Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + Primary()\Field\Name + "='" + Chr(34) + " + StrD(*InstanceA\" + Primary()\Field\Name + ", 25)"
                
              Case "s", "$"
                Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + Primary()\Field\Name + "='" + Chr(34) + " + *InstanceA\" + Primary()\Field\Name
                
            EndSelect
            
            If ListIndex(Primary()) < ListSize(Primary()) - 1 
              Output + " + " + Chr(34) + "', '" + Chr(34)  + #LineFeed
            ElseIf ListIndex(Primary()) = ListSize(Primary()) - 1 
              Output + " + " + Chr(34) + "'" + Chr(34)  + #TwinLineFeed
            EndIf   
            
          EndIf
          
        Next
        
        Output + Comments::Tabulation(2) + "DatabaseRequest + " + Chr(34) + "WHERE PrimaryKeyID='" + Chr(34) + " + Str(*InstanceA\PrimaryKeyID) + " + Chr(34) + "'" + Chr(34) + #TwinLineFeed
        Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, DatabaseRequest)" + #LineFeed
        Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
        Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
        Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure 

  Procedure.s GenerateDeleteDatabaseEntry() 
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        
        ForEach Primary()
          
          If Primary()\Field\Style = #FIELD_STYLE_LIST
            
            If Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
              
              SearchInternalStruct(Primary()\Field\ExtensionShort)
              
              Output.s + Comments::Tabulation(1) + "Procedure.b DeleteDatabase" + Primary()\Field\Name + "TableEntry(DatabaseID, TableName.s, *" + Primary()\Field\ExtensionShort + "A." + Primary()\Field\ExtensionShort +")" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, " + Chr(34) + "DELETE FROM " + Chr(34) + " + TableName + " + Chr(34) + " WHERE PrimaryKeyID='" + Chr(34) + " + Str(*" + Primary()\Field\ExtensionShort + "A\PrimaryKeyID) + " + Chr(34) + "'" + Chr(34) + ")" + #LineFeed
              Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
              Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
              Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
              
            EndIf
            
          EndIf
          
        Next
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        Output.s + Comments::Tabulation(1) + "Procedure.b DeleteDatabaseTableEntry(DatabaseID, TableName.s, *InstanceA.Instance)" + #TwinLineFeed
        Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, " + Chr(34) + "DELETE FROM " + Chr(34) + " + TableName + " + Chr(34) + " WHERE PrimaryKeyID='" + Chr(34) + " + Str(*InstanceA\PrimaryKeyID) + " + Chr(34) + "'" + Chr(34) + ")" + #LineFeed
        Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
        Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
        Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure 

  Procedure.s GenerateExtractDatabaseEntry() 
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        
        ForEach Primary()
          
          If Primary()\Field\Style = #FIELD_STYLE_LIST
            
            If Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
              
              SearchInternalStruct(Primary()\Field\ExtensionShort)
              
              Output.s + Comments::Tabulation(1) + "Procedure.b ExtractDatabase" + Primary()\Field\Name + "TableEntry(DatabaseID, *" + Primary()\Field\ExtensionShort + "A." + Primary()\Field\ExtensionShort +")" + #TwinLineFeed

              ForEach General\Struct()\Fields()
                
                If FindString(General\Struct()\Fields(), "$")
                  Name.s = Left(General\Struct()\Fields(), Len(General\Struct()\Fields())-1)
                  Extension.s = "$"
                Else
                  Name.s = StringField(General\Struct()\Fields(), 1, ".")
                  Extension.s = StringField(General\Struct()\Fields(), 2, ".")
                EndIf
                
                  Select Extension
                      
                    Case "b", "a", "c", "u", "w", "l", "q", "i"
                      Output + Comments::Tabulation(2) + "*" + Primary()\Field\ExtensionShort + "A\" + Name + " = GetDatabaseLong(DatabaseID, " + Str(ListIndex(General\Struct()\Fields())) + ")" + #LineFeed
                      
                    Case "f"
                      Output + Comments::Tabulation(2) + "*" + Primary()\Field\ExtensionShort + "A\" + Name + " = GetDatabaseFloat(DatabaseID, " + Str(ListIndex(General\Struct()\Fields())) + ")" + #LineFeed
                      
                    Case "d"
                      Output + Comments::Tabulation(2) + "*" + Primary()\Field\ExtensionShort + "A\" + Name + " = GetDatabaseDouble(DatabaseID, " + Str(ListIndex(General\Struct()\Fields())) + ")" + #LineFeed
                      
                    Case "s"
                      Output + Comments::Tabulation(2) + "*" + Primary()\Field\ExtensionShort + "A\" + Name + " = GetDatabaseString(DatabaseID, " + Str(ListIndex(General\Struct()\Fields())) + ")" + #LineFeed
                      
                    Case "$"
                      Output + Comments::Tabulation(2) + "*" + Primary()\Field\ExtensionShort + "A\" + Name + "$ = GetDatabaseString(DatabaseID, " + Str(ListIndex(General\Struct()\Fields())) + ")" + #LineFeed
                      
                  EndSelect
                  
                  If ListIndex(General\Struct()\Fields()) = ListSize(General\Struct()\Fields()) - 1 
                    Output + #LineFeed
                  EndIf   
                
              Next
              
              Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
              
            EndIf
            
          EndIf
          
        Next
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        
        Output.s + Comments::Tabulation(1) + "Procedure.b ExtractDatabaseTableEntry(DatabaseID, *InstanceA.Instance)" + #TwinLineFeed
        
        ForEach Primary()

          Select Primary()\Field\ExtensionShort
              
            Case "b", "a", "c", "u", "w", "l", "q", "i"
              Output + Comments::Tabulation(2) + "*InstanceA\" + Primary()\Field\Name + " = GetDatabaseLong(DatabaseID, " + Str(ListIndex(Primary())) + ")" + #LineFeed
              
            Case "f"
              Output + Comments::Tabulation(2) + "*InstanceA\" + Primary()\Field\Name + " = GetDatabaseFloat(DatabaseID, " + Str(ListIndex(Primary())) + ")" + #LineFeed
              
            Case "d"
              Output + Comments::Tabulation(2) + "*InstanceA\" + Primary()\Field\Name + " = GetDatabaseDouble(DatabaseID, " + Str(ListIndex(Primary())) + ")" + #LineFeed
              
            Case "s", "$"
              Output + Comments::Tabulation(2) + "*InstanceA\" + Primary()\Field\Name + " = GetDatabaseString(DatabaseID, " + Str(ListIndex(Primary())) + ")" + #LineFeed
              
          EndSelect
          
          If ListIndex(Primary()) = ListSize(Primary()) - 1 
            Output + #LineFeed
          EndIf   
          
        Next
        
        Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure 
 
  Procedure.s GenerateDatabase_To_Tables()
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        
        ForEach Primary()
          
          If Primary()\Field\Style = #FIELD_STYLE_LIST
            
            If Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
              Output.s + Comments::Tabulation(1) + "Procedure Database_To_" + Primary()\Field\Name + "(DatabaseID)" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "If SelectDatabaseTable(DatabaseID, " + Chr(34) + Primary()\Field\Name + Chr(34) + ")" + #TwinLineFeed
              Output + Comments::Tabulation(3) + "ClearList(Instance\" + Primary()\Field\Name + "())" + #LineFeed
              Output + Comments::Tabulation(3) + "FirstDatabaseRow(DatabaseID)" + #TwinLineFeed
              Output + Comments::Tabulation(3) + "Repeat" + #LineFeed
              Output + Comments::Tabulation(4) + "AddElement(Instance\" + Primary()\Field\Name + "())" + #LineFeed
              Output + Comments::Tabulation(4) + "ExtractDatabase" + Primary()\Field\Name + "TableEntry(DatabaseID, Instance\" + Primary()\Field\Name + "())" + #LineFeed
              Output + Comments::Tabulation(3) + "Until NextDatabaseRow(DatabaseID) = 0" + #TwinLineFeed
              Output + Comments::Tabulation(3) + "FinishDatabaseQuery(DatabaseID)" + #LineFeed
              Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
              Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
              
            EndIf
            
          EndIf
          
        Next
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure

  Procedure.s GenerateTables_To_Database()
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        
        ForEach Primary()
          
          If Primary()\Field\Style = #FIELD_STYLE_LIST
            
            If Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
              Output.s + Comments::Tabulation(1) + "Procedure " + Primary()\Field\Name + "_To_Database(DatabaseID)" + #TwinLineFeed
              Output + Comments::Tabulation(2) + "If TruncateDatabaseTable(DatabaseID, " + Chr(34) + Primary()\Field\Name + Chr(34) + ")" + #LineFeed
              Output + Comments::Tabulation(3) + "ForEach Instance\" + Primary()\Field\Name + "()" + #LineFeed
              Output + Comments::Tabulation(4) + "InsertDatabase" + Primary()\Field\Name + "TableEntry(DatabaseID, " + Chr(34) + Primary()\Field\Name + Chr(34)+", Instance\" + Primary()\Field\Name + "())" + #LineFeed
              Output + Comments::Tabulation(3) + "Next" + #LineFeed
              Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
              Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            EndIf
            
          EndIf
          
        Next
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GenerateDatabase_To_TablesCall(Mode.b)
    
    Select Mode
        
      Case 0
        
        Select General\InstanceStyle
            
          Case #INSTANCE_STYLE_UNIQUE
            Output.s = Comments::Tabulation(1) + "Declare Transfer_From_Database(DatabaseID.l)" + #LineFeed
            
          Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
            Output.s = Comments::Tabulation(1) + "Declare Transfer_From_Database(DatabaseID.l, TableName.s)" + #LineFeed
            
        EndSelect 
        
      Case 1
         
        Select General\InstanceStyle
            
          Case #INSTANCE_STYLE_UNIQUE
            
            Output.s = Comments::Tabulation(1) + "Procedure Transfer_From_Database(DatabaseID.l)" + #TwinLineFeed
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_LIST
                
                If Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  Output + Comments::Tabulation(2) + "Database_To_" + Primary()\Field\Name + "(DatabaseID)" + #LineFeed
                EndIf
                
              EndIf
              
            Next
            
            If ListIndex(Primary()) = ListSize(Primary()) - 1 
              Output + #LineFeed
            EndIf  
            
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
          Case #INSTANCE_STYLE_MULTIPLE_ID, #INSTANCE_STYLE_MULTIPLE_INDEX
            Output.s = Comments::Tabulation(1) + "Procedure Transfer_From_Database(DatabaseID.l, TableName.s)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If SelectDatabaseTable(DatabaseID, TableName)" + #TwinLineFeed
            Output + Comments::Tabulation(3) + "ClearList(Instances())" + #LineFeed
            Output + Comments::Tabulation(3) + "FirstDatabaseRow(DatabaseID)" + #TwinLineFeed
            Output + Comments::Tabulation(3) + "Repeat" + #LineFeed
            Output + Comments::Tabulation(4) + "AddElement(Instances())" + #LineFeed
            Output + Comments::Tabulation(4) + "ExtractDatabaseTableEntry(DatabaseID, Instances())" + #LineFeed
            Output + Comments::Tabulation(3) + "Until NextDatabaseRow(DatabaseID) = 0" + #TwinLineFeed 
            Output + Comments::Tabulation(3) + "FinishDatabaseQuery(DatabaseID)" + #LineFeed
            Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
        EndSelect
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s GenerateTables_To_DatabaseCall(Mode.b)
    
    Select Mode
        
      Case 0
        
        Select General\InstanceStyle
            
          Case #INSTANCE_STYLE_UNIQUE
            Output.s = Comments::Tabulation(1) + "Declare Transfer_To_Database(DatabaseID.l)" + #LineFeed
            
          Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
            Output.s = Comments::Tabulation(1) + "Declare Transfer_To_Database(DatabaseID.l, TableName.s)" + #LineFeed
            
        EndSelect
        
      Case 1

        Select General\InstanceStyle
            
          Case #INSTANCE_STYLE_UNIQUE
            
            Output.s = Comments::Tabulation(1) + "Procedure Transfer_To_Database(DatabaseID.l)" + #TwinLineFeed
            
            ForEach Primary()
              
              If Primary()\Field\Style = #FIELD_STYLE_LIST
                
                If Primary()\Field\Type = #FIELD_TYPE_STRUCTURE
                  Output + Comments::Tabulation(2) + Primary()\Field\Name + "_To_Database" + "(DatabaseID)" + #LineFeed
                EndIf
                
              EndIf
              
            Next
            
            If ListIndex(Primary()) = ListSize(Primary()) - 1 
              Output + #LineFeed
            EndIf  
            
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
          Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
            Output.s = Comments::Tabulation(1) + "Procedure Transfer_To_Database(DatabaseID.l, TableName.s)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If TruncateDatabaseTable(DatabaseID, TableName)" + #TwinLineFeed
            Output + Comments::Tabulation(3) + "ForEach Instances()" + #LineFeed
            Output + Comments::Tabulation(4) + "InsertDatabaseTableEntry(DatabaseID, TableName, Instances())" + #LineFeed
            Output + Comments::Tabulation(3) + "Next" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
        EndSelect
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure.s MethodDataBase(P_MethodID.l, P_Mode.b)
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0
            Output.s = Comments::Tabulation(1) + "Declare.b CreateDatabaseTable(DataBaseID.l, TableName.s)" + #LineFeed
            
          Case 1
            Output.s = Comments::Tabulation(1) + "Declare.b DropDatabaseTable(DataBaseID.l, TableName.s)" + #LineFeed
            
          Case 2
            Output.s = Comments::Tabulation(1) + "Declare.b TruncateDatabaseTable(DataBaseID.l, TableName.s)" + #LineFeed
            
          Case 3
            Output.s = Comments::Tabulation(1) + "Declare.b SelectDatabaseTable(DataBaseID.l, TableName.s)" + #LineFeed
            
          Case 4
            Output.s = Comments::Tabulation(1) + "Declare.l CountRowInDatabaseTable(DataBaseID.l, TableName.s, Where.s =" + #EmptyString + ")" + #LineFeed
            
          Case 5
            Output.s = Comments::Tabulation(1) + "Declare.b Open" + General\ModuleName + "Database(DatabaseID.l, FileName.s, User.s, Password.s, Plugin.l)" + #LineFeed
            
          Case 6
            Output = GenerateTables_To_DatabaseCall(0)
            
          Case 7 
            Output = GenerateDatabase_To_TablesCall(0) 
            
          Case 8
            Output.s = Comments::Tabulation(1) + "Declare.b VacuumizeDatabase(DatabaseID.l)" + #LineFeed
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0
            Output.s = GenerateCreateDatabaseTable()
            
          Case 1
            Output.s = Comments::Tabulation(1) + "Procedure.b DropDatabaseTable(DataBaseID.l, TableName.s)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, " + Chr(34) + "DROP TABLE IF EXISTS " + Chr(34) + " + TableName)" + #LineFeed
            Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
          Case 2
            Output.s = Comments::Tabulation(1) + "Procedure.b TruncateDatabaseTable(DataBaseID.l, TableName.s)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, " + Chr(34) + "TRUNCATE TABLE " + Chr(34) + " + TableName)" + #LineFeed
            Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
            Output + Comments::Tabulation(2) + "Else" + #LineFeed
            Output + Comments::Tabulation(3) + "If DatabaseUpdate(DatabaseID, " + Chr(34) + "DELETE FROM " + Chr(34) + " + TableName + " + Chr(34) + " WHERE 1=1"  + Chr(34) + ")" + #LineFeed
            Output + Comments::Tabulation(4) + "Success = #True" + #LineFeed
            Output + Comments::Tabulation(3) + "Else" + #LineFeed
            Output + Comments::Tabulation(4) + "Success = #False" + #LineFeed
            Output + Comments::Tabulation(3) + "EndIf" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
          Case 3
            Output.s = Comments::Tabulation(1) + "Procedure.b SelectDatabaseTable(DataBaseID.l, TableName.s)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If DatabaseQuery(DatabaseID, " + Chr(34) + "SELECT * FROM " + Chr(34) + " + TableName)" + #LineFeed
            Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
          Case 4
            Output.s = Comments::Tabulation(1) + "Procedure.l CountRowInDatabaseTable(DatabaseID.l, TableName.s)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If DatabaseQuery(DatabaseID, " + Chr(34) + "SELECT COUNT(*) FROM " + Chr(34) + " + TableName)" + #LineFeed
            Output + Comments::Tabulation(3) + "NextDatabaseRow(DatabaseID)" + #LineFeed
            Output + Comments::Tabulation(3) + "Protected TableRowCount.l = GetDatabaseLong(DatabaseID, 0)" + #LineFeed
            Output + Comments::Tabulation(3) + "FinishDatabaseQuery(DatabaseID)" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "ProcedureReturn TableRowCount" + #LineFeed
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
          Case 5
            Output.s = Comments::Tabulation(1) + "Procedure.b Open" + General\ModuleName + "Database(DatabaseID.l, FileName.s, User.s, Password.s, Plugin.l)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If FileSize(FileName) = -1" + #TwinLineFeed
            Output + Comments::Tabulation(3) + "Protected FileHandle.i = CreateFile(#PB_Any, FileName)" + #TwinLineFeed
            Output + Comments::Tabulation(3) + "If IsFile(FileHandle)" + #LineFeed
            Output + Comments::Tabulation(4) + "CloseFile(FileHandle)" + #LineFeed
            Output + Comments::Tabulation(3) + "Else" + #LineFeed
            Output + Comments::Tabulation(4) + "ProcedureReturn -1" + #LineFeed
            Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "Protected DatabaseHandle.i = OpenDatabase(DatabaseID, FileName, User, Password, Plugin)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If DatabaseID = #PB_Any" + #LineFeed
            Output + Comments::Tabulation(3) + "DatabaseID = DatabaseHandle" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If IsDatabase(DatabaseID)" + #LineFeed
            Output + GenerateCreateDatabaseTableCall(3)
            Output + Comments::Tabulation(2) + "Else" + #LineFeed
            Output + Comments::Tabulation(3) + "ProcedureReturn -2" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "ProcedureReturn DatabaseID" + #LineFeed
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
          Case 6
            Output = GenerateTables_To_DatabaseCall(1)
            
          Case 7 
            Output = GenerateDatabase_To_TablesCall(1)
            
          Case 8
            Output.s = Comments::Tabulation(1) + "Procedure.b VacuumizeDatabase(DatabaseID.l)" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "If DatabaseUpdate(DatabaseID, " + Chr(34) + "VACUUM" + Chr(34) + ")" + #LineFeed
            Output + Comments::Tabulation(3) + "Protected Success.b = #True" + #LineFeed
            Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "ProcedureReturn Success" + #LineFeed
            Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
            
          Case 9
            Output.s = GenerateCreateDatabaseTable()
            
          Case 10
            Output.s = GenerateInsertDatabaseEntry() 
            
          Case 11
            Output.s = GenerateUpdateDatabaseEntry() 
            
          Case 12
            Output.s = GenerateDeleteDatabaseEntry() 
            
          Case 13
            Output.s = GenerateExtractDatabaseEntry() 
            
          Case 14
            Output.s = GenerateDatabase_To_Tables()
            
          Case 15
            Output.s = GenerateTables_To_Database()
            
        EndSelect
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Debugging support instruction <<<<<
  
  Procedure.s InstructionDebug(*InstanceA.Instance, TabSize.b, P_InstanceCameFrom.b)
    
    If *InstanceA\Field\Type = #FIELD_TYPE_STRING01
      DollarSign.s = "$"
    Else
      DollarSign = ""
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    If General\SecondaryInstance = #True And P_InstanceCameFrom = #CAME_FROM_SECONDARY
      InstanceStyle.s = "Secondary\"
    EndIf
    
    Select *InstanceA\Field\Style
        
      Case #FIELD_STYLE_ARRAY
        
        Instruction.s = AddDynamicArrayOpeningLoop(*InstanceA\Field, @TabSize, P_InstanceCameFrom)
        DynamicArrayIndexList.s = BuiltDynamicArrayIndexList(*InstanceA\Field, 1)
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")" + #LineFeed
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")" + #LineFeed
            
          Case #FIELD_TYPE_STRING01
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "$(" + DynamicArrayIndexList + ")" + #LineFeed
            
          Case #FIELD_TYPE_STRING02
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ") = " + #LineFeed
            
          Case #FIELD_TYPE_MODULE
            ;Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + "))" + #LineFeed
            
          Case #FIELD_TYPE_STRUCTURE
            
            ForEach *InstanceA\SubField()
              
              If *InstanceA\SubField()\Type = #FIELD_TYPE_STRING01
                DollarSign2.s = "$"
              Else
                DollarSign2 = ""
              EndIf
              
              Select *InstanceA\SubField()\Style
                  
                Case #FIELD_STYLE_ARRAY
                  
                  TabSize + 1
                  Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                  DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed

                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                  TabSize - 1
                  
                Case #FIELD_STYLE_LIST
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                       
                Case #FIELD_STYLE_MAP
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                        
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$()" + #EmptyString + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "()" + #EmptyString + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                  
                Case #FIELD_STYLE_BASIC
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + #LineFeed
                      
                  EndSelect
                  
                Case #FIELD_STYLE_BASIC_ARRAY
                  
                  Instruction + Comments::Tabulation(TabSize+1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "(" + DynamicArrayIndexList + ")\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]"  + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "Next" + #Linefeed
                  
              EndSelect
              
            Next
 
        EndSelect
        
        Instruction + AddDynamicArrayClosingLoop(*InstanceA\Field, @TabSize) + #TwinLineFeed

      Case #FIELD_STYLE_LIST
        
        Instruction = Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()" + #LineFeed
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()" + #LineFeed
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()" + #LineFeed
            
          Case #FIELD_TYPE_STRING01
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "$()" + #LineFeed
            
          Case #FIELD_TYPE_STRING02
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()" + #LineFeed
            
          Case #FIELD_TYPE_MODULE
            ;Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
             
          Case #FIELD_TYPE_STRUCTURE
            
            ForEach *InstanceA\SubField()
              
              Select *InstanceA\SubField()\Style
                  
                Case #FIELD_STYLE_ARRAY
                  
                  TabSize + 1
                  Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                  DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                  TabSize = TabSize - 1
                  
                Case #FIELD_STYLE_LIST
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
  
                Case #FIELD_STYLE_MAP
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
                  
                Case #FIELD_STYLE_BASIC
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                  EndSelect
                  
                Case #FIELD_STYLE_BASIC_ARRAY
                  
                  Instruction + Comments::Tabulation(TabSize+1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "Next" + #Linefeed
                  
              EndSelect
              
            Next

        EndSelect
        
        Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed

      Case #FIELD_STYLE_MAP
        
        Instruction = Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + DollarSign + "()" + #LineFeed
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()" + #LineFeed
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()" + #LineFeed
            
          Case #FIELD_TYPE_STRING01
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "$()" + #LineFeed
            
          Case #FIELD_TYPE_STRING02
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()" + #LineFeed
            
          Case #FIELD_TYPE_MODULE
            ;Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "())" + #LineFeed
            
          Case #FIELD_TYPE_STRUCTURE
            
            ForEach *InstanceA\SubField()
              
              Select *InstanceA\SubField()\Style
                  
                Case #FIELD_STYLE_ARRAY
                  
                  TabSize + 1
                  Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                  DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                  TabSize - 1
                  
                Case #FIELD_STYLE_LIST
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
        
                Case #FIELD_STYLE_MAP
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #TwinLineFeed
  
                Case #FIELD_STYLE_BASIC
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + #LineFeed
                      
                  EndSelect
                  
                Case #FIELD_STYLE_BASIC_ARRAY
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "] = "  + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "()\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "] = " + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize + 1) + "Next" + #Linefeed
                  
              EndSelect
              
            Next
            
        EndSelect
        
        Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed

      Case #FIELD_STYLE_BASIC
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Instruction = Comments::Tabulation(TabSize) + "Debug " + InstanceStyle + *InstanceA\Field\Name
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            Instruction = Comments::Tabulation(TabSize) + "Debug " + InstanceStyle + *InstanceA\Field\Name
            
          Case #FIELD_TYPE_STRING01
            Instruction = Comments::Tabulation(TabSize) + "Debug " + InstanceStyle + *InstanceA\Field\Name
            
          Case #FIELD_TYPE_STRING02
            Instruction = Comments::Tabulation(TabSize) + "Debug " + InstanceStyle + *InstanceA\Field\Name
            
          Case #FIELD_TYPE_MODULE
            ;Instruction = Comments::Tabulation(TabSize) + *InstanceA\Field\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + ")" 
                
          Case #FIELD_TYPE_STRUCTURE
            
            Instruction = ""
            
            ForEach *InstanceA\SubField()
              
              Select *InstanceA\SubField()\Style
                  
                Case #FIELD_STYLE_ARRAY
                  
                  Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                  DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed

                Case #FIELD_STYLE_LIST
                  
                  Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed

                Case #FIELD_STYLE_MAP
                  
                  Instruction + Comments::Tabulation(TabSize) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize) + "Next" + #TwinLineFeed
                  
                Case #FIELD_STYLE_BASIC
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name  + #LineFeed
                      
                  EndSelect
                  
                Case #FIELD_STYLE_BASIC_ARRAY
                  
                  Instruction + Comments::Tabulation(TabSize) + #LineFeed + Comments::Tabulation(TabSize) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize) + "Next" + #Linefeed
                  
              EndSelect
              
            Next

        EndSelect
        
      Case #FIELD_STYLE_BASIC_ARRAY
        
        Instruction = Comments::Tabulation(TabSize) + "For " + *InstanceA\Field\ArrayIndexName + " = 0 To " + *InstanceA\Field\ArraySizeLoop + #LineFeed
        
        Select *InstanceA\Field\Type
            
          Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]" + #LineFeed
            
          Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]" + #LineFeed
            
          Case #FIELD_TYPE_STRING01
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "$[" + *InstanceA\Field\ArrayIndexName + "]" + #LineFeed
            
          Case #FIELD_TYPE_STRING02
            Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]" + #LineFeed
            
          Case #FIELD_TYPE_MODULE
            ;Instruction + Comments::Tabulation(TabSize + 1) + *InstanceA\Field\ExternModuleName + "::Reset(" + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "])" + #LineFeed
            
          Case #FIELD_TYPE_STRUCTURE
            
            ForEach *InstanceA\SubField()
              
              Select *InstanceA\SubField()\Style
                  
                Case #FIELD_STYLE_ARRAY
                  
                  TabSize + 1
                  Instruction + AddDynamicArrayOpeningLoop(*InstanceA\SubField(), @TabSize, P_InstanceCameFrom, *InstanceA\Field)
                  DynamicArrayIndexList2.s = BuiltDynamicArrayIndexList(*InstanceA\SubField(), 1)
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "(" + DynamicArrayIndexList2 + ")" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + AddDynamicArrayClosingLoop(*InstanceA\SubField(), @TabSize) + #TwinLineFeed
                  TabSize - 1
                  
                Case #FIELD_STYLE_LIST
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$()"+ #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "()"+ #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "Next" + #TwinLineFeed
            
                Case #FIELD_STYLE_MAP
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "ForEach " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + DollarSign2 + "()" + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name  + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$()" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "()" + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "Next" + #TwinLineFeed
       
                Case #FIELD_STYLE_BASIC
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$"  + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 1) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name  + #LineFeed
                      
                  EndSelect
                  
                Case #FIELD_STYLE_BASIC_ARRAY
                  
                  Instruction + Comments::Tabulation(TabSize+1) + #LineFeed + Comments::Tabulation(TabSize+1) + "For " + *InstanceA\SubField()\ArrayIndexName + " = 0 To " + *InstanceA\SubField()\ArraySizeLoop + #LineFeed
                  
                  Select *InstanceA\SubField()\Type
                      
                    Case #FIELD_TYPE_BYTE To #FIELD_TYPE_QUAD
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_FLOAT, #FIELD_TYPE_DOUBLE
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING01
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "$[" + *InstanceA\SubField()\ArrayIndexName + "]" + #LineFeed
                      
                    Case #FIELD_TYPE_STRING02
                      Instruction + Comments::Tabulation(TabSize + 2) + "Debug " + InstanceStyle + *InstanceA\Field\Name + "[" + *InstanceA\Field\ArrayIndexName + "]\" + *InstanceA\SubField()\Name + "[" + *InstanceA\SubField()\ArrayIndexName + "]"  + #LineFeed
                      
                  EndSelect
                  
                  Instruction + Comments::Tabulation(TabSize+1) + "Next" + #Linefeed
                  
              EndSelect
              
            Next 

        EndSelect
        
        Instruction + Comments::Tabulation(TabSize) + "Next"
        
    EndSelect
    
    ProcedureReturn Instruction
  EndProcedure
 
  Procedure.s MethodDebugging(P_MethodID.l, P_Mode.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE
        InstanceStyle.s = "Instance\"
        
      Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        InstanceStyle.s = "Instances()\"
        
      Case #INSTANCE_STYLE_OFF_MODULE
        InstanceStyle.s = "*" + General\ModuleName + "A\"
        
    EndSelect
    
    Select P_Mode
        
      Case #METHOD_MODE_DECLARE
        
        Select P_MethodID
            
          Case 0
            Output.s = #LineFeed + Comments::Tabulation(1) + "CompilerIf #PB_Compiler_Debugger" + #LineFeed
            Output + Comments::Tabulation(2) + "Declare Debugging()" + #LineFeed
            Output + Comments::Tabulation(1) + "CompilerEndIf" + #LineFeed
            
        EndSelect
        
      Case #METHOD_MODE_PROCEDURE
        
        Select P_MethodID
            
          Case 0
            
            Output.s = Comments::Tabulation(1) + "CompilerIf #PB_Compiler_Debugger" + #TwinLineFeed
            Output + Comments::Tabulation(2) + "Procedure Debugging()" + #LineFeed
            
            Select General\InstanceStyle
                
              Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_OFF_MODULE
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output + Comments::Tabulation(2) + #LineFeed
                  EndIf 
                  
                  Output + InstructionDebug(Primary(), 3, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output + Comments::Tabulation(2) + #LineFeed
                    EndIf
                  EndIf 
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
              Case #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
                Output + #LineFeed 
                Output2.s = ""
                
                ForEach Primary()
                  
                  Select Primary()\Field\Style
                      
                    Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                      SeparatorNeeded = #True
                      
                    Case #FIELD_STYLE_BASIC
                      SeparatorNeeded = #False
                      
                  EndSelect
                  
                  If ListIndex(Primary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                    Output2 + Comments::Tabulation(4) + #LineFeed
                  EndIf 
                  
                  Output2 + InstructionDebug(Primary(), 4, #CAME_FROM_PRIMARY) + #LineFeed
                  
                  If General\SecondaryInstance = #False
                    If ListIndex(Primary()) = ListSize(Primary()) - 1
                      Output2 + Comments::Tabulation(4) + #LineFeed
                    EndIf
                  EndIf 
                  
                  PreviousSeparator = SeparatorNeeded
                  
                Next
                
                Output + Comments::Tabulation(3) + "Foreach Instances()" + #LineFeed
                Output + OutPut2
                Output + Comments::Tabulation(3) + "Next" + #LineFeed
                
            EndSelect
            
            If General\SecondaryInstance = #True
              
              ForEach Secondary()
                
                Select Secondary()\Field\Style
                    
                  Case #FIELD_STYLE_ARRAY To #FIELD_STYLE_MAP, #FIELD_STYLE_BASIC_ARRAY
                    SeparatorNeeded = #True
                    
                  Case #FIELD_STYLE_BASIC
                    SeparatorNeeded = #False
                    
                EndSelect
                
                If ListIndex(Secondary()) = 0 Or SeparatorNeeded = #True Or PreviousSeparator = #True
                  Output + Comments::Tabulation(3) + #LineFeed
                EndIf 
                
                Output + InstructionDebug(Secondary(), 3, #CAME_FROM_SECONDARY) + #LineFeed
                
                If ListIndex(Secondary()) = ListSize(Secondary()) - 1
                  Output + Comments::Tabulation(3) + #LineFeed
                EndIf
                
                PreviousSeparator = SeparatorNeeded
                
              Next
              
            EndIf
            
            Output + Comments::Tabulation(2) + "EndProcedure" + #TwinLineFeed
            Output + Comments::Tabulation(1) + "CompilerEndIf" + #TwinLineFeed
            
        EndSelect
        
    EndSelect
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Procdures publiques <<<<<
 
  Procedure New(P_Target.b, P_FieldID.l, P_Description.s)
    
    If P_Target = 0
      
      If SearchInstances(P_FieldID, 0) = -1
        AddElement(Primary())
      EndIf
      
      Primary()\ID = P_FieldID
      
      StructName.s = FieldFromDescription(Primary()\Field, P_Description)
      
      If StructName <> ""
        
        If SearchInternalStruct(StructName) <> -1
          
          ForEach General\Struct()\Fields()
            AddElement(Primary()\SubField())
            Primary()\SubField()\IsSubField = #True
            FieldFromDescription(Primary()\SubField(), General\Struct()\Fields())
          Next
          
        EndIf
        
      EndIf
      
    ElseIf P_Target = 1
      
      If SearchInstances(P_FieldID, 1) = -1
        AddElement(Secondary())
      EndIf
      
      Secondary()\ID = P_FieldID
      
      StructName.s = FieldFromDescription(Secondary()\Field, P_Description)
      
      If StructName <> ""
        
        If SearchInternalStruct(StructName) <> -1
          
          ForEach General\Struct()\Fields()
            AddElement(Secondary()\SubField())
            Secondary()\SubField()\IsSubField = #True
            FieldFromDescription(Secondary()\SubField(), General\Struct()\Fields())
          Next
          
        EndIf
        
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure GenerateParamList()
    
    If General\UpdateInitParam = ""
      
      ForEach Primary()
        
        If Primary()\Field\Style = #FIELD_STYLE_BASIC
          
          If Primary()\Field\Name <> "ID"
            
            If Primary()\Field\Type = #FIELD_TYPE_STRING01
              Buffer.s + "P_" + Primary()\Field\Name + Primary()\Field\ExtensionShort
            ElseIf Primary()\Field\Type = #FIELD_TYPE_MODULE
              Buffer + "*P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort
            Else
              Buffer + "P_" + Primary()\Field\Name + "." + Primary()\Field\ExtensionShort
            EndIf 
            
            If ListIndex(Primary()) < ListSize(Primary()) - 1 
              Buffer + ", "
            EndIf
            
          EndIf
          
        EndIf 
        
      Next
      
      If Right(Buffer, 2) = ", "
        Buffer = Left(Buffer, Len(Buffer) - 2)
      EndIf
      
      General\UpdateInitParam = Buffer
      
    EndIf
    
  EndProcedure
  
  Procedure UpdateGeneral(P_ModuleName.s, P_InstanceID.s, P_InstanceStyle.b, P_SecondaryInstance.b)
    
    General\ModuleName = P_ModuleName
    General\InstanceID = P_InstanceID
    General\InstanceStyle = P_InstanceStyle
    General\SecondaryInstance = P_SecondaryInstance
    
    If Left(General\ModuleName, Len(General\ModuleName)-2) = "Matrix"
      
      General\IsMatrix = #True
      
      Size.s = Right(General\ModuleName, 2)
      
      General\MatrixSizeI = Val(Mid(Size, 1, 1))
      General\MatrixSizeJ = Val(Mid(Size, 2, 1))
      
      If General\MatrixSizeI = General\MatrixSizeJ
        General\IsSquareMatrix = #True
      Else
        General\IsSquareMatrix = #False
      EndIf
      
    EndIf
    
    GenerateParamList()
    
  EndProcedure
 
  Procedure.l CountStructure()
    
    StructureCount.l = 1 + ListSize(General\Struct())
    
    If ListSize(Secondary()) <> 0
      StructureCount + 1
    EndIf
    
    ProcedureReturn StructureCount
  EndProcedure
  
  Procedure.s GenerateStructures(CallFrom.b)
    
    If CallFrom = 1
      
      If ListSize(General\Struct()) <> 0
        Output.s + GenerateInternalStruct(1)
      EndIf
      
      If ListSize(Secondary()) <> 0
        
        Output + Comments::Tabulation(1) + "Structure Secondary" + #TwinLineFeed
        
        ForEach Secondary()
          
          If Secondary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY
            Output + Comments::Tabulation(2) + Secondary()\Field\Name + Secondary()\Field\ExtensionLong + "[" + Secondary()\Field\ArraySizeCte + "]" + #LineFeed
          Else  
            Output + Comments::Tabulation(2) + Secondary()\Field\Description + #LineFeed
          EndIf
          
        Next
        
        Output + #LineFeed + Comments::Tabulation(1) + "EndStructure" + #TwinLineFeed
        
        SecondaryFlag.b = #True
        
      EndIf
      
    EndIf
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_UNIQUE, #INSTANCE_STYLE_MULTIPLE_ID To #INSTANCE_STYLE_MULTIPLE_NAME
        Output + Comments::Tabulation(1) + "Structure Instance" + #TwinLineFeed
        
        ForEach Primary()
          If Primary()\Field\Style = #FIELD_STYLE_BASIC_ARRAY
            Output + Comments::Tabulation(2) + Primary()\Field\Name + Primary()\Field\ExtensionLong + "[" + Primary()\Field\ArraySizeCte + "]" + #LineFeed
          Else  
            Output + Comments::Tabulation(2) + Primary()\Field\Description + #LineFeed
          EndIf
        Next
        
        Output + #LineFeed + Comments::Tabulation(1) + "EndStructure" + #TwinLineFeed
        
        If SecondaryFlag.b = #True
          Output + Comments::Tabulation(1) + "Global Secondary.Secondary" + #LineFeed
        EndIf
        
        If General\InstanceStyle = #INSTANCE_STYLE_MULTIPLE_ID
          Output + Comments::Tabulation(1) + "Global NewList Instances.Instance()"
        ElseIf General\InstanceStyle = #INSTANCE_STYLE_MULTIPLE_INDEX
          Output + Comments::Tabulation(1) + "Global NewList Instances.Instance()"
        ElseIf General\InstanceStyle = #INSTANCE_STYLE_MULTIPLE_NAME
          Output + Comments::Tabulation(1) + "Global NewMap Instances.Instance()"
        Else
          Output + Comments::Tabulation(1) + "Global Instance.Instance"
        EndIf
        
      Case #INSTANCE_STYLE_OFF_MODULE
        Output.s = Comments::Tabulation(1) + "Structure " + General\ModuleName + #TwinLineFeed
        
        ForEach Primary()
          Output + Comments::Tabulation(2) + Primary()\Field\Description + #LineFeed
        Next
        
        Output + #LineFeed + Comments::Tabulation(1) + "EndStructure"
        
    EndSelect
    
    ProcedureReturn Output + #TwinLineFeed
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Generate Multiple Instance Helper <<<<<
  
  Procedure.s GenerateMultipleInstanceHelper(P_Mode.b)
    
    Select General\InstanceStyle
        
      Case #INSTANCE_STYLE_MULTIPLE_ID
        
        If P_Mode = #METHOD_MODE_DECLARE
          
          Output.s = Comments::Tabulation(1) + "Declare AddInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare SelectInstance(P_Index.l)" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare FirstInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare LastInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare PreviousInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare NextInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare DeleteInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ResetInstances()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ClearInstances()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare InstanceIndex()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare InstanceCount()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare.l SearchInstances(P_InstanceID.l)" + #LineFeed
          
          ForEach Primary()
            
            If Primary()\Field\Style = #FIELD_STYLE_BASIC
              If Primary()\Field\Name <> "ID"
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output + Comments::Tabulation(1) + "Declare.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
                ElseIf Primary()\Field\Type <= #FIELD_TYPE_DOUBLE
                  Output + Comments::Tabulation(1) + "Declare.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #LineFeed
                EndIf                
              EndIf
            EndIf
            
          Next 
          
        Else
          
          Output + Comments::Tabulation(1) + "Procedure AddInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "AddElement(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure SelectInstance(P_Index.l)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn SelectElement(Instances(), P_Index)" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure FirstInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn FirstElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure LastInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn LastElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure PreviousInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn PreviousElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure NextInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn NextElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure DeleteInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "DeleteElement(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed                    
          
          Output + Comments::Tabulation(1) + "Procedure ResetInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ResetList(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed        
          
          Output + Comments::Tabulation(1) + "Procedure ClearInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ClearList(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed        
          
          Output + Comments::Tabulation(1) + "Procedure InstanceIndex()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn ListIndex(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure InstanceCount()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn ListSize(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed

          Output + Comments::Tabulation(1) + "Procedure.l SearchInstances(P_InstanceID.l)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ForEach Instances()" + #TwinLineFeed
          Output + Comments::Tabulation(3) + "If Instances()\ID = P_InstanceID" + #LineFeed
          Output + Comments::Tabulation(4) + "IsFoundAtIndex = ListIndex(Instances())" + #LineFeed
          Output + Comments::Tabulation(4) + "Break" + #LineFeed
          Output + Comments::Tabulation(3) + "EndIf" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "Next" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex"+ #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          ForEach Primary()
            
            If Primary()\Field\Style = #FIELD_STYLE_BASIC And Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
              
              If Primary()\Field\Name <> "ID"
               
                If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                  Output + Comments::Tabulation(1) + "Procedure.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                  Flag = 1
                Else
                  Output + Comments::Tabulation(1) + "Procedure.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed 
                  Flag = 0
                EndIf       
                
                Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #TwinLineFeed
                
                If Primary()\Field\Type = #FIELD_TYPE_STRING01
                  ArraySizeLoop.s = "ForEach Instances()"
                  IndexName.s = "ListIndex(Instances())"
                  Test01.s = "UCase(Instances()\" + Primary()\Field\Name + "$) = UCase(P_" + Primary()\Field\Name + "$)"
                  Test02.s = "Instances()\" + Primary()\Field\Name + "$ = P_" + Primary()\Field\Name + "$"
                Else
                  ArraySizeLoop.s = "ForEach Instances()"
                  IndexName.s = "ListIndex(Instances())"
                  Test01.s = "UCase(Instances()\" + Primary()\Field\Name + ") = UCase(P_" + Primary()\Field\Name + ")"
                  Test02.s = "Instances()\" + Primary()\Field\Name + " = P_" + Primary()\Field\Name
                EndIf
                
                If Flag = 1
                  Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + #TwinLineFeed
                  Output + InsertLinearSearch(3, ArraySizeLoop, Test01, IndexName) + #LineFeed
                  Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                  Output + InsertLinearSearch(3, ArraySizeLoop, Test02, IndexName) + #LineFeed
                  Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
                Else 
                  Output + InsertLinearSearch(2, ArraySizeLoop, Test02, IndexName) + #LineFeed
                EndIf
                
                Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex"+ #LineFeed
                Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
                
              EndIf
              
            EndIf
            
          Next
          
        EndIf
        
      Case #INSTANCE_STYLE_MULTIPLE_INDEX
        
        If P_Mode = #METHOD_MODE_DECLARE
          
          Output.s = Comments::Tabulation(1) + "Declare AddInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare SelectInstance(P_Index.l)" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare FirstInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare LastInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare PreviousInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare NextInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare DeleteInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ResetInstances()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ClearInstances()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare InstanceIndex()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare InstanceCount()" + #LineFeed
          
          ForEach Primary()
            
            If Primary()\Field\Style = #FIELD_STYLE_BASIC And Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
              If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                Output + Comments::Tabulation(1) + "Declare.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #LineFeed
              Else
                Output + Comments::Tabulation(1) + "Declare.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #LineFeed 
              EndIf
            EndIf
            
          Next

        Else
          
          Output + Comments::Tabulation(1) + "Procedure AddInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "AddElement(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure SelectInstance(P_Index.l)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn SelectElement(Instances(), P_Index)" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure FirstInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn FirstElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure LastInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn LastElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure PreviousInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn PreviousElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure NextInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn NextElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure DeleteInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "DeleteElement(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed                    
          
          Output + Comments::Tabulation(1) + "Procedure ResetInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ResetList(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed        
          
          Output + Comments::Tabulation(1) + "Procedure ClearInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ClearList(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed        
          
          Output + Comments::Tabulation(1) + "Procedure InstanceIndex()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn ListIndex(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure InstanceCount()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn ListSize(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          ForEach Primary()
            
            If Primary()\Field\Style = #FIELD_STYLE_BASIC And Primary()\Field\Type < #FIELD_TYPE_STRUCTURE
              
              If Primary()\Field\Type = #FIELD_TYPE_STRING01 Or Primary()\Field\Type = #FIELD_TYPE_STRING02
                Output + Comments::Tabulation(1) + "Procedure.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ", P_CaseSensitive.b = #True)" + #TwinLineFeed
                Flag = 1
              Else
                Output + Comments::Tabulation(1) + "Procedure.l SearchInstancesBy" + Primary()\Field\Name + "(P_" + Primary()\Field\Name + Primary()\Field\ExtensionLong + ")" + #TwinLineFeed 
                Flag = 0
              EndIf       
              
              Output + Comments::Tabulation(2) + "Protected IsFoundAtIndex.l = -1" + #TwinLineFeed
              
              If Primary()\Field\Type = #FIELD_TYPE_STRING01
                ArraySizeLoop.s = "ForEach Instances()"
                IndexName.s = "ListIndex(Instances())"
                Test01.s = "UCase(Instances()\" + Primary()\Field\Name + "$) = UCase(P_" + Primary()\Field\Name + "$)"
                Test02.s = "Instances()\" + Primary()\Field\Name + "$ = P_" + Primary()\Field\Name + "$"
              Else
                ArraySizeLoop.s = "ForEach Instances()"
                IndexName.s = "ListIndex(Instances())"
                Test01.s = "UCase(Instances()\" + Primary()\Field\Name + ") = UCase(P_" + Primary()\Field\Name + ")"
                Test02.s = "Instances()\" + Primary()\Field\Name + " = P_" + Primary()\Field\Name
              EndIf
              
              If Flag = 1
                Output + Comments::Tabulation(2) + "If P_CaseSensitive = #False" + #TwinLineFeed
                Output + InsertLinearSearch(3, ArraySizeLoop, Test01, IndexName) + #LineFeed
                Output + Comments::Tabulation(2) + "Else" + #TwinLineFeed
                Output + InsertLinearSearch(3, ArraySizeLoop, Test02, IndexName) + #LineFeed
                Output + Comments::Tabulation(2) + "EndIf" + #TwinLineFeed
              Else 
                Output + InsertLinearSearch(2, ArraySizeLoop, Test02, IndexName) + #LineFeed
              EndIf
              
              Output + Comments::Tabulation(2) + "ProcedureReturn IsFoundAtIndex"+ #LineFeed
              Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
              
            EndIf
            
          Next

        EndIf
        
      Case #INSTANCE_STYLE_MULTIPLE_NAME
        
        If P_Mode = #METHOD_MODE_DECLARE
          
          Output = Comments::Tabulation(1) + "Declare AddInstance(P_Key.s)" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare FindInstance(P_Key.s)" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare NextInstance()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare DeleteInstance(P_Key.s)" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ResetInstances()" + #LineFeed
          Output + Comments::Tabulation(1) + "Declare ClearInstances()" + #LineFeed
          
        Else
          
          Output + Comments::Tabulation(1) + "Procedure AddInstance(P_Key.s)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "AddMapElement(Instances(), P_Key)" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure FindInstance(P_Key.s)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn FindMapElement(Instance(), P_Key)"+ #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure NextInstance()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ProcedureReturn NextMapElement(Instances())" + #LineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed
          
          Output + Comments::Tabulation(1) + "Procedure DeleteInstance(P_Key.s)" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "DeleteMapElement(Instances(), P_Key)" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed     
          
          Output + Comments::Tabulation(1) + "Procedure ResetInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ResetMap(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed        

          Output + Comments::Tabulation(1) + "Procedure ClearInstances()" + #TwinLineFeed
          Output + Comments::Tabulation(2) + "ClearMap(Instances())" + #TwinLineFeed
          Output + Comments::Tabulation(1) + "EndProcedure" + #TwinLineFeed       
          
        EndIf
        
    EndSelect 
    
    ProcedureReturn Output
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Utilitaires <<<<<
  
  Procedure.b IsSquareMatrix()
    
    ProcedureReturn General\IsSquareMatrix
  EndProcedure
  
  Procedure.b IsMatrix()
    
    ProcedureReturn General\IsMatrix
  EndProcedure
  
  Procedure.b IsStaticArray()
    
    ProcedureReturn General\StaticArraySort
  EndProcedure
 
  Procedure.b IsDatabaseHelperNeeded(Flag.b = -1)
    
    If Flag >= 0
      General\IsDatabaseHelperNeeded = Flag
    Else
      ProcedureReturn General\IsDatabaseHelperNeeded
    EndIf
    
  EndProcedure

  Procedure.l CountInstances(Flag.b = 0)
    
    If Flag = 0
      Count.l = ListSize(Primary())
    Else
      Count.l = ListSize(Secondary())
    EndIf
    
    ProcedureReturn Count
  EndProcedure
  
  Procedure GetSpecialMethods()
    
    ProcedureReturn General\SpecialMethods
  EndProcedure
  
  Procedure GadgetLinking(GadgetID, Flag)
    
    Select Flag
        
      Case 0
        General\EncodedModuleGadget = GadgetID
        
      Case 1
        General\CryptedModuleGadget = GadgetID
        
      Case 2
        General\InternalStructListViewGadget = GadgetID 
        
      Case 3
        General\InternalStructEditorGadget = GadgetID
        
    EndSelect
    
  EndProcedure
  
  Procedure FileModuleScanning(*FileModuleA.FileModule)
    
    FileID = ReadFile(#PB_Any, *FileModuleA\FileName)
    
    If IsFile(FileID)
      
      Exit_Condition = #False
      
      While Exit_Condition = #False
        
        Line.s = Trim(ReadString(FileID))
        
        If Line <> ""
          
          If *FileModuleA\Name = ""
            If FindString(Line, "DeclareModule")
              *FileModuleA\DisplayName = ReplaceString(RemoveString(Line, "DeclareModule "), ";", " - ")
              *FileModuleA\Name = Trim(StringField(*FileModuleA\DisplayName, 1, "-"))
            EndIf
          EndIf
          
          If *FileModuleA\Prefix = ""
            If FindString(Line, "Write")
              *FileModuleA\Prefix = Trim(StringBetween::FindIt(Line, "Declare", "Write"))
            EndIf
          EndIf
          
          If FindString(Line, "EndDeclareModule")
            Exit_Condition = #True
          EndIf
          
        EndIf
        
      Wend
      
      CloseFile(FileID)
      
    EndIf
    
  EndProcedure
  
  Procedure FileModule_To_GUI()
    
    ClearGadgetItems(General\EncodedModuleGadget)
    ClearGadgetItems(General\CryptedModuleGadget)
    
    ForEach General\EncodedModule()
      FileModuleScanning(General\EncodedModule())
    Next
    
    ForEach General\CryptedModule()
      FileModuleScanning(General\CryptedModule())
    Next  
    
    SortStructuredList(General\EncodedModule(), #PB_Sort_Ascending, OffsetOf(FileModule\Name), #PB_String)
    SortStructuredList(General\CryptedModule(), #PB_Sort_Ascending, OffsetOf(FileModule\Name), #PB_String)
    
    ForEach General\EncodedModule()
      AddGadgetItem(General\EncodedModuleGadget, ListIndex(General\EncodedModule()), General\EncodedModule()\DisplayName)
    Next
    
    ForEach General\CryptedModule()
      AddGadgetItem(General\CryptedModuleGadget, ListIndex(General\CryptedModule()), General\CryptedModule()\DisplayName)
    Next  
    
    SetGadgetState(General\EncodedModuleGadget, 0)
    SetGadgetState(General\CryptedModuleGadget, 0)
    SelectElement(General\EncodedModule(), 0)
    SelectElement(General\CryptedModule(), 0)
    
  EndProcedure
  
  Procedure To_GUI(Mode.b = 0)
    
    If Mode = 0
      
      If ListIndex(General\EncodedModule()) <> -1
        SetGadgetState(General\EncodedModuleGadget, ListIndex(General\EncodedModule()))
      EndIf
      
      If ListIndex(General\CryptedModule()) <> -1
        SetGadgetState(General\CryptedModuleGadget, ListIndex(General\CryptedModule()))
      EndIf
      
      ForEach General\Struct()
        AddGadgetItem(General\InternalStructListViewGadget, -1, General\Struct()\Name)
      Next
      
    ElseIf Mode = 1
      
      ClearGadgetItems(General\InternalStructEditorGadget)
      
      ForEach General\Struct()\Fields()
        AddGadgetItem(General\InternalStructEditorGadget, -1, General\Struct()\Fields())
      Next
      
    EndIf
    
  EndProcedure
  
  Procedure From_GUI(Mode.b = 0)
    
    If Mode = 0
      
      If CountGadgetItems(General\EncodedModuleGadget) > 0
        SelectElement(General\EncodedModule(), GetGadgetState(General\EncodedModuleGadget))
      EndIf
      
      If CountGadgetItems(General\CryptedModuleGadget) > 0
        SelectElement(General\CryptedModule(), GetGadgetState(General\CryptedModuleGadget))
      EndIf
      
    ElseIf Mode = 1
      
      ForEach General\Struct()\Fields()
        General\Struct()\Fields() = ""
      Next
      
      ClearList(General\Struct()\Fields())
      
      FieldMax = CountGadgetItems(General\InternalStructEditorGadget) - 1
      
      For FieldID = 0 To FieldMax 
        AddElement(General\Struct()\Fields())
        General\Struct()\Fields() = GetGadgetItemText(General\InternalStructEditorGadget, FieldID)
      Next
      
    EndIf
    
  EndProcedure
  
  Procedure.l SearchEncodedModuleName(P_Name.s)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach General\EncodedModule()
      
      If General\EncodedModule()\Name = P_Name
        IsFoundAtIndex = ListIndex(General\EncodedModule())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure.l SearchCryptedModuleName(P_Name.s)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach General\CryptedModule()
      
      If General\CryptedModule()\Name = P_Name
        IsFoundAtIndex = ListIndex(General\CryptedModule())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure AddFileModule(Flag.b)
    
    FileName.s = OpenFileRequester(Language::Message("Read/Write external module"), GetHomeDirectory(), Language::Message("PureBasic SourceCode (*.pb)|*.pb"), 1, #PB_Requester_MultiSelection)
    
    If FileName <> ""
      
      While FileName
        
        Select Flag
            
          Case 0
            AddElement(General\EncodedModule())
            General\EncodedModule()\FileName = FileName
            
          Case 1
            AddElement(General\CryptedModule())
            General\CryptedModule()\FileName = FileName
            
        EndSelect 
        
        FileName = NextSelectedFileName()
        
      Wend
      
      FileModule_To_GUI()
      
    EndIf
    
  EndProcedure
  
  Procedure RemoveFileModule(Flag.b)
    
    Select Flag
        
      Case 0
        
        Message.s = ReplaceString(Language::Message("You are about to remove the %MODULE_NAME% module. Are you sure ?"), "%MODULE_NAME%", GetGadgetText(General\EncodedModuleGadget))
        
        If MessageRequester(Language::Message("Dev-Module - Warning"), Message, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
          SelectElement(General\EncodedModule(), GetGadgetState(General\EncodedModuleGadget))
          DeleteElement(General\EncodedModule())
          FileModule_To_GUI()
        EndIf
        
      Case 1
        
        Message.s = ReplaceString(Language::Message("You are about to remove the %MODULE_NAME% module. Are you sure ?"), "%MODULE_NAME%", GetGadgetText(General\CryptedModuleGadget))
        
        If MessageRequester(Language::Message("Dev-Module - Warning"), Message, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
          SelectElement(General\CryptedModule(), GetGadgetState(General\CryptedModuleGadget))
          DeleteElement(General\CryptedModule())
          FileModule_To_GUI()
        EndIf
        
    EndSelect 
    
  EndProcedure
  
  Procedure.s CurrentFileModuleName(Flag.b, Input.s = "")
    
    If Input = ""
      
      Select Flag
          
        Case 0
          Output.s = General\EncodedModule()\Name
          
        Case 1
          Output = General\CryptedModule()\Name
          
      EndSelect
      
    Else
      
      Select Flag
          
        Case 0
          
          If SearchEncodedModuleName(Input) = -1
            FirstElement(General\EncodedModule())
          EndIf
          
        Case 1
          
          If SearchCryptedModuleName(Input) = -1
            FirstElement(General\CryptedModule())
          EndIf
          
      EndSelect
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure
  
  Procedure SaveProjectFileInternalStructure()
    
    PreferenceGroup("InternalStructure")
    
    WritePreferenceLong("StructMax", ListSize(General\Struct()))
    
    ForEach General\Struct()
      
      WritePreferenceString("StructName_" + Str(ListIndex(General\Struct())), General\Struct()\Name)
      WritePreferenceLong("StructFieldMax_" + Str(ListIndex(General\Struct())), ListSize(General\Struct()\Fields()))
      
      ForEach General\Struct()\Fields()
        WritePreferenceString("StructField_" + Str(ListIndex(General\Struct())) + "_" + Str(ListIndex(General\Struct()\Fields())), General\Struct()\Fields())
      Next
      
    Next
    
  EndProcedure
  
  Procedure LoadProjectFileInternalStructure()
    
    PreferenceGroup("InternalStructure")
    
    StructMax = ReadPreferenceLong("StructMax", 0) - 1
    
    For StructID = 0 To StructMax
      
      AddInternalStruct(ReadPreferenceString("StructName_" + Str(StructID), ""))
      StructFieldMax.l = ReadPreferenceLong("StructFieldMax_" + Str(StructID), 0) - 1
      
      For FieldID = 0 To StructFieldMax
        AddInternalStructField(General\Struct()\Name, ReadPreferenceString("StructField_" + Str(StructID) + "_" + Str(FieldID), ""))
      Next
      
    Next
    
  EndProcedure
  
  Procedure ReadPrefs(P_GroupName.s)
    
    PreferenceGroup(P_GroupName)
    
    EncodedModule_Max.l = ReadPreferenceLong("EncodedModule_Max", 0) - 1
    
    For EncodedModuleID = 0 To EncodedModule_Max
      AddElement(General\EncodedModule())
      General\EncodedModule()\FileName = ReadPreferenceString("EncodedModuleFileName_" + Str(EncodedModuleID), General\EncodedModule()\FileName)
    Next
    
    CryptedModule_Max.l = ReadPreferenceLong("CryptedModule_Max", 0) - 1
    
    For CryptedModuleID = 0 To CryptedModule_Max
      AddElement(General\CryptedModule())
      General\CryptedModule()\FileName = ReadPreferenceString("CryptedModuleFileName_" + Str(CryptedModuleID), General\CryptedModule()\FileName)
    Next
    
    FirstElement(General\EncodedModule())    
    FirstElement(General\CryptedModule())
    
  EndProcedure
  
  Procedure WritePrefs(P_GroupName.s)
    
    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("EncodedModule_Max", ListSize(General\EncodedModule()))
    
    ForEach General\EncodedModule()
      WritePreferenceString("EncodedModuleFileName_" + Str(ListIndex(General\EncodedModule())), General\EncodedModule()\FileName)
    Next
    
    WritePreferenceLong("CryptedModule_Max", ListSize(General\CryptedModule()))
    
    ForEach General\CryptedModule()
      WritePreferenceString("CryptedModuleFileName_" + Str(ListIndex(General\CryptedModule())), General\CryptedModule()\FileName)
    Next
    
  EndProcedure
  
  Procedure Reset(Style.b)
    
    Select Style
        
      Case #RESET_STYLE_TERMINAL
        
        ForEach Primary()
          
          Primary()\ID = 0
          ClearStructure(@Primary()\Field, Field)
          
          ForEach Primary()\SubField()
            ClearStructure(@Primary()\SubField(), Field)
          Next
          
          FreeList(Primary()\SubField())
          
        Next
        
        FreeList(Primary())
        
        ForEach Secondary()
          
          Secondary()\ID = 0
          ClearStructure(@Secondary()\Field, Field)
          
          ForEach Secondary()\SubField()
            ClearStructure(@Secondary()\SubField(), Field)
          Next
          
          FreeList(Secondary()\SubField())
          
        Next
        
        FreeList(Secondary())
        
        General\UpdateInitParam = ""
        General\ModuleName = ""
        General\InstanceID = ""
        General\SpecialMethods = 0 
        General\GenerateEnumConstants = 0
        General\SizeConstants = 0
        General\StaticArraySort = 0 
        General\StaticArray = 0
        General\StaticArrayFieldName = 0
        General\InstanceStyle = 0
        General\IsMatrix = 0
        General\IsSquareMatrix = 0
        General\MatrixSizeI = 0
        General\MatrixSizeJ = 0
        
        ForEach General\EncodedModule()
          General\EncodedModule()\Name = ""
          General\EncodedModule()\DisplayName = ""
          General\EncodedModule()\FileName = ""
          General\EncodedModule()\Prefix = ""
        Next
        
        FreeList(General\EncodedModule())
        
        ForEach General\CryptedModule()
          General\CryptedModule()\Name = ""
          General\CryptedModule()\DisplayName = ""
          General\CryptedModule()\FileName = ""
          General\CryptedModule()\Prefix = ""
        Next
        
        ForEach General\Struct()
          
          General\Struct()\Name = ""
          
          ForEach General\Struct()\Fields()
            General\Struct()\Fields() = ""
          Next
          
          FreeList(General\Struct()\Fields())
          
        Next    	  
        
        FreeList(General\Struct())
        
      Case #RESET_STYLE_NEW_MODULE
        
        ForEach Primary()
          
          Primary()\ID = 0
          ClearStructure(@Primary()\Field, Field)
          
          ForEach Primary()\SubField()
            ClearStructure(@Primary()\SubField(), Field)
          Next
          
          ClearList(Primary()\SubField())
          
        Next
        
        ClearList(Primary())
        
        
        ForEach Secondary()
          
          Secondary()\ID = 0
          ClearStructure(@Secondary()\Field, Field)
          
          ForEach Secondary()\SubField()
            ClearStructure(@Secondary()\SubField(), Field)
          Next
          
          ClearList(Secondary()\SubField())
          
        Next
        
        ClearList(Secondary())
        
        General\UpdateInitParam = ""
        General\ModuleName = ""
        General\InstanceID = ""
        General\SpecialMethods = 0 
        General\GenerateEnumConstants = 0
        General\SizeConstants = 0
        General\StaticArraySort = 0 
        General\StaticArray = 0
        General\StaticArrayFieldName = 0
        General\InstanceStyle = 0
        General\IsMatrix = 0
        General\IsSquareMatrix = 0
        General\MatrixSizeI = 0
        General\MatrixSizeJ = 0
        
        ForEach General\Struct()
          
          General\Struct()\Name = ""
          
          ForEach General\Struct()\Fields()
            General\Struct()\Fields() = ""
          Next
          
          ClearList(General\Struct()\Fields())
          
        Next    	  
        
        ClearList(General\Struct())
       
      Case #RESET_STYLE_AFTER_RUN
        
        ForEach Primary()
          
          Primary()\ID = 0
          ClearStructure(@Primary()\Field, Field)
          
          ForEach Primary()\SubField()
            ClearStructure(@Primary()\SubField(), Field)
          Next
          
          ClearList(Primary()\SubField())
          
        Next
        
        ClearList(Primary())
        
        ForEach Secondary()
          
          Secondary()\ID = 0
          ClearStructure(@Secondary()\Field, Field)
          
          ForEach Secondary()\SubField()
            ClearStructure(@Secondary()\SubField(), Field)
          Next
          
          ClearList(Secondary()\SubField())
          
        Next
        
        ClearList(Secondary())
        
        General\UpdateInitParam = ""
        General\ModuleName = ""
        General\InstanceID = ""
        General\SpecialMethods = 0 
        General\GenerateEnumConstants = 0
        General\SizeConstants = 0
        General\StaticArraySort = 0 
        General\StaticArray = 0
        General\StaticArrayFieldName = 0
        General\InstanceStyle = 0
        General\IsMatrix = 0
        General\IsSquareMatrix = 0
        General\MatrixSizeI = 0
        General\MatrixSizeJ = 0
        
      Case #RESET_STYLE_FLUSH_INTERNAL_STRUCTURE
        
        ForEach General\Struct()
          
          General\Struct()\Name = ""
          
          ForEach General\Struct()\Fields()
            General\Struct()\Fields() = ""
          Next
          
          ClearList(General\Struct()\Fields())
          
        Next    	  
        
        ClearList(General\Struct())
        
    EndSelect
    
  EndProcedure
 
EndModule  

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = 45AAAAAAAAAAAAAg-
; EnableXP
; DisableDebugger
; CompileSourceDirectory
; EnableUnicode